// Generated by CoffeeScript 2.4.1
(function() {
  var $, AGGREGATES, AND, NYIE, PVE, PromiseProps, RE, _, _dataToRes, _defFor, _defForSibling, _extractAggregates, _extractArgList, _extractGroupBy, _extractRelWhere, _extractSortBy, _extractWhere, _extractWriteFields, _readChildRes, _writeChildRes, changeM, clone, concat, contains, curry, difference, empty, emptyIfNil, equals, expandNode, expandQuery, expandWrite, fieldsClauseAndChildren, filter, func, groupBy, has, head, isAggregate, isEmpty, isNil, keys, length, map, mapO, match, merge, mergeToNorm, normalize, nth, pick, pluck, prop, qq, qqq, replace, resolveFields, returnResult, runDelta, runFatQuery, runFatQuerySync, runNode, runNodeSync, runQuery, sf0, sf2, sortBy, test, tryResolveFields, type, union, uniq, update, utils, validateANDOR, values, where, without, ːAVG, ːCOUNT, ːMAX, ːMIN, ːObject, ːSUM, ːUndefined, ːid;

  clone = require('ramda/src/clone');

  concat = require('ramda/src/concat');

  contains = require('ramda/src/contains');

  curry = require('ramda/src/curry');

  difference = require('ramda/src/difference');

  empty = require('ramda/src/empty');

  equals = require('ramda/src/equals');

  filter = require('ramda/src/filter');

  groupBy = require('ramda/src/groupBy');

  has = require('ramda/src/has');

  head = require('ramda/src/head');

  isEmpty = require('ramda/src/isEmpty');

  isNil = require('ramda/src/isNil');

  keys = require('ramda/src/keys');

  length = require('ramda/src/length');

  map = require('ramda/src/map');

  match = require('ramda/src/match');

  merge = require('ramda/src/merge');

  nth = require('ramda/src/nth');

  pick = require('ramda/src/pick');

  pluck = require('ramda/src/pluck');

  prop = require('ramda/src/prop');

  replace = require('ramda/src/replace');

  sortBy = require('ramda/src/sortBy');

  test = require('ramda/src/test');

  type = require('ramda/src/type');

  union = require('ramda/src/union');

  uniq = require('ramda/src/uniq');

  update = require('ramda/src/update');

  values = require('ramda/src/values');

  where = require('ramda/src/where');

  without = require('ramda/src/without');

  ({changeM, mapO, func, $, PromiseProps, sf0, sf2} = RE = require('ramda-extras')); //auto_require: ramda-extras

  [ːObject, ːCOUNT, ːid, ːUndefined, ːMIN, ːMAX, ːSUM, ːAVG] = [
    'Object',
    'COUNT',
    'id',
    'Undefined',
    'MIN',
    'MAX',
    'SUM',
    'AVG' //auto_sugar
  ];

  qq = function(f) {
    return console.log(match(/return (.*);/, f.toString())[1], f());
  };

  qqq = function(...args) {
    return console.log(...args);
  };

  _ = function(...xs) {
    return xs;
  };

  ({AND, _, PVE, NYIE} = utils = require('./utils'));

  AGGREGATES = [ːCOUNT, ːSUM, ːAVG, ːMIN, ːMAX];

  validateANDOR = function(query, fieldsClause) {
    var andOr;
    if (1 < $(fieldsClause, keys, length)) {
      throw new PVE('AND/OR needs to be the only key in object');
    }
    andOr = fieldsClause.AND || fieldsClause.OR;
    if ('Array' !== type(andOr)) {
      throw new PVE(query, 'args of AND/OR need to be array');
    }
    if (2 !== length(andOr)) {
      throw new PVE(query, 'array of AND/OR needs to have exactly 2 items');
    }
  };

  // Extracts a where object from a fieldsClause and validates it
  // Note: no simplification of ANDs, use AND function when combining instead
  _extractWhere = curry(function(query, fieldsClause) {
    var ew, k, kʹ, v, vʹ;
    if (isNil(fieldsClause)) {
      return {};
    }
    ew = _extractWhere(query);
    if (fieldsClause.AND) {
      validateANDOR(query, fieldsClause);
      return {
        AND: [ew(fieldsClause.AND[0]), ew(fieldsClause.AND[1])]
      };
    }
    if (fieldsClause.OR) {
      validateANDOR(query, fieldsClause);
      return {
        OR: [ew(fieldsClause.OR[0]), ew(fieldsClause.OR[1])]
      };
    }
    where = {};
    for (k in fieldsClause) {
      v = fieldsClause[k];
      if (k === 'ː' + v) {
        continue;
      }
      kʹ = replace(/〳.*/, '', k);
      vʹ = type(v) === 'Object' ? v : {
        eq: v // implicit eq
      };
      where[kʹ] = vʹ;
    }
    return where;
  });

  _extractWriteFields = function(model, query, entity, writeFields) {
    var k, res, v;
    res = {};
    for (k in writeFields) {
      v = writeFields[k];
      if (!has(k, model[entity].fields)) {
        throw new PVE(query, `${k} not valid field in entity ${entity}`);
      }
      res[k] = v;
    }
    return res;
  };

  // TODO: Ta bort?
  isAggregate = function(fieldsClause) {
    var k, v;
    for (k in fieldsClause) {
      v = fieldsClause[k];
      if (test(/〳COUNT|〳SUM|〳AVG|〳MIN|〳MAX/, k)) {
        return true;
      }
    }
    return false;
  };

  resolveFields = function(fieldsClause) {
    var _and, _or;
    _and = fieldsClause.AND;
    _or = fieldsClause.OR;
    if (_and) {
      return union(resolveFields(_and[0]), resolveFields(_and[1]));
    } else if (_or) {
      return union(resolveFields(_or[0]), resolveFields(_or[1]));
    } else {
      return $(fieldsClause, keys, map(replace(/^ː/, '')), map(replace(/〳.*/, '')));
    }
  };

  tryResolveFields = function(query, fieldsClause) {
    var err;
    try {
      return resolveFields(fieldsClause);
    } catch (error) {
      err = error;
      throw new PVE(query, `invalid fieldsClause ${sf0(fieldsClause)}`);
    }
  };

  _extractSortBy = function(fieldsClause) {
    var ks;
    RE = /^ː?(.*)〳(\d+)/;
    ks = $(fieldsClause, keys, filter(test(RE)), map(function(k) {
      var ___, field, i;
      [___, field, i] = match(RE, k);
      return [field, parseInt(i)];
    }));
    return $(ks, sortBy(nth(1)), map(nth(0)));
  };

  _extractGroupBy = function(fieldsClause) {
    var ks;
    RE = /^ː?(.*)〳GROUP(\d+)/;
    ks = $(fieldsClause, keys, filter(test(RE)), map(function(k) {
      var ___, field, i;
      [___, field, i] = match(RE, k);
      return [field, parseInt(i)];
    }));
    return $(ks, sortBy(nth(1)), map(nth(0)));
  };

  _extractAggregates = function(query, fieldsClause) {
    var ___, agg, field, k, kʹ, res, v;
    RE = /^ː?(.*)〳(.*)/;
    res = {};
    for (k in fieldsClause) {
      v = fieldsClause[k];
      kʹ = $(k, replace(/〳\d+/, ''), replace(/〳GROUP\d+/, ''));
      [___, field, agg] = match(RE, kʹ);
      if (agg) {
        if (!contains(agg, AGGREGATES)) {
          throw new PVE(query, `Invalid aggregate function: ${agg}`);
        } else {
          res[field] = agg;
        }
      }
    }
    return res;
  };

  fieldsClauseAndChildren = function(query, node) {
    var children, fieldsClause;
    if (node.body === 0) {
      [fieldsClause, children] = [{}, void 0];
    } else if (equals({}, node.body)) {
      [fieldsClause, children] = [{}, void 0];
    } else {
      if (type(node.body) !== 'Array') {
        throw new PVE(query, `the body of ${node.key} is not an array, 0 or {}`);
      }
      [fieldsClause, children] = node.body;
    }
    if (!fieldsClause) {
      throw new PVE(query, `the body of ${node.key} is missing a fields clause`);
    }
    if (type(fieldsClause) !== 'Object') {
      throw new PVE(query, `the fields clause of ${node.key} is not an object`);
    }
    return [fieldsClause, children];
  };

  // Recursivly expands and validates nodes doing all work that's possible without executing a query.
  // The point is to offload work from runNode so that function doesn't become to big.
  // Returns an intermediate representation of the query that can be used by runQuery.
  expandNode = function({query, model, parent, node}) {
    var aggregates, allFields, cbody, childProp, children, childrenToOrder, ckey, def, expandedChildren, fields, fieldsClause, fieldsDiff, groupByFields, hiddenChildren, j, l, lap, len, len1, len2, m, newChildrenToResolve, orderedChildren, parentProp, ref, rel, relAndSub, relAndSubParent, relProp, reldef, relsub, res, skey, sortByFields, sub;
    relAndSubParent = function(k) {
      return [model[parent.entity].rels[k], model[parent.entity].subs[k]];
    };
    res = {};
    if (isNil(parent)) {
      def = model[node.key];
      if (isNil(def)) {
        throw new PVE(query, `no entity ${node.key} in model`);
      }
    } else {
      [rel, sub] = relAndSubParent(node.key);
      def = rel || sub;
      if (isNil(def)) {
        new PVE(query, `no relationship or subquery ${node.key} on ${parent.entity}`);
      }
    }
    // ENTITY & KEY & PARENT
    res.entity = def.entity;
    res.key = node.key;
    res.parent = parent ? parent.entity : null;
    res.onlyOne = node.onlyOne ? true : false;
    relAndSub = function(k) {
      return [model[res.entity].rels[k], model[res.entity].subs[k]];
    };
    // FIELDS CLAUSE & CHILDREN
    [fieldsClause, children] = fieldsClauseAndChildren(query, node);
    for (ckey in children) {
      cbody = children[ckey];
      [rel, sub] = relAndSub(ckey);
      relsub = rel || sub;
      if (!relsub) {
        throw new PVE(query, `no rel or sub ${ckey} in entity ${res.entity}`);
      } else if (relsub.aggregates) {
        if (relsub.groupBy) {
          if (!equals({}, cbody)) {
            throw new PVE(query, `rel or sub ${ckey} is aggregate with group by, your fieldsClause should be {}, not ${cbody}`);
          }
        } else {
          if (cbody !== 0) {
            throw new PVE(query, `rel or sub ${ckey} is aggregate, your fieldsClause should be 0, not ${cbody}`);
          }
        }
      }
    }
    // FIELDS
    fields = tryResolveFields(query, fieldsClause);
    fieldsDiff = $(model[res.entity].fields, keys, difference(fields));
    if (!isEmpty(fieldsDiff)) {
      throw new PVE(query, `invalid fields '${fieldsDiff}' on '${node.key}'`);
    }
    if (def.isAgg) {
      fields = concat(fields, $(def.original, values, head, head, keys, map(replace(/^ː/, ''))));
    }
    res.fields = fields;
    // ALL FIELDS =
    // fields from query
    // + fields for parent relationship if needed (fields for child handled further down)
    // + always include the id field
    // + fields siblings depend on
    // + fields children depend on (handled further down)
    allFields = clone(fields);
    if (def.isRel) {
      [parentProp, relProp] = def.on;
      allFields.push(relProp);
    } else if (def.isSub && def.rel) {
      [reldef] = relAndSubParent(def.rel);
      [parentProp, relProp] = reldef.on;
      allFields.push(relProp);
    }
    if (!contains(ːid, allFields)) {
      allFields.unshift(ːid);
    }
    if (node.siblings) {
      ref = node.siblings;
      for (j = 0, len = ref.length; j < len; j++) {
        skey = ref[j];
        [rel, sub] = relAndSubParent(skey);
        if (sub && sub.funArgs && sub.funArgs[node.key]) {
          allFields = union(allFields, keys(sub.funArgs[node.key]));
        }
      }
    }
    res.allFields = allFields;
    // WHERE =
    // where from query 
    // + from model for object subs
    // + dynamicly calculated part of where (handled in runQuery)
    where = _extractWhere(query, fieldsClause);
    if (def.isSub && def.subType === 'object') {
      where = utils.AND(where, def.where);
    }
    res.where = where;
    // SORT BY
    sortByFields = _extractSortBy(fieldsClause);
    if (!isEmpty(sortByFields)) {
      res.sortBy = sortByFields;
    }
    // AGGREGATIONS
    if (def.isSub && def.aggregates) {
      if (!isEmpty(fieldsClause)) {
        throw new PVE(query, `fieldsClause not empty: ${res.key}`);
      } else if (def.aggregates) {
        res.aggregates = def.aggregates;
      }
    } else {
      aggregates = _extractAggregates(query, fieldsClause);
      if (!isEmpty(aggregates)) {
        res.aggregates = aggregates;
      }
    }
    // GROUP BY
    // group from query
    // OR from model for object subs directly (when model has group by)
    // OR from model for object subs indirectly (when model has aggregation)
    // if parent
    // 	if def.isRel
    // 		[parentProp, relProp] = def.on
    // 		res.groupBy = [relProp]
    // 	else if def.isSub
    // 		if def.subType == 'object'
    // 			[reldef] = relAndSubParent def.rel
    // 			[parentProp, relProp] = reldef.on
    // 			res.groupBy = [relProp]
    // else
    if (def.isSub) {
      if (def.groupBy) {
        if (!equals({}, fieldsClause)) {
          throw new PVE(query, `fieldsClause not empty for sub ${res.key}`);
        } else {
          if (def.groupBy) {
            res.groupBy = def.groupBy;
          }
        }
      } else if (def.aggregates && def.subType === 'object') {
        [rel] = relAndSubParent(def.rel);
        [parentProp, relProp] = rel.on;
        res.groupBy = [relProp];
      }
    } else {
      groupByFields = _extractGroupBy(fieldsClause);
      if (!isEmpty(groupByFields)) {
        res.groupBy = groupByFields;
      }
    }
    if (isNil(children)) {
      return res;
    }
    // CHILDREN
    // Ordered in execution order based on their sibling dependencies.
    // Note that we have to add children not directly included in the query if the children
    // that are included in the query depends on them (=hidden children).
    childrenToOrder = keys(children);
    orderedChildren = [];
    lap = 0;
    while (!isEmpty(difference(childrenToOrder, orderedChildren))) {
      newChildrenToResolve = [];
      for (l = 0, len1 = childrenToOrder.length; l < len1; l++) {
        ckey = childrenToOrder[l];
        [rel, sub] = relAndSub(ckey);
        if (rel) { // rels never has deps so can always be added directly
          orderedChildren.push(ckey);
        } else if (sub) {
          if (sub.siblingDeps) {
            newChildrenToResolve.push(...sub.siblingDeps);
            if (isEmpty(difference(sub.siblingDeps, orderedChildren))) {
              orderedChildren.push(ckey);
            }
          } else {
            orderedChildren.push(ckey); // subs without deps can be added directly
          }
        }
      }
      childrenToOrder = difference(union(childrenToOrder, newChildrenToResolve), orderedChildren);
      if (lap++ > 10) {
        throw new PVE(query, `cannot resolve children ${sf2(childrenToOrder)}`);
      }
    }
    // HIDDEN CHILDREN = Children not included in query but needed to run the query
    // 									(eg. children depended on by other children which are included in query)
    hiddenChildren = difference(orderedChildren, keys(children));
// hiddenChildrenDefaults = fmap hiddenChildren, (ckey) ->

// ALL FIELDS ...continued
// + fields children depend on
    for (m = 0, len2 = orderedChildren.length; m < len2; m++) {
      ckey = orderedChildren[m];
      [rel, sub] = relAndSub(ckey);
      if (rel) {
        [parentProp, childProp] = rel.on;
        res.allFields = union(res.allFields, [parentProp]);
      } else if (sub && !isEmpty(sub.parentFieldDeps)) {
        res.allFields = union(res.allFields, sub.parentFieldDeps);
      }
    }
    // EXPAND CHILDREN
    expandedChildren = $(orderedChildren, map(function(ckey) {
      var body, childRes, isHidden, siblings;
      if (contains(ckey, hiddenChildren)) {
        isHidden = true;
        // if its a hidden child, we need to create a default body
        [rel, sub] = relAndSub(ckey);
        if (rel) {
          body = {};
        }
        if (sub) {
          if (sub.isAggregate) {
            body = 0;
          } else {
            body = {};
          }
        }
      } else {
        body = children[ckey];
      }
      siblings = without([ckey], orderedChildren);
      childRes = expandNode({
        query,
        model,
        parent: res,
        node: {
          key: ckey,
          body,
          siblings
        }
      });
      if (isHidden) {
        childRes.isHidden = true;
      }
      return childRes;
    }));
    res.children = expandedChildren;
    return res;
  };

  
  // Writes data to a store (pointer) in a "good" way based on what kind of node
  // the query was run for
  _writeChildRes = curry(function(model, pointer, norm, node, data) {
    var data2, def, id, j, len, name, parentProp, relProp, reldef, tmp, val, x;
    // qq -> [model, pointer, node, data]
    def = _defFor(model, node);
    if (def.isRel) {
      // qq -> def
      data2 = data;
      return pointer[node.key] = $(data2, groupBy(prop(def.on[1])));
    } else if (def.isSub) {
      if (def.subType === 'function') {
        [id, val] = data;
        if (pointer[name = node.key] == null) {
          pointer[name] = {};
        }
        return pointer[node.key][id] = val;
      } else {
        reldef = _defForSibling(model, node, def.rel);
        [parentProp, relProp] = reldef.on;
        if (node.groupBy) {
          if (!def.groupBy) {
            // group by created dynamically => group in childRes to
            tmp = {};
            for (j = 0, len = data.length; j < len; j++) {
              x = data[j];
              tmp[x[relProp]] = x.value;
            }
            return pointer[node.key] = tmp;
          } else {
            throw new NYIE;
          }
        } else {
          return pointer[node.key] = $(data, groupBy(prop(relProp)));
        }
      }
    }
  });

  // The inverse of _writeChildRes, ie. reads data from a store based on the
  // same logic but opposite
  _readChildRes = curry(function(model, pointer, node, parent) {
    var def, parentProp, relProp, reldef;
    def = _defFor(model, node);
    if (def.isRel) {
      return pointer[node.key][parent[def.on[0]]];
    } else {
      if (def.subType === 'function') {
        return pointer[node.key][parent.id];
      } else {
        reldef = _defForSibling(model, node, def.rel);
        [parentProp, relProp] = reldef.on;
        if (node.groupBy) {
          if (!def.groupBy) {
            // group by created dynamically => group in childRes to
            return pointer[node.key][parent[parentProp]];
          } else {
            throw new NYIE;
          }
        } else {
          return pointer[node.key][parent[parentProp]];
        }
      }
    }
  });

  // Helper to create the dynamic part of the where for a rel given some parent result data
  _extractRelWhere = function(reldef, data) {
    var parentProp, relProp;
    [parentProp, relProp] = reldef.on;
    return {
      [relProp]: {
        in: $(data, pluck(parentProp), uniq)
      }
    };
  };

  // Helper for getting the definition for a node
  _defFor = curry(function(model, node) {
    var rel, sub;
    if (isNil(node.parent)) {
      return model[node.entity];
    } else {
      rel = model[node.parent].rels[node.key];
      sub = model[node.parent].subs[node.key];
      return rel || sub;
    }
  });

  // Helper for getting the definition for a sibling to a node
  _defForSibling = curry(function(model, child, key) {
    var rel, sub;
    rel = model[child.parent].rels[key];
    sub = model[child.parent].subs[key];
    return rel || sub;
  });

  emptyIfNil = function(x, isObj = false) {
    if (isNil(x)) {
      if (isObj) {
        return null;
      } else {
        return [];
      }
    } else {
      return x;
    }
  };

  // Building the "argList" for invoking sub functions
  _extractArgList = function(model, cres, pres, node, siblings) {
    var argList, data, def, i, j, k, l, len, len1, pr, ref, ref1, s, sib, tmp;
    def = _defFor(model, node);
    argList = [];
    for (i in pres) {
      pr = pres[i];
      // force the id for easier read/write to childResult later
      argList[i] = pick(union(['id'], def.parentFieldDeps), pr);
      ref = def.siblingDeps;
      for (j = 0, len = ref.length; j < len; j++) {
        s = ref[j];
        sib = siblings[s];
        data = _readChildRes(model, cres, sib, pr);
        if (sib.groupBy) {
          argList[i][s] = data;
        } else {
          if ('Object' === type(def.funArgs[s])) {
            // Note: this is the somewhat special behaviour of sub functions
            tmp = {};
            ref1 = keys(def.funArgs[s]);
            for (l = 0, len1 = ref1.length; l < len1; l++) {
              k = ref1[l];
              tmp[k] = pluck(k, data);
            }
            argList[i][s] = tmp;
          } else {
            argList[i][s] = data;
          }
        }
      }
    }
    return argList;
  };

  _dataToRes = function(model) {
    return function(data) {
      var k, res, v;
      res = {};
      for (k in data) {
        v = data[k];
        res[model.$config.colToProp(k)] = v;
      }
      return res;
    };
  };

  returnResult = function(query, node, res) {
    if (node.onlyOne) {
      if (1 < length(res)) {
        throw new PVE(query, 'Your 1 query returned multiple results');
      } else {
        return res[0];
      }
    } else {
      return res;
    }
  };

  // Recursively running a node (calling exec with it).
  // Note that this also prepares the dynamic part of WHEREs for rels and subs based
  // on the result of the parent.
  // Also note that this also prepares and handles the calling of sub functions to prepare the
  // the dynamic part of WHEREs for sub functions.
  runNode = function({model, exec, query, norm}) {
    return async function(node) {
      var _c, argList, argListRes, c, cdef, childRes, childRes2, cres, def, defFor, err, fr, funRes, i, id, isObj, j, l, len, len1, len2, len3, m, n, r, readChildRes, ref, ref1, relRes, relWhere, res, res123, res_, rescdef, runNodeAgain, siblings, writeChildRes;
      runNodeAgain = runNode({model, exec, query, norm});
      defFor = _defFor(model);
      res_ = (await exec(node));
      res = $(res_, map(_dataToRes(model)));
      for (j = 0, len = res.length; j < len; j++) {
        r = res[j];
        mergeToNorm(node.entity, clone(r), norm);
      }
      if (!node.children) {
        return returnResult(query, node, res);
      }
      def = defFor(node);
      cres = {};
      writeChildRes = _writeChildRes(model, cres, norm);
      siblings = {};
      ref = node.children;
      for (l = 0, len1 = ref.length; l < len1; l++) {
        _c = ref[l];
        c = clone(_c);
        siblings[c.key] = c;
        cdef = defFor(c);
        if (cdef.isRel) {
          if (isEmpty(res)) {
            writeChildRes(c, []);
          } else {
            relWhere = _extractRelWhere(cdef, res);
            c.where = AND(c.where, relWhere);
            relRes = (await runNodeAgain(c));
            writeChildRes(c, relRes);
          }
        } else if (cdef.isSub) {
          if (cdef.rel) {
            if (isEmpty(res)) {
              writeChildRes(c, []);
              continue;
            } else {
              c.where = AND(c.where, _extractRelWhere(def.rels[cdef.rel], res));
            }
          }
          if (cdef.subType === 'object') {
            res123 = (await runNodeAgain(c));
            writeChildRes(c, res123);
          // writeChildRes c, await runNodeAgain c
          } else if (cdef.subType === 'function') {
            argList = _extractArgList(model, cres, res, c, siblings);
            try {
              argListRes = $(argList, map(function(args) {
                return cdef.fun(args);
              }));
            } catch (error) {
              err = error;
              console.error(err);
              throw new PVE(query, `error when executing sub function for ${c.key} with argList ${sf0(argList)}`);
            }
            funRes = (await Promise.all($(argListRes, map(async function(query) {
              var body, fieldsClause, funWhere;
              body = $(query, values, head);
              fieldsClause = body[0];
              funWhere = _extractWhere({}, fieldsClause);
              return (await runNodeAgain(merge(c, {
                where: AND(c.where, funWhere)
              })));
            }))));
// using the index for sub function results for easier reads later
            for (i in funRes) {
              fr = funRes[i];
              id = argList[i].id;
              writeChildRes(c, [id, fr]);
            }
          }
        }
      }
      // Build the result
      readChildRes = _readChildRes(model, cres);
      for (m = 0, len2 = res.length; m < len2; m++) {
        r = res[m];
        ref1 = node.children;
        for (n = 0, len3 = ref1.length; n < len3; n++) {
          c = ref1[n];
          if (c.isHidden) {
            continue;
          }
          childRes = readChildRes(c, r);
          rescdef = _defFor(model, c);
          childRes2 = childRes;
          if (test(/One$/, rescdef.multiplicity) && type(childRes) === 'Array') {
            if (length(childRes) === 0) {
              childRes2 = {};
            } else if (length(childRes) === 1) {
              childRes2 = childRes[0];
            } else if (length(childRes) > 1) {
              throw new PVE(`Query gave multiple results for relation ${c.key} on parent ${c.parent}: ${sf2(childRes)}`);
            }
          }
          isObj = test(/One$/, rescdef.multiplicity);
          r[c.key] = emptyIfNil(childRes2, isObj);
        }
      }
      return returnResult(query, node, res);
    };
  };

  runNodeSync = function({model, exec, query, norm}) {
    return function(node) {
      var _c, argList, argListRes, c, cdef, childRes, childRes2, cres, def, defFor, err, fr, funRes, i, id, isObj, j, l, len, len1, len2, len3, m, n, r, readChildRes, ref, ref1, relWhere, res, res123, res_, rescdef, runNodeAgain, siblings, test1234, writeChildRes;
      runNodeAgain = runNodeSync({model, exec, query, norm});
      defFor = _defFor(model);
      res_ = exec(node);
      res = $(res_, map(_dataToRes(model)));
      for (j = 0, len = res.length; j < len; j++) {
        r = res[j];
        mergeToNorm(node.entity, clone(r), norm);
      }
      if (!node.children) {
        return returnResult(query, node, res);
      }
      def = defFor(node);
      cres = {};
      writeChildRes = _writeChildRes(model, cres, norm);
      siblings = {};
      ref = node.children;
      for (l = 0, len1 = ref.length; l < len1; l++) {
        _c = ref[l];
        c = clone(_c);
        siblings[c.key] = c;
        cdef = defFor(c);
        if (cdef.isRel) {
          if (isEmpty(res)) {
            writeChildRes(c, []);
          } else {
            relWhere = _extractRelWhere(cdef, res);
            c.where = AND(c.where, relWhere);
            test1234 = runNodeAgain(c);
            writeChildRes(c, test1234);
          }
        } else if (cdef.isSub) {
          if (cdef.rel) {
            if (isEmpty(res)) {
              writeChildRes(c, []);
              continue;
            } else {
              c.where = AND(c.where, _extractRelWhere(def.rels[cdef.rel], res));
            }
          }
          if (cdef.subType === 'object') {
            res123 = runNodeAgain(c);
            writeChildRes(c, res123);
          // writeChildRes c, await runNodeAgain c
          } else if (cdef.subType === 'function') {
            argList = _extractArgList(model, cres, res, c, siblings);
            try {
              argListRes = $(argList, map(function(args) {
                return cdef.fun(args);
              }));
            } catch (error) {
              err = error;
              console.error(err);
              throw new PVE(query, `error when executing sub function for ${c.key} with argList ${sf0(argList)}`);
            }
            funRes = $(argListRes, map(function(query) {
              var body, fieldsClause, funWhere;
              body = $(query, values, head);
              fieldsClause = body[0];
              funWhere = _extractWhere({}, fieldsClause);
              return runNodeAgain(merge(c, {
                where: AND(c.where, funWhere)
              }));
            }));
// using the index for sub function results for easier reads later
            for (i in funRes) {
              fr = funRes[i];
              id = argList[i].id;
              writeChildRes(c, [id, fr]);
            }
          }
        }
      }
      // Build the result
      readChildRes = _readChildRes(model, cres);
      for (m = 0, len2 = res.length; m < len2; m++) {
        r = res[m];
        ref1 = node.children;
        for (n = 0, len3 = ref1.length; n < len3; n++) {
          c = ref1[n];
          if (c.isHidden) {
            continue;
          }
          childRes = readChildRes(c, r);
          rescdef = _defFor(model, c);
          childRes2 = childRes;
          if (test(/One$/, rescdef.multiplicity) && type(childRes) === 'Array') {
            if (length(childRes) === 0) {
              childRes2 = {};
            } else if (length(childRes) === 1) {
              childRes2 = childRes[0];
            } else if (length(childRes) > 1) {
              throw new PVE(`Query gave multiple results for relation ${c.key} on parent ${c.parent}: ${sf2(childRes)}`);
            }
          }
          isObj = test(/One$/, rescdef.multiplicity);
          r[c.key] = emptyIfNil(childRes2, isObj);
        }
      }
      return returnResult(query, node, res);
    };
  };

  mergeToNorm = function(entity, o, norm) {
    if (norm[entity] == null) {
      norm[entity] = {};
    }
    if (isNil(o.id)) {
      throw new Error('o misses id');
    }
    if (norm[entity][o.id]) {
      return norm[entity][o.id] = merge(norm[entity][o.id], o);
    } else {
      return norm[entity][o.id] = o;
    }
  };

  expandQuery = function(model, query) {
    if (isNil(model)) {
      throw new PVE('model cannot be nil');
    }
    if (isNil(query)) {
      throw new PVE('query cannot be nil');
    }
    // TODO: only handling simple queries now, ie. only one root which is entity
    return $(query, mapO(function(body, key) {
      var cleanKey;
      if (test(/1$/, key)) {
        cleanKey = replace(/1$/, '', key);
        return expandNode({
          model,
          query,
          parent: null,
          node: {
            key: cleanKey,
            body,
            onlyOne: true
          }
        });
      } else {
        return expandNode({
          model,
          query,
          parent: null,
          node: {key, body}
        });
      }
    }));
  };

  expandWrite = function(model, query) {
    var entity, writeFields;
    if (isNil(model)) {
      throw new PVE('model cannot be nil');
    }
    if (isNil(query)) {
      throw new PVE('query cannot be nil');
    }
    // TODO: only handling simple queries now, ie. only one root which is entity
    if (1 < $(query, keys, length)) {
      throw new NYIE;
    }
    entity = $(query, keys, head);
    if (isNil(model[entity])) {
      throw new PVE(query, `${entity} not an entity in model`);
    }
    writeFields = _extractWriteFields(model, query, entity, query[entity]);
    return {
      entity,
      values: writeFields
    };
  };

  runQuery = async function(model, exec, query) {
    var fatQuery, firstRes, norm, res;
    if (isNil(model)) {
      throw new PVE('model cannot be nil');
    }
    if (isNil(query)) {
      throw new PVE('query cannot be nil');
    }
    fatQuery = expandQuery(model, query);
    norm = {};
    res = (await PromiseProps($(fatQuery, mapO(function(node, key) {
      return runNode({model, query, exec, norm})(node);
    }))));
    if (1 < $(query, keys, length)) {
      throw new NYIE;
    }
    firstRes = $(res, values, head);
    return [firstRes, norm];
  };

  runFatQuery = async function(model, exec, fatQuery, query) {
    var firstRes, norm, res;
    if (isNil(model)) {
      throw new PVE('model cannot be nil');
    }
    if (isNil(fatQuery)) {
      throw new PVE('fatQuery cannot be nil');
    }
    if (isNil(query)) {
      throw new PVE('query cannot be nil');
    }
    norm = {};
    res = (await PromiseProps($(fatQuery, mapO(function(node, key) {
      return runNode({model, query, exec, norm})(node);
    }))));
    if (1 < $(query, keys, length)) {
      throw new NYIE;
    }
    firstRes = $(res, values, head);
    return [firstRes, norm];
  };

  runFatQuerySync = function(model, exec, fatQuery, query) {
    var norm, res, ret;
    if (isNil(model)) {
      throw new PVE('model cannot be nil');
    }
    if (isNil(fatQuery)) {
      throw new PVE('fatQuery cannot be nil');
    }
    if (isNil(query)) {
      throw new PVE('query cannot be nil');
    }
    norm = {};
    res = $(fatQuery, mapO(function(node, key) {
      return runNodeSync({model, query, exec, norm})(node);
    }));
    if ($(query, keys, length, equals(1))) {
      ret = $(res, values, head);
    } else {
      ret = res;
    }
    return [ret, norm];
  };

  // Validates delta, normalizes writes (Creates, Updates, Deletes) and calls exec.
  // Note: if we'd have foreign keys, we'd have to do some fancy ordering based on if its C or D...
  runDelta = func({
    model: Object, // model as returned from createModel
    exec: function({entity, id, delta}) {}, // callback (you determine if it's Create, Update or Delete), you can return a spec for serverDelta
    delta: Object
  }, async function({model, exec, delta}) {
    var entity, entityDelta, id, items, k, op, res, serverDelta, v;
    serverDelta = {};
    for (entity in delta) {
      items = delta[entity];
      if (ːObject !== type(items)) {
        throw new PVE(`invalid items ${type(items)} in delta`);
      }
      if (isNil(model[entity])) {
        throw new PVE(`${entity} not an entity in model`);
      }
      for (id in items) {
        entityDelta = items[id];
        if (type(entityDelta) !== ːObject && type(entityDelta) !== ːUndefined) {
          throw new PVE(`invalid values ${type(entityDelta)} in delta for entity ${entity}`);
        }
        for (k in entityDelta) {
          v = entityDelta[k];
          if (!has(k, model[entity].fields)) {
            throw new PVE(`${entity} does not have field ${k}`);
          }
        }
        if (id < 0) {
          op = 'create';
        } else if (entityDelta === void 0) {
          op = 'delete';
        } else {
          op = 'update';
        }
        res = (await exec({
          entity,
          id,
          op,
          delta: entityDelta
        }));
        serverDelta = changeM(res, serverDelta);
      }
    }
    return serverDelta;
  });

  normalize = function(model, data) {
    var entity, entityData, res, results;
    res = {};
    results = [];
    for (entity in data) {
      entityData = data[entity];
      results.push(res[entity] = {});
    }
    return results;
  };

  module.exports = {runQuery, runFatQuery, runFatQuerySync, runDelta, expandQuery, expandWrite, normalize, _extractSortBy, _extractGroupBy, _extractAggregates, _extractWhere, fieldsClauseAndChildren, isAggregate};

}).call(this);
