// Generated by CoffeeScript 2.4.1
(function() {
  var $, PSE, R, RE, _, add, append, call, contains, curry, flatten, isNil, join, keys, length, map, mapI, match, max, omit, qq, qqq, query, range, replace, test, toPair, toPairs, toUpper, type, union, update, utils, validateKeys, values, where, ːBigInt, ːBool, ːDate, ːDateTime, ːFloat, ːID_Int_Seq, ːInt, ːStr;

  add = require('ramda/src/add');

  append = require('ramda/src/append');

  call = require('ramda/src/call');

  contains = require('ramda/src/contains');

  curry = require('ramda/src/curry');

  flatten = require('ramda/src/flatten');

  isNil = require('ramda/src/isNil');

  join = require('ramda/src/join');

  keys = require('ramda/src/keys');

  length = require('ramda/src/length');

  map = require('ramda/src/map');

  match = require('ramda/src/match');

  max = require('ramda/src/max');

  omit = require('ramda/src/omit');

  range = require('ramda/src/range');

  replace = require('ramda/src/replace');

  test = require('ramda/src/test');

  toPairs = require('ramda/src/toPairs');

  toUpper = require('ramda/src/toUpper');

  type = require('ramda/src/type');

  union = require('ramda/src/union');

  update = require('ramda/src/update');

  values = require('ramda/src/values');

  where = require('ramda/src/where');

  R = require('ramda');

  ({mapI, toPair, $} = RE = require('ramda-extras')); //auto_require: ramda-extras

  [ːStr, ːDate, ːBool, ːID_Int_Seq, ːFloat, ːBigInt, ːDateTime, ːInt] = [
    'Str',
    'Date',
    'Bool',
    'ID_Int_Seq',
    'Float',
    'BigInt',
    'DateTime',
    'Int' //auto_sugar
  ];

  qq = function(f) {
    return console.log(match(/return (.*);/, f.toString())[1], f());
  };

  qqq = function(...args) {
    return console.log(...args);
  };

  _ = function(...xs) {
    return xs;
  };

  utils = require('./utils');

  query = require('./query');

  PSE = utils.customError('PopsiqlSQLError');

  module.exports = function(model) {
    var REPLACE, col, coldef, dollar, dropTables, ent, esc, escKW, keywords, keywordsLoose, makeColumns, makeEntity, makeFields, makeGrouping, makePreds, makeSorting, makeTables, ops, toAgg, toOpAndVal, toOpAndValOld, toPred, toPreds, val;
    //##### HELPERS ################################################################
    // https://www.postgresql.org/docs/8.1/sql-keywords-appendix.html
    // All except "non-reserved" from list
    keywords = ['A', 'ABS', 'ADA', 'ALIAS', 'ALL', 'ALLOCATE', 'ALWAYS', 'ANALYSE', 'ANALYZE', 'AND', 'ANY', 'ARE', 'ARRAY', 'AS', 'ASC', 'ASENSITIVE', 'ASYMMETRIC', 'ATOMIC', 'ATTRIBUTE', 'ATTRIBUTES', 'AUTHORIZATION', 'AVG', 'BERNOULLI', 'BETWEEN', 'BINARY', 'BITVAR', 'BIT_LENGTH', 'BLOB', 'BOTH', 'BREADTH', 'C', 'CALL', 'CARDINALITY', 'CASCADED', 'CASE', 'CAST', 'CATALOG', 'CATALOG_NAME', 'CEIL', 'CEILING', 'CHARACTERS', 'CHARACTER_LENGTH', 'CHARACTER_SET_CATALOG', 'CHARACTER_SET_NAME', 'CHARACTER_SET_SCHEMA', 'CHAR_LENGTH', 'CHECK', 'CHECKED', 'CLASS_ORIGIN', 'CLOB', 'COBOL', 'COLLATE', 'COLLATION', 'COLLATION_CATALOG', 'COLLATION_NAME', 'COLLATION_SCHEMA', 'COLLECT', 'COLUMN', 'COLUMN_NAME', 'COMMAND_FUNCTION', 'COMMAND_FUNCTION_CODE', 'COMPLETION', 'CONDITION', 'CONDITION_NUMBER', 'CONNECT', 'CONNECTION_NAME', 'CONSTRAINT', 'CONSTRAINT_CATALOG', 'CONSTRAINT_NAME', 'CONSTRAINT_SCHEMA', 'CONSTRUCTOR', 'CONTAINS', 'CONTINUE', 'CORR', 'CORRESPONDING', 'COUNT', 'COVAR_POP', 'COVAR_SAMP', 'CREATE', 'CROSS', 'CUBE', 'CUME_DIST', 'CURRENT', 'CURRENT_DATE', 'CURRENT_DEFAULT_TRANSFORM_GROUP', 'CURRENT_PATH', 'CURRENT_ROLE', 'CURRENT_TIME', 'CURRENT_TIMESTAMP', 'CURRENT_TRANSFORM_GROUP_FOR_TYPE', 'CURRENT_USER', 'CURSOR_NAME', 'DATA', 'DATE', 'DATETIME_INTERVAL_CODE', 'DATETIME_INTERVAL_PRECISION', 'DEFAULT', 'DEFERRABLE', 'DEFINED', 'DEGREE', 'DENSE_RANK', 'DEPTH', 'DEREF', 'DERIVED', 'DESC', 'DESCRIBE', 'DESCRIPTOR', 'DESTROY', 'DESTRUCTOR', 'DETERMINISTIC', 'DIAGNOSTICS', 'DICTIONARY', 'DISCONNECT', 'DISPATCH', 'DISTINCT', 'DO', 'DYNAMIC', 'DYNAMIC_FUNCTION', 'DYNAMIC_FUNCTION_CODE', 'ELEMENT', 'ELSE', 'END', 'END-EXEC', 'EQUALS', 'EVERY', 'EXCEPT', 'EXCEPTION', 'EXCLUDE', 'EXEC', 'EXISTING', 'EXP', 'FALSE', 'FILTER', 'FINAL', 'FLOOR', 'FOLLOWING', 'FOR', 'FOREIGN', 'FORTRAN', 'FOUND', 'FREE', 'FREEZE', 'FROM', 'FULL', 'FUSION', 'G', 'GENERAL', 'GENERATED', 'GET', 'GO', 'GOTO', 'GRANT', 'GROUP', 'GROUPING', 'HAVING', 'HIERARCHY', 'HOST', 'IDENTITY', 'IGNORE', 'ILIKE', 'IMPLEMENTATION', 'IN', 'INDICATOR', 'INFIX', 'INITIALIZE', 'INITIALLY', 'INNER', 'INSTANCE', 'INSTANTIABLE', 'INTERSECT', 'INTERSECTION', 'INTO', 'IS', 'ISNULL', 'ITERATE', 'JOIN', 'K', 'KEY_MEMBER', 'KEY_TYPE', 'LATERAL', 'LEADING', 'LEFT', 'LENGTH', 'LESS', 'LIKE', 'LIMIT', 'LN', 'LOCALTIME', 'LOCALTIMESTAMP', 'LOCATOR', 'LOWER', 'M', 'MAP', 'MATCHED', 'MAX', 'MEMBER', 'MERGE', 'MESSAGE_LENGTH', 'MESSAGE_OCTET_LENGTH', 'MESSAGE_TEXT', 'METHOD', 'MIN', 'MOD', 'MODIFIES', 'MODIFY', 'MODULE', 'MORE', 'MULTISET', 'MUMPS', 'NAME', 'NATURAL', 'NCLOB', 'NESTING', 'NEW', 'NORMALIZE', 'NORMALIZED', 'NOT', 'NOTNULL', 'NULL', 'NULLABLE', 'NULLS', 'NUMBER', 'OCTETS', 'OCTET_LENGTH', 'OFF', 'OFFSET', 'OLD', 'ON', 'ONLY', 'OPEN', 'OPERATION', 'OPTIONS', 'OR', 'ORDER', 'ORDERING', 'ORDINALITY', 'OTHERS', 'OUTER', 'OUTPUT', 'OVER', 'OVERLAPS', 'OVERRIDING', 'PAD', 'PARAMETER', 'PARAMETERS', 'PARAMETER_MODE', 'PARAMETER_NAME', 'PARAMETER_ORDINAL_POSITION', 'PARAMETER_SPECIFIC_CATALOG', 'PARAMETER_SPECIFIC_NAME', 'PARAMETER_SPECIFIC_SCHEMA', 'PARTITION', 'PASCAL', 'PATH', 'PERCENTILE_CONT', 'PERCENTILE_DISC', 'PERCENT_RANK', 'PLACING', 'PLI', 'POSTFIX', 'POWER', 'PRECEDING', 'PREFIX', 'PREORDER', 'PRIMARY', 'PUBLIC', 'RANGE', 'RANK', 'READS', 'RECURSIVE', 'REF', 'REFERENCES', 'REFERENCING', 'REGR_AVGX', 'REGR_AVGY', 'REGR_COUNT', 'REGR_INTERCEPT', 'REGR_R2', 'REGR_SLOPE', 'REGR_SXX', 'REGR_SXY', 'REGR_SYY', 'RESULT', 'RETURN', 'RETURNED_CARDINALITY', 'RETURNED_LENGTH', 'RETURNED_OCTET_LENGTH', 'RETURNED_SQLSTATE', 'RIGHT', 'ROLLUP', 'ROUTINE', 'ROUTINE_CATALOG', 'ROUTINE_NAME', 'ROUTINE_SCHEMA', 'ROW_COUNT', 'ROW_NUMBER', 'SCALE', 'SCHEMA_NAME', 'SCOPE', 'SCOPE_CATALOG', 'SCOPE_NAME', 'SCOPE_SCHEMA', 'SEARCH', 'SECTION', 'SELECT', 'SELF', 'SENSITIVE', 'SERVER_NAME', 'SESSION_USER', 'SETS', 'SIMILAR', 'SIZE', 'SOME', 'SOURCE', 'SPACE', 'SPECIFIC', 'SPECIFICTYPE', 'SPECIFIC_NAME', 'SQL', 'SQLCODE', 'SQLERROR', 'SQLEXCEPTION', 'SQLSTATE', 'SQLWARNING', 'SQRT', 'STATE', 'STATIC', 'STDDEV_POP', 'STDDEV_SAMP', 'STRUCTURE', 'STYLE', 'SUBCLASS_ORIGIN', 'SUBLIST', 'SUBMULTISET', 'SUM', 'SYMMETRIC', 'SYSTEM_USER', 'TABLE', 'TABLESAMPLE', 'TABLE_NAME', 'TERMINATE', 'THAN', 'THEN', 'TIES', 'TIMEZONE_HOUR', 'TIMEZONE_MINUTE', 'TO', 'TOP_LEVEL_COUNT', 'TRAILING', 'TRANSACTIONS_COMMITTED', 'TRANSACTIONS_ROLLED_BACK', 'TRANSACTION_ACTIVE', 'TRANSFORM', 'TRANSFORMS', 'TRANSLATE', 'TRANSLATION', 'TRIGGER_CATALOG', 'TRIGGER_NAME', 'TRIGGER_SCHEMA', 'TRUE', 'UESCAPE', 'UNBOUNDED', 'UNDER', 'UNION', 'UNIQUE', 'UNNAMED', 'UNNEST', 'UPPER', 'USAGE', 'USER', 'USER_DEFINED_TYPE_CATALOG', 'USER_DEFINED_TYPE_CODE', 'USER_DEFINED_TYPE_NAME', 'USER_DEFINED_TYPE_SCHEMA', 'USING', 'VALUE', 'VARIABLE', 'VAR_POP', 'VAR_SAMP', 'VERBOSE', 'WHEN', 'WHENEVER', 'WHERE', 'WIDTH_BUCKET', 'WINDOW', 'WITHIN'];
    // A bit loosened up definition of keywords
    keywordsLoose = ['A', 'ABS', 'ADA', 'ALIAS', 'ALL', 'ALLOCATE', 'ALWAYS', 'ANALYSE', 'ANALYZE', 'AND', 'ANY', 'ARE', 'ARRAY', 'AS', 'ASC', 'ASENSITIVE', 'ASYMMETRIC', 'ATOMIC', 'ATTRIBUTE', 'ATTRIBUTES', 'AUTHORIZATION', 'AVG', 'BERNOULLI', 'BETWEEN', 'BINARY', 'BITVAR', 'BIT_LENGTH', 'BLOB', 'BOTH', 'BREADTH', 'C', 'CALL', 'CARDINALITY', 'CASCADED', 'CASE', 'CAST', 'CATALOG', 'CATALOG_NAME', 'CEIL', 'CEILING', 'CHARACTERS', 'CHARACTER_LENGTH', 'CHARACTER_SET_CATALOG', 'CHARACTER_SET_NAME', 'CHARACTER_SET_SCHEMA', 'CHAR_LENGTH', 'CHECK', 'CHECKED', 'CLASS_ORIGIN', 'CLOB', 'COBOL', 'COLLATE', 'COLLATION', 'COLLATION_CATALOG', 'COLLATION_NAME', 'COLLATION_SCHEMA', 'COLLECT', 'COLUMN', 'COLUMN_NAME', 'COMMAND_FUNCTION', 'COMMAND_FUNCTION_CODE', 'COMPLETION', 'CONDITION', 'CONDITION_NUMBER', 'CONNECT', 'CONNECTION_NAME', 'CONSTRAINT', 'CONSTRAINT_CATALOG', 'CONSTRAINT_NAME', 'CONSTRAINT_SCHEMA', 'CONSTRUCTOR', 'CONTAINS', 'CONTINUE', 'CORR', 'CORRESPONDING', 'COUNT', 'COVAR_POP', 'COVAR_SAMP', 'CREATE', 'CROSS', 'CUBE', 'CUME_DIST', 'CURRENT', 'CURRENT_DATE', 'CURRENT_DEFAULT_TRANSFORM_GROUP', 'CURRENT_PATH', 'CURRENT_ROLE', 'CURRENT_TIME', 'CURRENT_TIMESTAMP', 'CURRENT_TRANSFORM_GROUP_FOR_TYPE', 'CURRENT_USER', 'CURSOR_NAME', 'DATA', 'DATE', 'DATETIME_INTERVAL_CODE', 'DATETIME_INTERVAL_PRECISION', 'DEFAULT', 'DEFERRABLE', 'DEFINED', 'DEGREE', 'DENSE_RANK', 'DEPTH', 'DEREF', 'DERIVED', 'DESC', 'DESCRIBE', 'DESCRIPTOR', 'DESTROY', 'DESTRUCTOR', 'DETERMINISTIC', 'DIAGNOSTICS', 'DICTIONARY', 'DISCONNECT', 'DISPATCH', 'DISTINCT', 'DO', 'DYNAMIC', 'DYNAMIC_FUNCTION', 'DYNAMIC_FUNCTION_CODE', 'ELEMENT', 'ELSE', 'END', 'END-EXEC', 'EQUALS', 'EVERY', 'EXCEPT', 'EXCEPTION', 'EXCLUDE', 'EXEC', 'EXISTING', 'EXP', 'FALSE', 'FILTER', 'FINAL', 'FLOOR', 'FOLLOWING', 'FOR', 'FOREIGN', 'FORTRAN', 'FOUND', 'FREE', 'FREEZE', 'FROM', 'FULL', 'FUSION', 'G', 'GENERAL', 'GENERATED', 'GET', 'GO', 'GOTO', 'GRANT', 'GROUP', 'GROUPING', 'HAVING', 'HIERARCHY', 'HOST', 'IDENTITY', 'IGNORE', 'ILIKE', 'IMPLEMENTATION', 'IN', 'INDICATOR', 'INFIX', 'INITIALIZE', 'INITIALLY', 'INNER', 'INSTANCE', 'INSTANTIABLE', 'INTERSECT', 'INTERSECTION', 'INTO', 'IS', 'ISNULL', 'ITERATE', 'JOIN', 'K', 'KEY_MEMBER', 'KEY_TYPE', 'LATERAL', 'LEADING', 'LEFT', 'LENGTH', 'LESS', 'LIKE', 'LIMIT', 'LN', 'LOCALTIME', 'LOCALTIMESTAMP', 'LOCATOR', 'LOWER', 'M', 'MAP', 'MATCHED', 'MAX', 'MERGE', 'MESSAGE_LENGTH', 'MESSAGE_OCTET_LENGTH', 'MESSAGE_TEXT', 'METHOD', 'MIN', 'MOD', 'MODIFIES', 'MODIFY', 'MODULE', 'MORE', 'MULTISET', 'MUMPS', 'NAME', 'NATURAL', 'NCLOB', 'NESTING', 'NEW', 'NORMALIZE', 'NORMALIZED', 'NOT', 'NOTNULL', 'NULL', 'NULLABLE', 'NULLS', 'NUMBER', 'OCTETS', 'OCTET_LENGTH', 'OFF', 'OFFSET', 'OLD', 'ON', 'ONLY', 'OPEN', 'OPERATION', 'OPTIONS', 'OR', 'ORDER', 'ORDERING', 'ORDINALITY', 'OTHERS', 'OUTER', 'OUTPUT', 'OVER', 'OVERLAPS', 'OVERRIDING', 'PAD', 'PARAMETER', 'PARAMETERS', 'PARAMETER_MODE', 'PARAMETER_NAME', 'PARAMETER_ORDINAL_POSITION', 'PARAMETER_SPECIFIC_CATALOG', 'PARAMETER_SPECIFIC_NAME', 'PARAMETER_SPECIFIC_SCHEMA', 'PARTITION', 'PASCAL', 'PATH', 'PERCENTILE_CONT', 'PERCENTILE_DISC', 'PERCENT_RANK', 'PLACING', 'PLI', 'POSTFIX', 'POWER', 'PRECEDING', 'PREFIX', 'PREORDER', 'PRIMARY', 'PUBLIC', 'RANGE', 'RANK', 'READS', 'RECURSIVE', 'REF', 'REFERENCES', 'REFERENCING', 'REGR_AVGX', 'REGR_AVGY', 'REGR_COUNT', 'REGR_INTERCEPT', 'REGR_R2', 'REGR_SLOPE', 'REGR_SXX', 'REGR_SXY', 'REGR_SYY', 'RESULT', 'RETURN', 'RETURNED_CARDINALITY', 'RETURNED_LENGTH', 'RETURNED_OCTET_LENGTH', 'RETURNED_SQLSTATE', 'RIGHT', 'ROLLUP', 'ROUTINE', 'ROUTINE_CATALOG', 'ROUTINE_NAME', 'ROUTINE_SCHEMA', 'ROW_COUNT', 'ROW_NUMBER', 'SCALE', 'SCHEMA_NAME', 'SCOPE', 'SCOPE_CATALOG', 'SCOPE_NAME', 'SCOPE_SCHEMA', 'SEARCH', 'SECTION', 'SELECT', 'SELF', 'SENSITIVE', 'SERVER_NAME', 'SESSION_USER', 'SETS', 'SIMILAR', 'SIZE', 'SOME', 'SOURCE', 'SPACE', 'SPECIFIC', 'SPECIFICTYPE', 'SPECIFIC_NAME', 'SQL', 'SQLCODE', 'SQLERROR', 'SQLEXCEPTION', 'SQLSTATE', 'SQLWARNING', 'SQRT', 'STATE', 'STATIC', 'STDDEV_POP', 'STDDEV_SAMP', 'STRUCTURE', 'STYLE', 'SUBCLASS_ORIGIN', 'SUBLIST', 'SUBMULTISET', 'SUM', 'SYMMETRIC', 'SYSTEM_USER', 'TABLE', 'TABLESAMPLE', 'TABLE_NAME', 'TERMINATE', 'THAN', 'THEN', 'TIES', 'TIMEZONE_HOUR', 'TIMEZONE_MINUTE', 'TO', 'TOP_LEVEL_COUNT', 'TRAILING', 'TRANSACTIONS_COMMITTED', 'TRANSACTIONS_ROLLED_BACK', 'TRANSACTION_ACTIVE', 'TRANSFORM', 'TRANSFORMS', 'TRANSLATE', 'TRANSLATION', 'TRIGGER_CATALOG', 'TRIGGER_NAME', 'TRIGGER_SCHEMA', 'TRUE', 'UESCAPE', 'UNBOUNDED', 'UNDER', 'UNION', 'UNIQUE', 'UNNAMED', 'UNNEST', 'UPPER', 'USAGE', 'USER', 'USER_DEFINED_TYPE_CATALOG', 'USER_DEFINED_TYPE_CODE', 'USER_DEFINED_TYPE_NAME', 'USER_DEFINED_TYPE_SCHEMA', 'USING', 'VALUE', 'VARIABLE', 'VAR_POP', 'VAR_SAMP', 'VERBOSE', 'WHEN', 'WHENEVER', 'WHERE', 'WIDTH_BUCKET', 'WINDOW', 'WITHIN'];
    esc = function(s) {
      return `"${s}"`;
    };
    escKW = function(s) {
      if (contains(toUpper(s), keywordsLoose)) {
        return esc(s);
      } else {
        return s;
      }
    };
    val = function(x) {
      if (isNil(x)) {
        return "null";
      } else if (type(x) === 'Date') {
        return `'${x.toISOString()}'`;
      } else if (type(x) === 'String') {
        return `'${x.replace(/'/g, "''")}'`;
      } else {
        return x;
      }
    };
    dollar = function(x) {
      return `$${x}`;
    };
    ent = function(s) {
      return escKW(model.$config.entityToTable(s));
    };
    col = function(s) {
      return escKW(model.$config.propToCol(s));
    };
    //##### CREATE TABLE ###########################################################
    coldef = curry(function(k, v) {
      return `${col(k)} ${v}`;
    });
    makeColumns = function(fields) {
      var res;
      res = $(fields, toPairs, map(function([field, dataType]) {
        var dataTypeʹ, k, notNull, v;
        if ('Object' === type(dataType)) {
          [k, v] = toPair(dataType);
          if (test(/oneToOne〳?/, k)) { // not yet implemented
            return [];
          } else if (test(/oneToMany〳?/, k)) { // not yet implemented
            return [];
          } else if (test(/manyToOne〳?/, k)) { // not yet implemented
            return [];
          }
          throw new PSE(`Object type for key '${k}' not yet implemented`);
        }
        notNull = test(/〳$/, dataType) ? '' : ' NOT NULL';
        dataTypeʹ = test(/〳$/, dataType) ? replace(/〳$/, '', dataType) : dataType;
        switch (dataTypeʹ) {
          case ːID_Int_Seq:
            return coldef(field, 'serial') + `, PRIMARY KEY ("${field}")`;
          case ːStr:
            return coldef(field, 'text' + notNull);
          case ːInt:
            return coldef(field, 'integer' + notNull);
          case ːBigInt:
            return coldef(field, 'bigint' + notNull);
          case ːFloat:
            return coldef(field, 'float' + notNull);
          case ːBool:
            return coldef(field, 'boolean' + notNull);
          case ːDate:
            return coldef(field, 'date' + notNull);
          case ːDateTime:
            return coldef(field, 'timestamp with time zone' + notNull);
          default:
            throw new PSE(`unsupported data type '${dataType}'`);
        }
      }));
      return flatten(res);
    };
    makeTables = function() {
      var entity, entityK, fields, tables;
      tables = [];
      for (entityK in model) {
        fields = model[entityK];
        if (entityK === '$config') {
          continue;
        }
        entity = model[entityK];
        tables.push(`CREATE TABLE "public".${ent(entityK)} (\n	${join(',\n\t', makeColumns(entity.fields))}\n);`);
      }
      return tables;
    };
    dropTables = function() {
      return $(model, omit(['$config']), keys, map(function(k) {
        return `DROP TABLE IF EXISTS ${ent(k, model)} CASCADE;`;
      }));
    };
    //##### ENTITY #################################################################
    makeEntity = function(query) {
      return ent(query.entity);
    };
    //##### FIELDS #################################################################
    toAgg = function([k, v]) {
      return `${v}(${col(k)})`;
    };
    makeFields = function(query) {
      var aggFields;
      if (query.aggregates) {
        aggFields = $(query.aggregates, toPairs, map(toAgg));
        return union(map(col, query.groupBy), aggFields);
      } else {
        return $(query.allFields, map(col), join(', '));
      }
    };
    //##### WHERE ##################################################################
    ops = {
      eq: '=',
      ne: '<>',
      gt: '>',
      gte: '>=',
      lt: '<',
      lte: '<=',
      in: 'IN',
      like: 'LIKE',
      ilike: 'ILIKE',
      notlike: 'NOT LIKE',
      notilike: 'NOT ILIKE'
    };
    REPLACE = '¨!¨¨%¨&¨';
    // https://github.com/brianc/node-postgres/wiki/FAQ#11-how-do-i-build-a-where-foo-in--query-to-find-rows-matching-an-array-of-values
    toOpAndValOld = function(op, v) {
      return op === 'in' && `= ANY (${map(val, v)})` || `${ops[op]} ${val(v)}`;
    };
    toOpAndVal = function(op, v) {
      return op === 'in' && `= ANY (${REPLACE})` || `${ops[op]} ${REPLACE}`;
    };
    toPred = curry(function(kesc, [op, v]) {
      return `${kesc} ${toOpAndVal(op, v)}`;
    });
    toPreds = function([kesc, v]) {
      return $(v, toPairs, map(toPred(kesc)));
    };
    makePreds = function({where}, vals = []) {
      var AND, OR, i, idx, k, len, op, preds, predsStr, predsStrDollar, ref, v, valu;
      ({AND, OR} = where);
      if (AND) {
        return [
          `${(makePreds({
            where: AND[0]
          },
          vals)[0])} AND ${(makePreds({
            where: AND[1]
          },
          vals)[0])}`,
          vals
        ];
      } else if (OR) {
        return [
          `(${(makePreds({
            where: OR[0]
          },
          vals)[0])} OR ${(makePreds({
            where: OR[1]
          },
          vals)[0])})`,
          vals
        ];
      } else {
        preds = [];
        idx = vals.length + 1;
        for (k in where) {
          v = where[k];
          preds.push(toPreds([col(k), v], vals.length));
          ref = $(v, toPairs);
          for (i = 0, len = ref.length; i < len; i++) {
            [op, valu] = ref[i];
            vals.push(valu);
          }
        }
        predsStr = $(preds, flatten, join(' AND '));
        predsStrDollar = predsStr.replace(new RegExp(REPLACE, 'g'), function() {
          return '$' + idx++;
        });
        return [predsStrDollar, vals];
      }
    };
    //##### GROUP BY ###############################################################
    makeGrouping = function(query) {
      if (query.groupBy) {
        return $(query.groupBy, map(col));
      } else {
        return null;
      }
    };
    //##### SORT BY ################################################################
    makeSorting = function(query) {
      if (query.sortBy) {
        return $(query.sortBy, map(col));
      } else {
        return null;
      }
    };
    return {
      //##############################################################################
      createTables: function() {
        return join('\n', makeTables());
      },
      dropTables: function() {
        return join('\n', dropTables());
      },
      dev: {
        makePreds: makePreds
      },
      read: function(fatQuery, safeGuard) {
        var entity, fields, grouping, predsSql, predsVals, res, sorting;
        entity = makeEntity(fatQuery);
        fields = makeFields(fatQuery);
        res = `SELECT ${fields} FROM ${entity}`;
        [predsSql, predsVals] = makePreds(fatQuery);
        if (predsSql) {
          res += ` WHERE ${predsSql}${(safeGuard ? ` AND ${safeGuard}` : '')}`;
        } else if (safeGuard) {
          res += ` WHERE ${safeGuard}`;
        }
        sorting = makeSorting(fatQuery);
        if (sorting) {
          res += ` ORDER BY ${sorting}`;
        }
        grouping = makeGrouping(fatQuery);
        if (grouping) {
          res += ` GROUP BY ${grouping}`;
        }
        return [res, predsVals];
      },
      create: function(fatQuery) {
        // DEPRECATED?!
        return `INSERT INTO ${ent(fatQuery.entity)} (${$(fatQuery.values, keys, map(col), join(', '))}) VALUES (${$(fatQuery.values, values, map(val), join(', '))}) RETURNING ${$(model[fatQuery.entity].fields, keys, map(col), join(', '))};`;
      },
      insert: function({entity, values}) {
        validateKeys({entity, values});
        return [`INSERT INTO ${ent(entity)} (${$(values, keys, map(col), join(', '))}) VALUES (${$(values, keys, length, add(1), range(1), map(dollar), join(', '))}) RETURNING id;`, R.values(values)];
      },
      update: function({entity, id, values, safeGuard}) {
        validateKeys({entity, values});
        if (isNil(id)) {
          throw new Error("POPSIQL: id cannot be nil in update call");
        }
        return [
          `UPDATE ${ent(entity)} SET ${$(values,
          toPairs,
          mapI(function([k,
          v],
          idx) {
            return col(k) + ` = $${idx + 1}`;
          }),
          join(', '))} WHERE id=$${$(values,
          R.values,
          length,
          add(1))}${safeGuard || ''};`,
          $(values,
          R.values,
          append(id))
        ];
      },
      delete: function({entity, id, safeGuard}) {
        validateKeys({entity});
        if (isNil(id)) {
          throw new Error("POPSIQL: id cannot be nil in delete call");
        }
        return [`DELETE FROM ${ent(entity)} WHERE id=$1${safeGuard || ''};`, [id]];
      },
      resetIndex: function(entity) {
        return `SELECT setval((SELECT pg_get_serial_sequence('${ent(entity)}', 'id')), (SELECT max(id) FROM ${ent(entity)}));`;
      }
    };
  };

  validateKeys = function(o) {
    var k, results, v;
    results = [];
    for (k in o) {
      v = o[k];
      if (isNil(v)) {
        throw new Error(`POPSIQL: ${k} cannot be nil`);
      } else {
        results.push(void 0);
      }
    }
    return results;
  };

}).call(this);
