clone = require('ramda/src/clone'); concat = require('ramda/src/concat'); contains = require('ramda/src/contains'); curry = require('ramda/src/curry'); difference = require('ramda/src/difference'); empty = require('ramda/src/empty'); equals = require('ramda/src/equals'); filter = require('ramda/src/filter'); groupBy = require('ramda/src/groupBy'); has = require('ramda/src/has'); head = require('ramda/src/head'); isEmpty = require('ramda/src/isEmpty'); isNil = require('ramda/src/isNil'); keys = require('ramda/src/keys'); length = require('ramda/src/length'); map = require('ramda/src/map'); match = require('ramda/src/match'); merge = require('ramda/src/merge'); nth = require('ramda/src/nth'); pick = require('ramda/src/pick'); pluck = require('ramda/src/pluck'); prop = require('ramda/src/prop'); replace = require('ramda/src/replace'); sortBy = require('ramda/src/sortBy'); test = require('ramda/src/test'); type = require('ramda/src/type'); union = require('ramda/src/union'); uniq = require('ramda/src/uniq'); update = require('ramda/src/update'); values = require('ramda/src/values'); where = require('ramda/src/where'); without = require('ramda/src/without'); #auto_require: srcramda
{changeM, mapO, func, $, PromiseProps, sf0, sf2} = RE = require 'ramda-extras' #auto_require: ramda-extras
[ːObject, ːCOUNT, ːid, ːUndefined, ːMIN, ːMAX, ːSUM, ːAVG] = ['Object', 'COUNT', 'id', 'Undefined', 'MIN', 'MAX', 'SUM', 'AVG'] #auto_sugar
qq = (f) -> console.log match(/return (.*);/, f.toString())[1], f()
qqq = (...args) -> console.log ...args
_ = (...xs) -> xs

{AND, _, PVE, NYIE} = utils = require './utils'


AGGREGATES = [ːCOUNT, ːSUM, ːAVG, ːMIN, ːMAX]

validateANDOR = (query, fieldsClause) ->
	if 1 < $ fieldsClause, keys, length then throw new PVE 'AND/OR needs to be the only key in object'
	andOr = fieldsClause.AND || fieldsClause.OR
	if 'Array' != type andOr then throw new PVE query, 'args of AND/OR need to be array'
	if 2 != length andOr then throw new PVE query, 'array of AND/OR needs to have exactly 2 items'

# Extracts a where object from a fieldsClause and validates it
# Note: no simplification of ANDs, use AND function when combining instead
_extractWhere = curry (query, fieldsClause) -> 
	if isNil fieldsClause then return {}
	ew = _extractWhere query
	if fieldsClause.AND
		validateANDOR query, fieldsClause
		return {AND: [ew(fieldsClause.AND[0]), ew(fieldsClause.AND[1])]}

	if fieldsClause.OR
		validateANDOR query, fieldsClause
		return {OR: [ew(fieldsClause.OR[0]), ew(fieldsClause.OR[1])]}

	where = {}
	for k, v of fieldsClause
		if k == 'ː' + v then continue

		kʹ = replace /〳.*/, '', k
		vʹ = if type(v) == 'Object' then v else {eq: v} # implicit eq
		where[kʹ] = vʹ

	return where

_extractWriteFields = (model, query, entity, writeFields) ->
	res = {}
	for k, v of writeFields
		if ! has k, model[entity].fields
			throw new PVE query, "#{k} not valid field in entity #{entity}"
		res[k] = v

	return res

# TODO: Ta bort?
isAggregate = (fieldsClause) ->
	for k, v of fieldsClause
		if test /〳COUNT|〳SUM|〳AVG|〳MIN|〳MAX/, k then return true

	return false

resolveFields = (fieldsClause) ->
	_and = fieldsClause.AND
	_or = fieldsClause.OR
	if _and then union resolveFields(_and[0]), resolveFields(_and[1])
	else if _or then union resolveFields(_or[0]), resolveFields(_or[1])
	else $ fieldsClause, keys, map(replace(/^ː/, '')), map(replace(/〳.*/, ''))

tryResolveFields = (query, fieldsClause) ->
	try resolveFields fieldsClause
	catch err then throw new PVE query, "invalid fieldsClause #{sf0 fieldsClause}"

_extractSortBy = (fieldsClause) ->
	RE = /^ː?(.*)〳(\d+)/
	ks = $ fieldsClause, keys, filter(test(RE)), map (k) ->
		[___, field, i] = match RE, k
		return [field, parseInt(i)]
	return $ ks, sortBy(nth(1)), map(nth(0))

_extractGroupBy = (fieldsClause) ->
	RE = /^ː?(.*)〳GROUP(\d+)/
	ks = $ fieldsClause, keys, filter(test(RE)), map (k) ->
		[___, field, i] = match RE, k
		return [field, parseInt(i)]
	return $ ks, sortBy(nth(1)), map(nth(0))

_extractAggregates = (query, fieldsClause) ->
	RE = /^ː?(.*)〳(.*)/
	res = {}
	for k,v of fieldsClause
		kʹ = $ k, replace(/〳\d+/, ''), replace(/〳GROUP\d+/, '')
		[___, field, agg] = match RE, kʹ
		if agg
			if ! contains agg, AGGREGATES then throw new PVE query, "Invalid aggregate function: #{agg}"
			else res[field] = agg
	return res

fieldsClauseAndChildren = (query, node) ->
	if node.body == 0
		[fieldsClause, children] = [{}, undefined]
	else if equals {}, node.body
		[fieldsClause, children] = [{}, undefined]
	else
		if type(node.body) != 'Array' then throw new PVE query, "the body of #{node.key} is not an array, 0 or {}"
		[fieldsClause, children] = node.body

	if !fieldsClause then throw new PVE query, "the body of #{node.key} is missing a fields clause"
	if type(fieldsClause) != 'Object'
		throw new PVE query, "the fields clause of #{node.key} is not an object"

	return [fieldsClause, children]


# Recursivly expands and validates nodes doing all work that's possible without executing a query.
# The point is to offload work from runNode so that function doesn't become to big.
# Returns an intermediate representation of the query that can be used by runQuery.
expandNode = ({query, model, parent, node}) ->
	relAndSubParent = (k) -> [ model[parent.entity].rels[k], model[parent.entity].subs[k] ]

	res = {}
	if isNil parent
		def = model[node.key]
		if isNil def then throw new PVE query, "no entity #{node.key} in model"
	else 
		[rel, sub] = relAndSubParent node.key
		def = rel || sub
		if isNil def then new PVE query, "no relationship or subquery #{node.key} on #{parent.entity}"

	# ENTITY & KEY & PARENT
	res.entity = def.entity
	res.key = node.key
	res.parent = if parent then parent.entity else null
	res.onlyOne = if node.onlyOne then true else false
	relAndSub = (k) -> [ model[res.entity].rels[k], model[res.entity].subs[k] ]

	# FIELDS CLAUSE & CHILDREN
	[fieldsClause, children] = fieldsClauseAndChildren query, node
	for ckey, cbody of children
		[rel, sub] = relAndSub ckey
		relsub = rel || sub
		if !relsub then throw new PVE query, "no rel or sub #{ckey} in entity #{res.entity}"
		else if relsub.aggregates
			if relsub.groupBy
				if ! equals {}, cbody
					throw new PVE query, "rel or sub #{ckey} is aggregate with group by, your fieldsClause
					should be {}, not #{cbody}"
			else
				if cbody != 0
					throw new PVE query, "rel or sub #{ckey} is aggregate, your fieldsClause
					should be 0, not #{cbody}"


	# FIELDS
	fields = tryResolveFields query, fieldsClause
	fieldsDiff = $ model[res.entity].fields, keys, difference(fields)
	if ! isEmpty fieldsDiff then throw new PVE query, "invalid fields '#{fieldsDiff}' on '#{node.key}'"
	if def.isAgg
		fields = concat fields, $ def.original, values, head, head, keys, map replace(/^ː/, '')
	res.fields = fields

	# ALL FIELDS =
	# fields from query
	# + fields for parent relationship if needed (fields for child handled further down)
	# + always include the id field
	# + fields siblings depend on
	# + fields children depend on (handled further down)
	allFields = clone fields
	if def.isRel
		[parentProp, relProp] = def.on
		allFields.push relProp
	else if def.isSub && def.rel
		[reldef] = relAndSubParent def.rel
		[parentProp, relProp] = reldef.on
		allFields.push relProp
	if ! contains ːid, allFields then allFields.unshift ːid

	if node.siblings
		for skey in node.siblings
			[rel, sub] = relAndSubParent skey
			if sub && sub.funArgs && sub.funArgs[node.key]
				allFields = union allFields, keys sub.funArgs[node.key]

	res.allFields = allFields

	# WHERE =
	# where from query 
	# + from model for object subs
	# + dynamicly calculated part of where (handled in runQuery)
	where = _extractWhere query, fieldsClause
	if def.isSub && def.subType == 'object'
		where = utils.AND where, def.where
	res.where = where

	# SORT BY
	sortByFields = _extractSortBy fieldsClause
	if !isEmpty sortByFields then res.sortBy = sortByFields

	# AGGREGATIONS
	if def.isSub && def.aggregates
		# NOTE: kanske läsa detta från modell ist i runQuery
		if ! isEmpty fieldsClause then throw new PVE query, "fieldsClause not empty: #{res.key}"
		else if def.aggregates then res.aggregates = def.aggregates
	else
		aggregates = _extractAggregates query, fieldsClause
		if !isEmpty aggregates then res.aggregates = aggregates

	# GROUP BY
	# group from query
	# OR from model for object subs directly (when model has group by)
	# OR from model for object subs indirectly (when model has aggregation)
	# if parent
	# 	if def.isRel
	# 		[parentProp, relProp] = def.on
	# 		res.groupBy = [relProp]
	# 	else if def.isSub
	# 		if def.subType == 'object'
	# 			[reldef] = relAndSubParent def.rel
	# 			[parentProp, relProp] = reldef.on
	# 			res.groupBy = [relProp]
	# else
	if def.isSub
		if def.groupBy
			# NOTE: kanske läsa detta från modell ist i runQuery
			if ! equals {}, fieldsClause
				throw new PVE query, "fieldsClause not empty for sub #{res.key}"
			else
				if def.groupBy then res.groupBy = def.groupBy
		else if def.aggregates && def.subType == 'object'
			[rel] = relAndSubParent def.rel
			[parentProp, relProp] = rel.on
			res.groupBy = [relProp]
	else
		groupByFields = _extractGroupBy fieldsClause
		if !isEmpty groupByFields then res.groupBy = groupByFields

	if isNil children then return res

	# CHILDREN
	# Ordered in execution order based on their sibling dependencies.
	# Note that we have to add children not directly included in the query if the children
	# that are included in the query depends on them (=hidden children).
	childrenToOrder = keys children
	orderedChildren = []
	lap = 0
	while ! isEmpty difference childrenToOrder, orderedChildren
		newChildrenToResolve = []
		for ckey in childrenToOrder
			[rel, sub] = relAndSub ckey
			if rel # rels never has deps so can always be added directly
				orderedChildren.push ckey
			else if sub
				if sub.siblingDeps
					newChildrenToResolve.push sub.siblingDeps...
					if isEmpty difference sub.siblingDeps, orderedChildren
						orderedChildren.push ckey
				else
					orderedChildren.push ckey # subs without deps can be added directly

		childrenToOrder = difference union(childrenToOrder, newChildrenToResolve), orderedChildren

		if lap++ > 10 then throw new PVE query, "cannot resolve children #{sf2 childrenToOrder}"

	# HIDDEN CHILDREN = Children not included in query but needed to run the query
	# 									(eg. children depended on by other children which are included in query)
	hiddenChildren = difference orderedChildren, keys children
	# hiddenChildrenDefaults = fmap hiddenChildren, (ckey) ->

	# ALL FIELDS ...continued
	# + fields children depend on
	for ckey in orderedChildren
		[rel, sub] = relAndSub ckey
		if rel
			[parentProp, childProp] = rel.on
			res.allFields = union res.allFields, [parentProp]
		else if sub && !isEmpty sub.parentFieldDeps
			res.allFields = union res.allFields, sub.parentFieldDeps

	# EXPAND CHILDREN
	expandedChildren = $ orderedChildren, map (ckey) ->
		if contains ckey, hiddenChildren
			isHidden = true
			# if its a hidden child, we need to create a default body
			[rel, sub] = relAndSub ckey
			if rel then body = {}
			if sub
				if sub.isAggregate then body = 0
				else body = {}
		else
			body = children[ckey]

		siblings = without [ckey], orderedChildren
		childRes = expandNode {query, model, parent: res, node: {key: ckey, body, siblings}}
		if isHidden then childRes.isHidden = true
		return childRes
	res.children = expandedChildren

	return res
		

# Writes data to a store (pointer) in a "good" way based on what kind of node
# the query was run for
_writeChildRes = curry (model, pointer, norm, node, data) ->
	# qq -> [model, pointer, node, data]
	def = _defFor model, node
	if def.isRel
		# qq -> def
		data2 = data

		pointer[node.key] = $ data2, groupBy prop def.on[1]
	else if def.isSub
		if def.subType == 'function'
			[id, val] = data
			pointer[node.key] ?= {}
			pointer[node.key][id] = val

		else
			reldef = _defForSibling model, node, def.rel
			[parentProp, relProp] = reldef.on
			if node.groupBy
				if !def.groupBy
					# group by created dynamically => group in childRes to
					tmp = {}
					for x in data
						tmp[x[relProp]] = x.value
					pointer[node.key] = tmp

				else throw new NYIE
			else
				pointer[node.key] = $ data, groupBy prop relProp

# The inverse of _writeChildRes, ie. reads data from a store based on the
# same logic but opposite
_readChildRes = curry (model, pointer, node, parent) ->
	def = _defFor model, node
	if def.isRel
		return pointer[node.key][parent[def.on[0]]]
	else
		if def.subType == 'function'
			return pointer[node.key][parent.id]
		else
			reldef = _defForSibling model, node, def.rel
			[parentProp, relProp] = reldef.on
			if node.groupBy
				if !def.groupBy
					# group by created dynamically => group in childRes to
					return pointer[node.key][parent[parentProp]]

				else throw new NYIE
			else
				return pointer[node.key][parent[parentProp]]

# Helper to create the dynamic part of the where for a rel given some parent result data
_extractRelWhere = (reldef, data) ->
	[parentProp, relProp] = reldef.on
	return {[relProp]: {in: $ data, pluck(parentProp), uniq}}

# Helper for getting the definition for a node
_defFor = curry (model, node) ->
	if isNil node.parent then model[node.entity]
	else
		rel = model[node.parent].rels[node.key]
		sub = model[node.parent].subs[node.key]
		return rel || sub

# Helper for getting the definition for a sibling to a node
_defForSibling = curry (model, child, key) ->
	rel = model[child.parent].rels[key]
	sub = model[child.parent].subs[key]
	return rel || sub

emptyIfNil = (x, isObj = false) ->
	if isNil x
		if isObj then null else []
	else x

# Building the "argList" for invoking sub functions
_extractArgList = (model, cres, pres, node, siblings) ->
	def = _defFor model, node
	argList = []
	for i of pres
		pr = pres[i]
		# force the id for easier read/write to childResult later
		argList[i] = pick union(['id'], def.parentFieldDeps), pr
		for s in def.siblingDeps
			sib = siblings[s]
			data = _readChildRes model, cres, sib, pr
			if sib.groupBy
				argList[i][s] = data
			else
				if 'Object' == type def.funArgs[s]
					# Note: this is the somewhat special behaviour of sub functions
					tmp = {}
					for k in keys def.funArgs[s]
						tmp[k] = pluck k, data
					argList[i][s] = tmp
				else
					argList[i][s] = data

	return argList

_dataToRes = (model) -> (data) ->
	res = {}
	for k, v of data
		res[model.$config.colToProp(k)] = v
	return res


returnResult = (query, node, res) ->
	if node.onlyOne
		if 1 < length res
			throw new PVE query, 'Your 1 query returned multiple results'
		else res[0]
	else res


# Recursively running a node (calling exec with it).
# Note that this also prepares the dynamic part of WHEREs for rels and subs based
# on the result of the parent.
# Also note that this also prepares and handles the calling of sub functions to prepare the
# the dynamic part of WHEREs for sub functions.
runNode = ({model, exec, query, norm}) -> (node) ->
	runNodeAgain = runNode {model, exec, query, norm}
	defFor = _defFor model

	res_ = await exec node
	res = $ res_, map _dataToRes(model)

	for r in res
		mergeToNorm node.entity, clone(r), norm
	if !node.children then return returnResult query, node, res

	def = defFor node
	cres = {}
	writeChildRes = _writeChildRes model, cres, norm
	siblings = {}
	for _c in node.children
		c = clone _c
		siblings[c.key] = c
		cdef = defFor c

		if cdef.isRel
			if isEmpty res then writeChildRes c, []
			else
				relWhere = _extractRelWhere cdef, res
				c.where = AND c.where, relWhere
				relRes = await runNodeAgain c
				writeChildRes c, relRes

		else if cdef.isSub
			if cdef.rel
				if isEmpty res
					writeChildRes c, []
					continue
				else
					c.where = AND c.where, _extractRelWhere def.rels[cdef.rel], res

			if cdef.subType == 'object'
				res123 = await runNodeAgain c
				writeChildRes c, res123
				# writeChildRes c, await runNodeAgain c

			else if cdef.subType == 'function'
				argList = _extractArgList model, cres, res, c, siblings

				try
					argListRes = $ argList, map (args) -> cdef.fun(args)
				catch err
					console.error err
					throw new PVE query, "error when executing sub function for #{c.key} with argList #{sf0 argList}"

				funRes = await Promise.all $ argListRes, map (query) ->
					body = $ query, values, head
					fieldsClause = body[0]
					funWhere = _extractWhere {}, fieldsClause
					return await runNodeAgain merge c, {where: AND c.where, funWhere}

				# using the index for sub function results for easier reads later
				for i of funRes
					fr = funRes[i]
					id = argList[i].id
					writeChildRes c, [id, fr]

	# Build the result
	readChildRes = _readChildRes model, cres
	for r in res
		for c in node.children
			if c.isHidden then continue
			childRes = readChildRes c, r
			rescdef = _defFor model, c

			childRes2 = childRes
			if test(/One$/, rescdef.multiplicity) && type(childRes) == 'Array'
				if length(childRes) == 0 then childRes2 = {}
				else if length(childRes) == 1 then childRes2 = childRes[0]
				else if length(childRes) > 1
					throw new PVE "Query gave multiple results for relation #{c.key} on parent #{c.parent}:
					#{sf2 childRes}"

			isObj = test /One$/, rescdef.multiplicity

			r[c.key] = emptyIfNil childRes2, isObj

	return returnResult query, node, res

runNodeSync = ({model, exec, query, norm}) -> (node) ->
	runNodeAgain = runNodeSync {model, exec, query, norm}
	defFor = _defFor model

	res_ = exec node
	res = $ res_, map _dataToRes(model)

	for r in res
		mergeToNorm node.entity, clone(r), norm
	if !node.children then return returnResult query, node, res

	def = defFor node
	cres = {}
	writeChildRes = _writeChildRes model, cres, norm
	siblings = {}
	for _c in node.children
		c = clone _c
		siblings[c.key] = c
		cdef = defFor c

		if cdef.isRel
			if isEmpty res then writeChildRes c, []
			else
				relWhere = _extractRelWhere cdef, res
				c.where = AND c.where, relWhere
				test1234 = runNodeAgain c
				writeChildRes c, test1234

		else if cdef.isSub
			if cdef.rel
				if isEmpty res
					writeChildRes c, []
					continue
				else
					c.where = AND c.where, _extractRelWhere def.rels[cdef.rel], res

			if cdef.subType == 'object'
				res123 = runNodeAgain c
				writeChildRes c, res123
				# writeChildRes c, await runNodeAgain c

			else if cdef.subType == 'function'
				argList = _extractArgList model, cres, res, c, siblings

				try
					argListRes = $ argList, map (args) -> cdef.fun(args)
				catch err
					console.error err
					throw new PVE query, "error when executing sub function for #{c.key} with argList #{sf0 argList}"

				funRes = $ argListRes, map (query) ->
					body = $ query, values, head
					fieldsClause = body[0]
					funWhere = _extractWhere {}, fieldsClause
					return runNodeAgain merge c, {where: AND c.where, funWhere}

				# using the index for sub function results for easier reads later
				for i of funRes
					fr = funRes[i]
					id = argList[i].id
					writeChildRes c, [id, fr]

	# Build the result
	readChildRes = _readChildRes model, cres
	for r in res
		for c in node.children
			if c.isHidden then continue
			childRes = readChildRes c, r
			rescdef = _defFor model, c

			childRes2 = childRes
			if test(/One$/, rescdef.multiplicity) && type(childRes) == 'Array'
				if length(childRes) == 0 then childRes2 = {}
				else if length(childRes) == 1
					childRes2 = childRes[0]
				else if length(childRes) > 1
					throw new PVE "Query gave multiple results for relation #{c.key} on parent #{c.parent}:
					#{sf2 childRes}"

			isObj = test /One$/, rescdef.multiplicity

			r[c.key] = emptyIfNil childRes2, isObj

	return returnResult query, node, res

mergeToNorm = (entity, o, norm) ->
	norm[entity] ?= {}
	if isNil o.id then throw new Error 'o misses id'
	if norm[entity][o.id] then norm[entity][o.id] = merge norm[entity][o.id], o
	else norm[entity][o.id] = o




expandQuery = (model, query) ->
	if isNil model then throw new PVE 'model cannot be nil'
	if isNil query then throw new PVE 'query cannot be nil'
	# TODO: only handling simple queries now, ie. only one root which is entity
	return $ query, mapO (body, key) ->
		if test /1$/, key
			cleanKey = replace /1$/, '', key
			expandNode {model, query, parent: null, node: {key: cleanKey, body, onlyOne: true}}
		else
			expandNode {model, query, parent: null, node: {key, body}}

expandWrite = (model, query) ->
	if isNil model then throw new PVE 'model cannot be nil'
	if isNil query then throw new PVE 'query cannot be nil'
	# TODO: only handling simple queries now, ie. only one root which is entity

	if 1 < $ query, keys, length then throw new NYIE

	entity = $ query, keys, head
	if isNil model[entity] then throw new PVE query, "#{entity} not an entity in model"

	writeFields = _extractWriteFields model, query, entity, query[entity]

	return {entity, values: writeFields}


runQuery = (model, exec, query) ->
	if isNil model then throw new PVE 'model cannot be nil'
	if isNil query then throw new PVE 'query cannot be nil'
	fatQuery = expandQuery model, query

	norm = {}

	res = await PromiseProps $ fatQuery, mapO (node, key) ->
		runNode({model, query, exec, norm})(node)

	if 1 < $ query, keys, length then throw new NYIE

	firstRes = $ res, values, head
	return [firstRes, norm]

runFatQuery = (model, exec, fatQuery, query) ->
	if isNil model then throw new PVE 'model cannot be nil'
	if isNil fatQuery then throw new PVE 'fatQuery cannot be nil'
	if isNil query then throw new PVE 'query cannot be nil'

	norm = {}

	res = await PromiseProps $ fatQuery, mapO (node, key) ->
		runNode({model, query, exec, norm})(node)

	if 1 < $ query, keys, length then throw new NYIE

	firstRes = $ res, values, head
	return [firstRes, norm]

runFatQuerySync = (model, exec, fatQuery, query) ->
	if isNil model then throw new PVE 'model cannot be nil'
	if isNil fatQuery then throw new PVE 'fatQuery cannot be nil'
	if isNil query then throw new PVE 'query cannot be nil'

	norm = {}

	res = $ fatQuery, mapO (node, key) ->
		runNodeSync({model, query, exec, norm})(node)

	if $ query, keys, length, equals 1 then ret = $ res, values, head
	else ret = res

	return [ret, norm]

# Validates delta, normalizes writes (Creates, Updates, Deletes) and calls exec.
# Note: if we'd have foreign keys, we'd have to do some fancy ordering based on if its C or D...
runDelta = func
	model: Object # model as returned from createModel
	exec: ({entity, id, delta}) -> # callback (you determine if it's Create, Update or Delete), you can return a spec for serverDelta
	delta: Object
, ({model, exec, delta}) ->
	serverDelta = {}
	for entity, items of delta
		if ːObject != type items then throw new PVE "invalid items #{type items} in delta"
		if isNil model[entity] then throw new PVE "#{entity} not an entity in model"

		for id, entityDelta of items
			if type(entityDelta) != ːObject && type(entityDelta) != ːUndefined
				throw new PVE "invalid values #{type entityDelta} in delta for entity #{entity}"
			for k, v of entityDelta
				if ! has k, model[entity].fields then throw new PVE "#{entity} does not have field #{k}"

			if id < 0 then op = 'create'
			else if entityDelta == undefined then op = 'delete'
			else op = 'update'

			res = await exec {entity, id, op, delta: entityDelta}
			serverDelta = changeM res, serverDelta

	return serverDelta

normalize = (model, data) ->
	res = {}
	for entity, entityData of data
		res[entity] = {}




module.exports = {
	runQuery
	runFatQuery
	runFatQuerySync
	runDelta
	expandQuery
	expandWrite
	normalize
	_extractSortBy
	_extractGroupBy
	_extractAggregates
	_extractWhere
	fieldsClauseAndChildren
	isAggregate
}





