add = require('ramda/src/add'); append = require('ramda/src/append'); call = require('ramda/src/call'); contains = require('ramda/src/contains'); curry = require('ramda/src/curry'); flatten = require('ramda/src/flatten'); isNil = require('ramda/src/isNil'); join = require('ramda/src/join'); keys = require('ramda/src/keys'); length = require('ramda/src/length'); map = require('ramda/src/map'); match = require('ramda/src/match'); max = require('ramda/src/max'); omit = require('ramda/src/omit'); range = require('ramda/src/range'); replace = require('ramda/src/replace'); test = require('ramda/src/test'); toPairs = require('ramda/src/toPairs'); toUpper = require('ramda/src/toUpper'); type = require('ramda/src/type'); union = require('ramda/src/union'); update = require('ramda/src/update'); values = require('ramda/src/values'); where = require('ramda/src/where'); #auto_require: srcramda
R = require 'ramda'
{mapI, toPair, $} = RE = require 'ramda-extras' #auto_require: ramda-extras
[ːStr, ːDate, ːBool, ːID_Int_Seq, ːFloat, ːBigInt, ːDateTime, ːInt] = ['Str', 'Date', 'Bool', 'ID_Int_Seq', 'Float', 'BigInt', 'DateTime', 'Int'] #auto_sugar
qq = (f) -> console.log match(/return (.*);/, f.toString())[1], f()
qqq = (...args) -> console.log ...args
_ = (...xs) -> xs

utils = require './utils'
query = require './query'

PSE = utils.customError 'PopsiqlSQLError'

module.exports = (model) ->

	###### HELPERS ################################################################
	# https://www.postgresql.org/docs/8.1/sql-keywords-appendix.html
	# All except "non-reserved" from list
	keywords = ['A', 'ABS', 'ADA', 'ALIAS', 'ALL', 'ALLOCATE', 'ALWAYS', 'ANALYSE', 'ANALYZE', 'AND', 'ANY', 'ARE', 'ARRAY', 'AS', 'ASC', 'ASENSITIVE', 'ASYMMETRIC', 'ATOMIC', 'ATTRIBUTE', 'ATTRIBUTES', 'AUTHORIZATION', 'AVG', 'BERNOULLI', 'BETWEEN', 'BINARY', 'BITVAR', 'BIT_LENGTH', 'BLOB', 'BOTH', 'BREADTH', 'C', 'CALL', 'CARDINALITY', 'CASCADED', 'CASE', 'CAST', 'CATALOG', 'CATALOG_NAME', 'CEIL', 'CEILING', 'CHARACTERS', 'CHARACTER_LENGTH', 'CHARACTER_SET_CATALOG', 'CHARACTER_SET_NAME', 'CHARACTER_SET_SCHEMA', 'CHAR_LENGTH', 'CHECK', 'CHECKED', 'CLASS_ORIGIN', 'CLOB', 'COBOL', 'COLLATE', 'COLLATION', 'COLLATION_CATALOG', 'COLLATION_NAME', 'COLLATION_SCHEMA', 'COLLECT', 'COLUMN', 'COLUMN_NAME', 'COMMAND_FUNCTION', 'COMMAND_FUNCTION_CODE', 'COMPLETION', 'CONDITION', 'CONDITION_NUMBER', 'CONNECT', 'CONNECTION_NAME', 'CONSTRAINT', 'CONSTRAINT_CATALOG', 'CONSTRAINT_NAME', 'CONSTRAINT_SCHEMA', 'CONSTRUCTOR', 'CONTAINS', 'CONTINUE', 'CORR', 'CORRESPONDING', 'COUNT', 'COVAR_POP', 'COVAR_SAMP', 'CREATE', 'CROSS', 'CUBE', 'CUME_DIST', 'CURRENT', 'CURRENT_DATE', 'CURRENT_DEFAULT_TRANSFORM_GROUP', 'CURRENT_PATH', 'CURRENT_ROLE', 'CURRENT_TIME', 'CURRENT_TIMESTAMP', 'CURRENT_TRANSFORM_GROUP_FOR_TYPE', 'CURRENT_USER', 'CURSOR_NAME', 'DATA', 'DATE', 'DATETIME_INTERVAL_CODE', 'DATETIME_INTERVAL_PRECISION', 'DEFAULT', 'DEFERRABLE', 'DEFINED', 'DEGREE', 'DENSE_RANK', 'DEPTH', 'DEREF', 'DERIVED', 'DESC', 'DESCRIBE', 'DESCRIPTOR', 'DESTROY', 'DESTRUCTOR', 'DETERMINISTIC', 'DIAGNOSTICS', 'DICTIONARY', 'DISCONNECT', 'DISPATCH', 'DISTINCT', 'DO', 'DYNAMIC', 'DYNAMIC_FUNCTION', 'DYNAMIC_FUNCTION_CODE', 'ELEMENT', 'ELSE', 'END', 'END-EXEC', 'EQUALS', 'EVERY', 'EXCEPT', 'EXCEPTION', 'EXCLUDE', 'EXEC', 'EXISTING', 'EXP', 'FALSE', 'FILTER', 'FINAL', 'FLOOR', 'FOLLOWING', 'FOR', 'FOREIGN', 'FORTRAN', 'FOUND', 'FREE', 'FREEZE', 'FROM', 'FULL', 'FUSION', 'G', 'GENERAL', 'GENERATED', 'GET', 'GO', 'GOTO', 'GRANT', 'GROUP', 'GROUPING', 'HAVING', 'HIERARCHY', 'HOST', 'IDENTITY', 'IGNORE', 'ILIKE', 'IMPLEMENTATION', 'IN', 'INDICATOR', 'INFIX', 'INITIALIZE', 'INITIALLY', 'INNER', 'INSTANCE', 'INSTANTIABLE', 'INTERSECT', 'INTERSECTION', 'INTO', 'IS', 'ISNULL', 'ITERATE', 'JOIN', 'K', 'KEY_MEMBER', 'KEY_TYPE', 'LATERAL', 'LEADING', 'LEFT', 'LENGTH', 'LESS', 'LIKE', 'LIMIT', 'LN', 'LOCALTIME', 'LOCALTIMESTAMP', 'LOCATOR', 'LOWER', 'M', 'MAP', 'MATCHED', 'MAX', 'MEMBER', 'MERGE', 'MESSAGE_LENGTH', 'MESSAGE_OCTET_LENGTH', 'MESSAGE_TEXT', 'METHOD', 'MIN', 'MOD', 'MODIFIES', 'MODIFY', 'MODULE', 'MORE', 'MULTISET', 'MUMPS', 'NAME', 'NATURAL', 'NCLOB', 'NESTING', 'NEW', 'NORMALIZE', 'NORMALIZED', 'NOT', 'NOTNULL', 'NULL', 'NULLABLE', 'NULLS', 'NUMBER', 'OCTETS', 'OCTET_LENGTH', 'OFF', 'OFFSET', 'OLD', 'ON', 'ONLY', 'OPEN', 'OPERATION', 'OPTIONS', 'OR', 'ORDER', 'ORDERING', 'ORDINALITY', 'OTHERS', 'OUTER', 'OUTPUT', 'OVER', 'OVERLAPS', 'OVERRIDING', 'PAD', 'PARAMETER', 'PARAMETERS', 'PARAMETER_MODE', 'PARAMETER_NAME', 'PARAMETER_ORDINAL_POSITION', 'PARAMETER_SPECIFIC_CATALOG', 'PARAMETER_SPECIFIC_NAME', 'PARAMETER_SPECIFIC_SCHEMA', 'PARTITION', 'PASCAL', 'PATH', 'PERCENTILE_CONT', 'PERCENTILE_DISC', 'PERCENT_RANK', 'PLACING', 'PLI', 'POSTFIX', 'POWER', 'PRECEDING', 'PREFIX', 'PREORDER', 'PRIMARY', 'PUBLIC', 'RANGE', 'RANK', 'READS', 'RECURSIVE', 'REF', 'REFERENCES', 'REFERENCING', 'REGR_AVGX', 'REGR_AVGY', 'REGR_COUNT', 'REGR_INTERCEPT', 'REGR_R2', 'REGR_SLOPE', 'REGR_SXX', 'REGR_SXY', 'REGR_SYY', 'RESULT', 'RETURN', 'RETURNED_CARDINALITY', 'RETURNED_LENGTH', 'RETURNED_OCTET_LENGTH', 'RETURNED_SQLSTATE', 'RIGHT', 'ROLLUP', 'ROUTINE', 'ROUTINE_CATALOG', 'ROUTINE_NAME', 'ROUTINE_SCHEMA', 'ROW_COUNT', 'ROW_NUMBER', 'SCALE', 'SCHEMA_NAME', 'SCOPE', 'SCOPE_CATALOG', 'SCOPE_NAME', 'SCOPE_SCHEMA', 'SEARCH', 'SECTION', 'SELECT', 'SELF', 'SENSITIVE', 'SERVER_NAME', 'SESSION_USER', 'SETS', 'SIMILAR', 'SIZE', 'SOME', 'SOURCE', 'SPACE', 'SPECIFIC', 'SPECIFICTYPE', 'SPECIFIC_NAME', 'SQL', 'SQLCODE', 'SQLERROR', 'SQLEXCEPTION', 'SQLSTATE', 'SQLWARNING', 'SQRT', 'STATE', 'STATIC', 'STDDEV_POP', 'STDDEV_SAMP', 'STRUCTURE', 'STYLE', 'SUBCLASS_ORIGIN', 'SUBLIST', 'SUBMULTISET', 'SUM', 'SYMMETRIC', 'SYSTEM_USER', 'TABLE', 'TABLESAMPLE', 'TABLE_NAME', 'TERMINATE', 'THAN', 'THEN', 'TIES', 'TIMEZONE_HOUR', 'TIMEZONE_MINUTE', 'TO', 'TOP_LEVEL_COUNT', 'TRAILING', 'TRANSACTIONS_COMMITTED', 'TRANSACTIONS_ROLLED_BACK', 'TRANSACTION_ACTIVE', 'TRANSFORM', 'TRANSFORMS', 'TRANSLATE', 'TRANSLATION', 'TRIGGER_CATALOG', 'TRIGGER_NAME', 'TRIGGER_SCHEMA', 'TRUE', 'UESCAPE', 'UNBOUNDED', 'UNDER', 'UNION', 'UNIQUE', 'UNNAMED', 'UNNEST', 'UPPER', 'USAGE', 'USER', 'USER_DEFINED_TYPE_CATALOG', 'USER_DEFINED_TYPE_CODE', 'USER_DEFINED_TYPE_NAME', 'USER_DEFINED_TYPE_SCHEMA', 'USING', 'VALUE', 'VARIABLE', 'VAR_POP', 'VAR_SAMP', 'VERBOSE', 'WHEN', 'WHENEVER', 'WHERE', 'WIDTH_BUCKET', 'WINDOW', 'WITHIN']
	# A bit loosened up definition of keywords
	keywordsLoose = ['A', 'ABS', 'ADA', 'ALIAS', 'ALL', 'ALLOCATE', 'ALWAYS', 'ANALYSE', 'ANALYZE', 'AND', 'ANY', 'ARE', 'ARRAY', 'AS', 'ASC', 'ASENSITIVE', 'ASYMMETRIC', 'ATOMIC', 'ATTRIBUTE', 'ATTRIBUTES', 'AUTHORIZATION', 'AVG', 'BERNOULLI', 'BETWEEN', 'BINARY', 'BITVAR', 'BIT_LENGTH', 'BLOB', 'BOTH', 'BREADTH', 'C', 'CALL', 'CARDINALITY', 'CASCADED', 'CASE', 'CAST', 'CATALOG', 'CATALOG_NAME', 'CEIL', 'CEILING', 'CHARACTERS', 'CHARACTER_LENGTH', 'CHARACTER_SET_CATALOG', 'CHARACTER_SET_NAME', 'CHARACTER_SET_SCHEMA', 'CHAR_LENGTH', 'CHECK', 'CHECKED', 'CLASS_ORIGIN', 'CLOB', 'COBOL', 'COLLATE', 'COLLATION', 'COLLATION_CATALOG', 'COLLATION_NAME', 'COLLATION_SCHEMA', 'COLLECT', 'COLUMN', 'COLUMN_NAME', 'COMMAND_FUNCTION', 'COMMAND_FUNCTION_CODE', 'COMPLETION', 'CONDITION', 'CONDITION_NUMBER', 'CONNECT', 'CONNECTION_NAME', 'CONSTRAINT', 'CONSTRAINT_CATALOG', 'CONSTRAINT_NAME', 'CONSTRAINT_SCHEMA', 'CONSTRUCTOR', 'CONTAINS', 'CONTINUE', 'CORR', 'CORRESPONDING', 'COUNT', 'COVAR_POP', 'COVAR_SAMP', 'CREATE', 'CROSS', 'CUBE', 'CUME_DIST', 'CURRENT', 'CURRENT_DATE', 'CURRENT_DEFAULT_TRANSFORM_GROUP', 'CURRENT_PATH', 'CURRENT_ROLE', 'CURRENT_TIME', 'CURRENT_TIMESTAMP', 'CURRENT_TRANSFORM_GROUP_FOR_TYPE', 'CURRENT_USER', 'CURSOR_NAME', 'DATA', 'DATE', 'DATETIME_INTERVAL_CODE', 'DATETIME_INTERVAL_PRECISION', 'DEFAULT', 'DEFERRABLE', 'DEFINED', 'DEGREE', 'DENSE_RANK', 'DEPTH', 'DEREF', 'DERIVED', 'DESC', 'DESCRIBE', 'DESCRIPTOR', 'DESTROY', 'DESTRUCTOR', 'DETERMINISTIC', 'DIAGNOSTICS', 'DICTIONARY', 'DISCONNECT', 'DISPATCH', 'DISTINCT', 'DO', 'DYNAMIC', 'DYNAMIC_FUNCTION', 'DYNAMIC_FUNCTION_CODE', 'ELEMENT', 'ELSE', 'END', 'END-EXEC', 'EQUALS', 'EVERY', 'EXCEPT', 'EXCEPTION', 'EXCLUDE', 'EXEC', 'EXISTING', 'EXP', 'FALSE', 'FILTER', 'FINAL', 'FLOOR', 'FOLLOWING', 'FOR', 'FOREIGN', 'FORTRAN', 'FOUND', 'FREE', 'FREEZE', 'FROM', 'FULL', 'FUSION', 'G', 'GENERAL', 'GENERATED', 'GET', 'GO', 'GOTO', 'GRANT', 'GROUP', 'GROUPING', 'HAVING', 'HIERARCHY', 'HOST', 'IDENTITY', 'IGNORE', 'ILIKE', 'IMPLEMENTATION', 'IN', 'INDICATOR', 'INFIX', 'INITIALIZE', 'INITIALLY', 'INNER', 'INSTANCE', 'INSTANTIABLE', 'INTERSECT', 'INTERSECTION', 'INTO', 'IS', 'ISNULL', 'ITERATE', 'JOIN', 'K', 'KEY_MEMBER', 'KEY_TYPE', 'LATERAL', 'LEADING', 'LEFT', 'LENGTH', 'LESS', 'LIKE', 'LIMIT', 'LN', 'LOCALTIME', 'LOCALTIMESTAMP', 'LOCATOR', 'LOWER', 'M', 'MAP', 'MATCHED', 'MAX', 'MERGE', 'MESSAGE_LENGTH', 'MESSAGE_OCTET_LENGTH', 'MESSAGE_TEXT', 'METHOD', 'MIN', 'MOD', 'MODIFIES', 'MODIFY', 'MODULE', 'MORE', 'MULTISET', 'MUMPS', 'NAME', 'NATURAL', 'NCLOB', 'NESTING', 'NEW', 'NORMALIZE', 'NORMALIZED', 'NOT', 'NOTNULL', 'NULL', 'NULLABLE', 'NULLS', 'NUMBER', 'OCTETS', 'OCTET_LENGTH', 'OFF', 'OFFSET', 'OLD', 'ON', 'ONLY', 'OPEN', 'OPERATION', 'OPTIONS', 'OR', 'ORDER', 'ORDERING', 'ORDINALITY', 'OTHERS', 'OUTER', 'OUTPUT', 'OVER', 'OVERLAPS', 'OVERRIDING', 'PAD', 'PARAMETER', 'PARAMETERS', 'PARAMETER_MODE', 'PARAMETER_NAME', 'PARAMETER_ORDINAL_POSITION', 'PARAMETER_SPECIFIC_CATALOG', 'PARAMETER_SPECIFIC_NAME', 'PARAMETER_SPECIFIC_SCHEMA', 'PARTITION', 'PASCAL', 'PATH', 'PERCENTILE_CONT', 'PERCENTILE_DISC', 'PERCENT_RANK', 'PLACING', 'PLI', 'POSTFIX', 'POWER', 'PRECEDING', 'PREFIX', 'PREORDER', 'PRIMARY', 'PUBLIC', 'RANGE', 'RANK', 'READS', 'RECURSIVE', 'REF', 'REFERENCES', 'REFERENCING', 'REGR_AVGX', 'REGR_AVGY', 'REGR_COUNT', 'REGR_INTERCEPT', 'REGR_R2', 'REGR_SLOPE', 'REGR_SXX', 'REGR_SXY', 'REGR_SYY', 'RESULT', 'RETURN', 'RETURNED_CARDINALITY', 'RETURNED_LENGTH', 'RETURNED_OCTET_LENGTH', 'RETURNED_SQLSTATE', 'RIGHT', 'ROLLUP', 'ROUTINE', 'ROUTINE_CATALOG', 'ROUTINE_NAME', 'ROUTINE_SCHEMA', 'ROW_COUNT', 'ROW_NUMBER', 'SCALE', 'SCHEMA_NAME', 'SCOPE', 'SCOPE_CATALOG', 'SCOPE_NAME', 'SCOPE_SCHEMA', 'SEARCH', 'SECTION', 'SELECT', 'SELF', 'SENSITIVE', 'SERVER_NAME', 'SESSION_USER', 'SETS', 'SIMILAR', 'SIZE', 'SOME', 'SOURCE', 'SPACE', 'SPECIFIC', 'SPECIFICTYPE', 'SPECIFIC_NAME', 'SQL', 'SQLCODE', 'SQLERROR', 'SQLEXCEPTION', 'SQLSTATE', 'SQLWARNING', 'SQRT', 'STATE', 'STATIC', 'STDDEV_POP', 'STDDEV_SAMP', 'STRUCTURE', 'STYLE', 'SUBCLASS_ORIGIN', 'SUBLIST', 'SUBMULTISET', 'SUM', 'SYMMETRIC', 'SYSTEM_USER', 'TABLE', 'TABLESAMPLE', 'TABLE_NAME', 'TERMINATE', 'THAN', 'THEN', 'TIES', 'TIMEZONE_HOUR', 'TIMEZONE_MINUTE', 'TO', 'TOP_LEVEL_COUNT', 'TRAILING', 'TRANSACTIONS_COMMITTED', 'TRANSACTIONS_ROLLED_BACK', 'TRANSACTION_ACTIVE', 'TRANSFORM', 'TRANSFORMS', 'TRANSLATE', 'TRANSLATION', 'TRIGGER_CATALOG', 'TRIGGER_NAME', 'TRIGGER_SCHEMA', 'TRUE', 'UESCAPE', 'UNBOUNDED', 'UNDER', 'UNION', 'UNIQUE', 'UNNAMED', 'UNNEST', 'UPPER', 'USAGE', 'USER', 'USER_DEFINED_TYPE_CATALOG', 'USER_DEFINED_TYPE_CODE', 'USER_DEFINED_TYPE_NAME', 'USER_DEFINED_TYPE_SCHEMA', 'USING', 'VALUE', 'VARIABLE', 'VAR_POP', 'VAR_SAMP', 'VERBOSE', 'WHEN', 'WHENEVER', 'WHERE', 'WIDTH_BUCKET', 'WINDOW', 'WITHIN']
	esc = (s) -> "\"#{s}\""
	escKW = (s) -> if contains toUpper(s), keywordsLoose then esc s else s
	val = (x) ->
		if isNil x then "null"
		else if type(x) == 'Date' then "'#{x.toISOString()}'"
		else if type(x) == 'String' then "'#{x.replace(/'/g, "''")}'"
		else x
	dollar = (x) -> "$#{x}"
	ent = (s) -> escKW model.$config.entityToTable s
	col = (s) -> escKW model.$config.propToCol s

	###### CREATE TABLE ###########################################################
	coldef = curry (k, v) -> "#{col k} #{v}"

	makeColumns = (fields) ->
		res = $ fields, toPairs, map ([field, dataType]) ->
			if 'Object' == type dataType
				[k, v] = toPair dataType
				if test /oneToOne〳?/, k then return [] # not yet implemented
				else if test /oneToMany〳?/, k then return [] # not yet implemented
				else if test /manyToOne〳?/, k then return [] # not yet implemented
				throw new PSE "Object type for key '#{k}' not yet implemented"

			notNull = if test /〳$/, dataType then '' else ' NOT NULL'
			dataTypeʹ = if test /〳$/, dataType then replace /〳$/, '', dataType else dataType
			switch dataTypeʹ
				when ːID_Int_Seq then coldef(field, 'serial') + ", PRIMARY KEY (\"#{field}\")"
				when ːStr then coldef field, 'text' + notNull
				when ːInt then coldef field, 'integer' + notNull
				when ːBigInt then coldef field, 'bigint' + notNull
				when ːFloat then coldef field, 'float' + notNull
				when ːBool then coldef field, 'boolean' + notNull
				when ːDate then coldef field, 'date' + notNull
				when ːDateTime then coldef field, 'timestamp with time zone' + notNull
				else throw new PSE "unsupported data type '#{dataType}'"

		return flatten res

	makeTables = ->
		tables = []
		for entityK, fields of model
			if entityK == '$config' then continue

			entity = model[entityK]

			tables.push """CREATE TABLE "public".#{ent entityK} (
				#{join ',\n\t', makeColumns entity.fields}
			);
			"""

		return tables

	dropTables = ->
		$ model, omit(['$config']), keys, map (k) -> "DROP TABLE IF EXISTS #{ent k, model} CASCADE;"

	###### ENTITY #################################################################
	makeEntity = (query) -> ent query.entity

	###### FIELDS #################################################################
	toAgg = ([k, v]) -> "#{v}(#{col k})"

	makeFields = (query) ->
		if query.aggregates
			aggFields = $ query.aggregates, toPairs, map toAgg
			return union map(col, query.groupBy), aggFields
		else $ query.allFields, map(col), join ', '

	###### WHERE ##################################################################
	ops = {eq: '=', ne: '<>', gt: '>', gte: '>=', lt: '<', lte: '<=', in: 'IN',
	like: 'LIKE', ilike: 'ILIKE', notlike: 'NOT LIKE', notilike: 'NOT ILIKE'}

	REPLACE = '¨!¨¨%¨&¨'

	# https://github.com/brianc/node-postgres/wiki/FAQ#11-how-do-i-build-a-where-foo-in--query-to-find-rows-matching-an-array-of-values
	toOpAndValOld = (op, v) -> op == 'in' && "= ANY (#{map(val, v)})" || "#{ops[op]} #{val(v)}"
	toOpAndVal = (op, v) -> op == 'in' && "= ANY (#{REPLACE})" || "#{ops[op]} #{REPLACE}"

	toPred = curry (kesc, [op, v]) -> "#{kesc} #{toOpAndVal(op, v)}"

	toPreds = ([kesc, v]) -> $ v, toPairs, map toPred(kesc)


	makePreds = ({where}, vals = []) ->
		{AND, OR} = where
		if AND then ["#{makePreds({where: AND[0]}, vals)[0]} AND #{makePreds({where: AND[1]}, vals)[0]}", vals]
		else if OR then ["(#{makePreds({where: OR[0]}, vals)[0]} OR #{makePreds({where: OR[1]}, vals)[0]})", vals]
		else
			preds = []
			idx = vals.length + 1
			for k, v of where
				preds.push toPreds [col(k), v], vals.length
				for [op, valu] in $ v, toPairs
					vals.push valu

			predsStr = $ preds, flatten, join ' AND '
			predsStrDollar = predsStr.replace new RegExp(REPLACE, 'g'), () -> '$' + idx++
			[predsStrDollar, vals]

	###### GROUP BY ###############################################################
	makeGrouping = (query) ->
		if query.groupBy then $ query.groupBy, map col
		else null

	###### SORT BY ################################################################
	makeSorting = (query) ->
		if query.sortBy then $ query.sortBy, map col
		else null


	###############################################################################
	createTables: -> join '\n', makeTables()
	dropTables: -> join '\n', dropTables()

	dev:
		makePreds: makePreds

	read: (fatQuery, safeGuard) ->
		entity = makeEntity fatQuery
		fields = makeFields fatQuery
		res = "SELECT #{fields} FROM #{entity}"

		[predsSql, predsVals] = makePreds fatQuery
		if predsSql then res += " WHERE #{predsSql}#{if safeGuard then " AND #{safeGuard}" else ''}"
		else if safeGuard then res += " WHERE #{safeGuard}"

		sorting = makeSorting fatQuery
		if sorting then res += " ORDER BY #{sorting}"

		grouping = makeGrouping fatQuery
		if grouping then res += " GROUP BY #{grouping}"

		return [res, predsVals]
		
	create: (fatQuery) ->
		# DEPRECATED?!
		"""INSERT INTO #{ent fatQuery.entity} \
		(#{$ fatQuery.values, keys, map(col), join ', '}) VALUES \
		(#{$ fatQuery.values, values, map(val), join ', '}) RETURNING \
		#{$ model[fatQuery.entity].fields, keys, map(col), join ', '};"""

	insert: ({entity, values}) ->
		validateKeys {entity, values}
		["""INSERT INTO #{ent entity} \
		(#{$ values, keys, map(col), join ', '}) VALUES \
		(#{$ values, keys, length, add(1), range(1), map(dollar), join ', '}) RETURNING id;""", R.values values]

	update: ({entity, id, values, safeGuard}) ->
		validateKeys {entity, values}
		if isNil id then  throw new Error "POPSIQL: id cannot be nil in update call"
		["""UPDATE #{ent entity} SET \
		#{$ values, toPairs, mapI(([k, v], idx) -> col(k) + " = $#{idx+1}"), join ', '} \
		WHERE id=$#{$ values, R.values, length, add(1)}\
		#{safeGuard || ''};""", $ values, R.values, append(id)]

	delete: ({entity, id, safeGuard}) ->
		validateKeys {entity}
		if isNil id then throw new Error "POPSIQL: id cannot be nil in delete call"
		["""DELETE FROM #{ent entity} WHERE id=$1\
		#{safeGuard || ''};""", [id]]

	resetIndex: (entity) ->
		"SELECT setval((SELECT pg_get_serial_sequence('#{ent entity}', 'id')), \
		(SELECT max(id) FROM #{ent entity}));"

validateKeys = (o) ->
	for k, v of o
		if isNil v then throw new Error "POPSIQL: #{k} cannot be nil"
















