insert = require('ramda/src/insert'); isNil = require('ramda/src/isNil'); match = require('ramda/src/match'); omit = require('ramda/src/omit'); test = require('ramda/src/test'); update = require('ramda/src/update'); values = require('ramda/src/values'); where = require('ramda/src/where'); #auto_require: srcramda
{sf0} = RE = require 'ramda-extras' #auto_require: ramda-extras
[ːa, ːb, ːc, ːc〳1, ːname, ːa〳COUNT, ːturnover, ːdate, ːamount, ːposition〳2, ːsex〳GROUP1, ːtext, ːnameX, ːa〳2, ːposition, ːage〳AVG, ːc〳COUNT, ːsalary〳1] = ['a', 'b', 'c', 'c〳1', 'name', 'a〳COUNT', 'turnover', 'date', 'amount', 'position〳2', 'sex〳GROUP1', 'text', 'nameX', 'a〳2', 'position', 'age〳AVG', 'c〳COUNT', 'salary〳1'] #auto_sugar
qq = (f) -> console.log match(/return (.*);/, f.toString())[1], f()
qqq = (...args) -> console.log ...args
_ = (...xs) -> xs
assert = require 'assert'
{eq, deepEq, fdeepEq, throwsP} = RE = require 'testhelp' # auto_require: testhelp


model = require './testModel'
seed = require './testSeed'
{runQuery, runDelta, normalize, expandWrite, expandQuery, _extractSortBy, _extractWhere, resolveAggregates, isAggregate} = require './query'
sql = require('./sql')(model)
ramda = require('./ramda')(model, seed)


# todo: move to test help?
console.clear()
console.log((new Date).toISOString())
dots = ''
dots += '.' for num in [0..Date.now() % 50]
console.log dots
console.log dots
console.log dots

_ = (...xs) -> xs


sleep = (ms) -> new Promise (res) -> setTimeout res, ms

exec = (args) ->
	await sleep 1
	console.log '\nEXEC', args
	return args

execWith = (data) ->
	count = 0
	(args) ->
		console.log '\nEXEC', omit ['where', 'children'], args
		console.log '  where:', sf0 args.where
		console.log 'result:', sf0 data[count]
		return data[count++]

execSqlWith = (data) ->
	count = 0
	(fatQuery) ->
		console.log '\nEXEC', omit ['where', 'children'], fatQuery
		console.log '  where:', sf0 fatQuery.where
		console.log 'result:', sf0 data[count]
		[readSql, readVals] = sql.read fatQuery
		console.log readSql, readVals
		return data[count++]

execRamda = (fatQuery) ->
	# console.log '\nEXEC', omit ['where', 'children'], fatQuery
	# console.log '  where:', sf0 fatQuery.where
	result = ramda.read fatQuery
	# console.log 'result:', result
	return result

rq = (q) ->
	return runQuery model, exec, q

fq = (q) ->
	return flattenQuery model, q



describe 'query', ->
	describe '_extractSortBy', ->
		it '1', ->
			res = _extractSortBy {ːa〳2, ːb, ːc〳1}
			fdeepEq [ːc, ːa], res

		it '2', ->
			res = _extractSortBy {}
			fdeepEq [], res

	describe '_extractWhere', ->
		it 'undefined', ->
			res = _extractWhere {}, undefined
			fdeepEq res, {}

	describe 'isAggregate', ->
		it 'simple 1', -> eq true, isAggregate {a: 1, ːb, ːc〳COUNT}
		it 'simple 2', -> eq true, isAggregate {a: 1, ːb, d〳COUNT: false}
		it 'simple 3', -> eq false, isAggregate {a: 1, ːb, c: {lt: 1}}
		it 'simple 4', -> eq true, isAggregate {ːa〳COUNT}

	describe 'expandWrite', ->
		it 'simple', ->
			res = expandWrite model, {Company: {name: 'test'}}
			eq 1, 1

	# describe 'normalize', ->
	# 	it.only 'oneToOne', ->
	# 		data =
	# 			Employment:
	# 				id: 1
	# 				person: {id: 2, name: 'Anna'}

	# 		res = normalize model, data
	# 		eq 2, res.personId
	# 		eq undefined, res.person

		# it.only 'many', ->
		# 	data =
		# 		Record:
		# 			id: 1
		# 			name: 'Cust1'
		# 			turnover: 9900
		# 			projects: [{id: 1, name: 'Proj1', type: 'a'}, {id: 2, name: 'Proj2', type: 'a'}]

		# 	res = normalize model, data
		# 	eq 1, res.project


	describe 'runDela', ->
		runD = (fullDelta) ->
			newIds = 100
			exec = ({entity, id, op, delta}) ->
				if parseInt(id) < 0
					tsql = sql.insert {entity, values: delta}
					return {[entity]: {[id]: newIds++}}
				else if isNil delta
					tsql = sql.delete {entity, id}
					return {}
				else
					tsql = sql.update {entity, id, values: delta}
					return {}


			runDelta {model, exec, delta: fullDelta}

		it 'invalid entity', -> throwsP /not an entity/, -> runD {PersonX: {1: {name: 'a'}}}
		it 'invalid values', -> throwsP /invalid values/, -> runD {Person: {name: 'a'}}
		it 'invalid field', -> throwsP /have field/, -> runD {Person: {1: {nameX: 'a'}}}


		it 'full sql', ->
			delta =
				Company:
					1: {name: 'a'}
					'-1': {name: 'a'}
					2: undefined

			serverDelta = await runD delta

			deepEq {Company: {'-1': 100}}, serverDelta



	describe.skip 'runQuery', ->
		it 'no query', -> throwsP /query cannot/, -> runQuery model, exec, null
		it 'no model', -> throwsP /model cannot/, -> runQuery null, exec, {}
		it 'no entity', -> throwsP /no entity/, -> rq {PersonX: _ {ːname}}
		it 'invalid body', -> throwsP /the body/, -> rq {Person: {ːname}}
		it 'missing fields clause', -> throwsP /fields clause/, -> rq {Person: []}
		it 'invalid fields clause', -> throwsP /not an obj/, -> rq {Person: ['a']}
		it 'invalid fields', -> throwsP /invalid field/, -> rq {Person: _ {ːnameX}}
		it 'invalid child', -> throwsP /no rel.* or sub/, -> rq {Company: _ {ːname}, {projectsX: _ {}}}
		it 'invalid AND', -> throwsP /invalid fiel/, -> rq {Company: _ {AND: {name: 1, name: 2}}}
		it 'invalid OR', -> throwsP /invalid fiel/, -> rq {Company: _ {OR: [{name: 1, name: 2}]}}

		it 'full 1', ->
			query =
				Company: _ {ːname},
					employees: _ {ːsalary〳1},
						person: _ {name: {like: '%n%'}}

			execʹ = execSqlWith [
				[{id: 1, turnover: 350}, {id: 2, turnover: 680}],

				[{id: 4, companyId: 1, salary: 3000, personId: 3},
				{id: 7, companyId: 1, salary: 1000, personId: 4},
				{id: 7, companyId: 2, salary: 4000, personId: 4},
				{id: 8, companyId: 2, value: 50000, personId: 5}],

				[{id: 5, name: 'Kel Vernsen'},
				{id: 7, name: 'Hank Scorpio'},
				{id: 8, name: 'Homer Simpson'}]
			]

			res = await runQuery model, execʹ, query
			# qq 9, res
			eq 1, 1

		it 'insert update delete sql', ->
			console.log sql.insert {entity: 'Company', values: {name: "O'Reilly", turnover: 12000}}
			console.log sql.update {entity: 'Company', id: 1, values: {name: "O'Reilly", turnover: 12000}}
			console.log sql.delete {entity: 'Company', id: 1}
			eq 1, 1


		it 'full ramda', ->
			query =
				# Employment: _ {id: 2},
				# 	person: _ {ːname}

				# Project: _ {id: 1},
				# 	company: _ {ːname}
				# Company: _ {OR: [{turnover: {gt: 100000000}}, {name: {like: '%d%'}}]}

				Company: _ {id: 6, ːname, ːturnover},
					employees: _ {ːsalary〳1, ːposition〳2},
						person: _ {ːname}
					# projects: _ {ːname}
					# 	entries: _ {ːdate, ːamount, ːtext}

				# Employment: _ {id: 19},
				# 	person: _ {ːname}

			[res, norm] = await runQuery model, execRamda, query, true
			qqq -> res
			eq 1, 1

		it 'full rest', ->
			query =
				# Project: _ {id: 1},
				# 	company: _ {ːname}
				Company: _ {name: 'dasd'},
					# projects: _ {OR: [{name: {like: 't%'}}, {name: {like: 'e%'}}]},
					# 	entries: _ {ːdate, ːamount, ːtext}
					# numImportantEmployees: 0
					# importantEmployees: _ {ːsalary〳1, ːposition}
					# managers: _ {ːsalary〳1}
					# hoursByManager: {}
					# numEmployees: 0
					# employees: _ {ːsalary〳1},
						# person: _ {ːname}
					# hoursByEmployee: {}


					# Person: _ {ːage〳AVG, ːsex〳GROUP1}

					# NEXT NEXT NEXT NEXT NEXT NEXT NEXT NEXT NEXT NEXT NEXT NEXT  
					# NEXT: modelBeach1 inte numImportantEmployees eftersom vi kan ha en regel som är:
					# en sub kan ha deps på rels och fields, ej andra subs


			# res = expandQuery model, query
			# eq 1, 1
			# return

			# execʹ = execWith [
			execʹ = execSqlWith [
				[]
				# Project
				# [{id: 1, companyId: 2}],
				# [{id: 2, name: 'Pendent Publishing'}]
				# []
				# [{id: 1, turnover: 350}, {id: 2, turnover: 680}],
				# [{id: 1, turnover: 350}],

				# projects & entries
				# [{id: 7, name: 'test', companyId: 1}, {id: 8, name: 'etest', companyId: 1}],
				# [{id: 1, date: '2019-01-01', text: 'hej', projectId: 7},
				# 	{id: 2, date: '2019-01-02', text: 'då', projectId: 7}]
				# projects & entries (empty)
				# []

				# importantEmployees
				# [{companyId: 1, value: 2}, {companyId: 2, value: 10}],

				# managers / employees / hoursByManagers / ...importantEmployees
				# [{id: 4, companyId: 1, salary: 3000, personId: 3},
				# {id: 7, companyId: 1, salary: 1000, personId: 4},
				# {id: 7, companyId: 2, salary: 4000, personId: 4},
				# {id: 8, companyId: 2, value: 50000, personId: 5}],

				# [{id: 3, name: 'Elin'},{id: 4, name: 'Isabelle'},{id: 5, name: 'Cedric'}]
				# ...hoursByManager
				# [{personId: 3, value: 10}],
				# [{personId: 4, value: 12}, {personId: 5, value: 20}],
				# ...importantEmployees
				# [{id: 4, salary: 3000, personId: 3},
				# {id: 7, salary: 4000, personId: 4}],
				# [],

				# hoursByManager / hoursByEmployee
				# [{id: 2, companyId: 1, personId: 5}, {id: 3, companyId: 1, personId: 8}],
				# [{personId: 5, value: 5.5}, {personId: 8, value: 1.0}]

				# numEmployees
				# [{companyId: 1, value: 2}, {companyId: 2, value: 10}],

				# [{id: 1, turnover: 350}, {id: 2, turnover: 680}],
				# [{id: 2}, {id: 3}],
				# [{id: 1, value: 14}, {id: 2, value: 23}],
				# [{id: 4}, {id: 5}],
				# [{id: 6}, {id: 7}],
				# [{id: 8}, {id: 9}],
			]

			[res, norm] = await runQuery model, execʹ, query

			qq -> res
			qq -> norm

			eq 1, 1



