insert = require('ramda/src/insert'); match = require('ramda/src/match'); update = require('ramda/src/update'); #auto_require: srcramda
{$} = RE = require 'ramda-extras' #auto_require: ramda-extras
[ːsalary〳1, ːname] = ['salary〳1', 'name'] #auto_sugar
qq = (f) -> console.log match(/return (.*);/, f.toString())[1], f()
qqq = (...args) -> console.log ...args
_ = (...xs) -> xs
{deepEq, fdeepEq} = RE = require 'testhelp' # auto_require: testhelp

{createModel, parseArguments} = mode = require './model'

model = require './testModel'
{runQuery, expandQuery} = require './query'
sql = require('./sql')(model)

_ = (...xs) -> xs

runQueryWith = (data, query) ->
	sqlRes = []
	count = 0
	execSql = (fatQuery) ->
		[readSql, readVals] = sql.read fatQuery
		sqlRes.push [readSql, readVals]
		return data[count++]

	res = await runQuery model, execSql, query
	return sqlRes

describe 'sql.coffee', ->

	it 'insert', ->
		res = sql.insert {entity: 'Company', values: {name: "O'Reilly", turnover: 12000}}
		deepEq ['INSERT INTO company ("name", turnover) VALUES ($1, $2) RETURNING id;', ["O'Reilly", 12000]], res

	it 'update', ->
		res = sql.update {entity: 'Company', id: 1, values: {name: "O'Reilly", turnover: 12000}}
		deepEq ['UPDATE company SET "name" = $1, turnover = $2 WHERE id=$3;', ["O'Reilly", 12000, 1]], res

	it 'delete', ->
		res = sql.delete {entity: 'Company', id: 1}
		deepEq ['DELETE FROM company WHERE id=$1;', [1]], res

	describe 'read', ->
		it '1', ->
			query =
				Company: _ {ːname},
					employees: _ {ːsalary〳1},
						person: _ {AND: [{name: {like: '%n%'}}, {age: {gt: 20}}]}
			data = [
				[{id: 1, turnover: 350}, {id: 2, turnover: 680}],

				[{id: 4, companyId: 1, salary: 3000, personId: 3},
				{id: 7, companyId: 1, salary: 1000, personId: 4},
				{id: 7, companyId: 2, salary: 4000, personId: 4},
				{id: 8, companyId: 2, value: 50000, personId: 5}],

				[{id: 5, name: 'Kel Vernsen'},
				{id: 7, name: 'Hank Scorpio'},
				{id: 8, name: 'Homer Simpson'}]
			]

			res = await runQueryWith data, query
			fdeepEq res, [
				['SELECT id, "name" FROM company', []],
				[
					'SELECT id, salary, company_id, person_id FROM employment WHERE company_id = ANY ($1) ORDER BY salary',
					[[1, 2]]
				],
				[
					'SELECT "name", age, id FROM person WHERE "name" LIKE $1 AND age > $2 AND id = ANY ($3)',
					['%n%', 20, [3, 4, 5]]
				]
			]

	describe 'other', ->
		describe 'makePreds', ->
			it '1', ->
				res = sql.dev.makePreds {where: {a: {eq: 1}, b: {gt: 2, lt: 4}}}
				deepEq ['"a" = $1 AND b > $2 AND b < $3', [1, 2, 4]], res

			it '2', ->
				res = sql.dev.makePreds {where: {AND: [{a: {in: [1, 2]}}, {b: {gt: 2, lt: 4}}]}}
				deepEq ['"a" = ANY ($1) AND b > $2 AND b < $3', [[1, 2], 2, 4]], res

			it '3', ->
				res = sql.dev.makePreds {where: {AND: [{c: {in: [8, 9]}}, {AND: [{a: {eq: 1}}, {b: {gt: 2, lt: 4}}]}]}}
				deepEq ['"c" = ANY ($1) AND "a" = $2 AND b > $3 AND b < $4', [[8, 9], 1, 2, 4]], res

			it '4', ->
				res = sql.dev.makePreds {where: {OR: [{c: {in: [8, 9]}}, {OR: [{a: {eq: 1}}, {b: {gt: 2, lt: 4}}]}]}}
				deepEq ['("c" = ANY ($1) OR ("a" = $2 OR b > $3 AND b < $4))', [[8, 9], 1, 2, 4]], res












