empty = require('ramda/src/empty'); length = require('ramda/src/length'); path = require('ramda/src/path'); test = require('ramda/src/test'); values = require('ramda/src/values'); # auto_require: srcramda
{} = RE = require 'ramda-extras' # auto_require: ramda-extras
[ːgroup, ːb, ːname, ːid, ːdate, ːaa1, ːaa2, ːb2, ːab1, ːuserId, ːa1, ːactivity, ːa] = ['group', 'b', 'name', 'id', 'date', 'aa1', 'aa2', 'b2', 'ab1', 'userId', 'a1', 'activity', 'a'] #auto_sugar
{eq, feq, deepEq, fdeepEq, throws} = RE = require 'testhelp' # auto_require: testhelp

model = require './testModel'
{AND, parseArguments, toDataQuery, subSelect, queryToString, dataQueryToPaths, isQueryNilOrEmpty,
ensureQuery, ensureQueryMap} = require './utils'
sql = require('./sql')(model)


# todo: move to test help?
console.clear()
console.log((new Date).toISOString())
dots = ''
dots += '.' for num in [0..Date.now() % 50]
console.log dots
console.log dots
console.log dots

_ = (...xs) -> xs



describe 'utils', ->
	describe 'AND', ->
		it 'empty', ->
			deepEq {a: 1}, AND {a: 1}, {}
			deepEq {a: 2}, AND {}, {a: 2}
			deepEq {}, AND {}, {}
		it 'undefined', ->
			deepEq {a: 1}, AND {a: 1}, undefined
			deepEq {a: 2}, AND undefined, {a: 2}
			deepEq {}, AND undefined, undefined
		it '1', ->
			res = AND {a: {neq: 1}}, {a: {neq: 2}}
			fdeepEq res, {AND: [{a: {neq: 1}}, {a: {neq: 2}}]}
		it '2', ->
			res = AND {a: 1}, {b: {in: [1,2]}}
			fdeepEq res, {a: 1, b: {in: [1,2]}}
		it '3', ->
			res = AND {a: {lt: 1}}, {a: {gt: 2}}
			fdeepEq res, {a: {lt: 1, gt: 2}}
		it '4', ->
			res = AND {a: 1}, {a: {gt: 2}}
			fdeepEq res, {a: {eq: 1, gt: 2}}
		it '5', ->
			res = AND {OR: [{a: 1}, {b: 2}]}, {a: {gt: 2}}
			fdeepEq res, {AND: [{OR: [{a: 1}, {b: 2}]}, {a: {gt: 2}}]}
		it '6', ->
			res = AND {AND: [{a: {lt: 4}}, {b: 2}]}, {a: {gt: 2}}
			fdeepEq res, {AND: [{AND: [{a: {lt: 4}}, {b: 2}]}, {a: {gt: 2}}]}
		it 'aggs', ->
			throws /not yet supported/, -> AND {a: 1}, {b〳COUNT: 1}

	describe 'parseArguments', ->
		it 'null', ->
			res = parseArguments null
			deepEq [{}], res

		it 'empty', ->
			res = parseArguments ''
			deepEq [{}], res

		it 'empty no', ->
			res = parseArguments 'function () { ...'
			deepEq [{}], res

		it '1', ->
			res = parseArguments 'function ({a, b}) { ...'
			deepEq [{a: null, b: null}], res

		it '2', ->
			res = parseArguments 'function ({a, b: {b1, b2}, c, d: {d1}}) { ...'
			deepEq [{a: null, b: {b1: null, b2: null}, c: null, d: {d1: null}}], res

		it '3', ->
			res = parseArguments """function({
			a: {a1},
			b
		}) { ..."""
			deepEq [{a: {a1: null}, b: null}], res

		it '4', ->
			res = parseArguments 'function ({a, b: {b1}}, d, {a: {a1}, c}) { ...'
			deepEq [{a: null, b: {b1: null}}, {d: null}, {a: {a1: null}, c: null}], res

		it '5', ->
			res = parseArguments "function({\n    a: {a1}\n  }) {\n  (function() {\n    switch (path0) {\n  "
			deepEq [{a: {a1: null}}], res


	describe 'toDataQuery', ->
		it 'undefined', ->
			query =
				a: _ {ːa1},
					aa: undefined

			throws /is nil/, -> toDataQuery query

		it 'not array', ->
			query =
				a: _ {},
					aa: {ːaa1}

			throws /body is not Array/, -> toDataQuery query
		it 'no fields', ->
			query =
				a: _ {},
					aa: _ {ːaa1}

			deepEq {a: {aa: {aa1: null}}}, toDataQuery query

		it '1', ->
			query =
				a: _ {ːa1},
					aa: _ {ːaa1, ːaa2}
					ab: _ {ːab1}
				b: _ {ːb2}

			expected = {a: {a1: null, aa: {aa1: null, aa2: null}, ab: {ab1: null}}, b: {b2: null}}
			res = toDataQuery query
			deepEq expected, res

		it 'test', ->
			query =
				Data: _ {},
					me: _ {ːid}
					group: _ {},
						workouts: _ {ːdate, ːuserId, ːactivity}
					activities: _ {ːid, ːname}
					url: _ {ːgroup, ːdate}

			toDataQuery query
			eq 1, 1

	describe 'dataQueryToPaths', ->
		it '1', ->
			res = dataQueryToPaths {a: {a1: {a11: null, a12: null}, a2: null}, b: null}
			fdeepEq res, [['a', 'a1', 'a11'], ['a', 'a1', 'a12'], ['a', 'a2'], ['b']]

	describe 'subSelect', ->
		it 'data is nil', ->
			res = subSelect {a: {a1: null}}, null
			deepEq [[['a']], null], res
		it 'missing key', ->
			res = subSelect {a: {a1: null}}, {}
			deepEq [[['a']], {a: null}], res
		it 'missing key in object', ->
			res = subSelect {a: {a1: null, a2: null}}, {a: {a2: 1}}
			deepEq [[['a', 'a1']], {a: {a1: null, a2: 1}}], res
		it 'missing key in array', ->
			res = subSelect {a: {a1: null, a2: null}}, {a: [{a2: 1}]}
			deepEq [[['a', 'a1']], {a: [{a1: null, a2: 1}]}], res
		# it 'missing key in array 2', ->
		# 	res = subSelect {a: {a1: null}, {a: [{a1: 1, a2: 1}]}
		# 	deepEq [[['a', 'a1']], {a: [{a1: null, a2: 1}]}], res
		it 'undefined in data', ->
			res = subSelect {a: {a1: null, a2: null}}, {a: [{a1: undefined, a2: 1}]}
			deepEq [[['a', 'a1']], {a: [{a1: null, a2: 1}]}], res
		it 'null in array', ->
			res = subSelect {a: {a1: null, a2: null}}, {a: [{a1: null, a2: 1}]}
			deepEq [[], {a: [{a1: null, a2: 1}]}], res
		it 'missing optional key in object', ->
			res = subSelect {a: {a1〳: null}}, {a: {a2: 1}}
			deepEq [[], {a: {a1: null}}], res
		it 'missing optional key in array', ->
			res = subSelect {a: {a1〳: null}}, {a: [{a2: 1}, {a1: 1}]}
			deepEq [[], {a: [{a1: null}, {a1: 1}]}], res
		it 'missing optional item in array', ->
			res = subSelect {a〳: {a1: null}}, {a: [{a1: 1}, null]}
			deepEq [[], {a: [{a1: 1}, null]}], res
		it 'missing key in optional item in array', ->
			res = subSelect {a〳: {a1: null}}, {a: [{a1: 1}, {a2: 2}]}
			deepEq [[['a', 'a1']], {a: [{a1: 1}, {a1: null}]}], res
		it 'missing optional key in optional item in array', ->
			res = subSelect {a〳: {a1〳: null}}, {a: [{a1: 1}, {a2: 2}]}
			deepEq [[], {a: [{a1: 1}, {a1: null}]}], res
		it 'missing optional array', ->
			res = subSelect {a〳: {a1: null}}, {a: null}
			deepEq [[], {a: null}], res
		it 'array with values', ->
			res = subSelect {a: {a1: null}}, {a: {a1: [1,2,3]}}
			deepEq [[], {a: {a1: [1,2,3]}}], res
		it '1', ->
			query =
				a: {a1: null, aa: {aa1: null}, ab: {ab1: null}}
				b: {b1: null}
			data =
				a: {a1: 1, aa: {aa1: 1}, ab: [{ab1: 1}, {ab1: 2}]}
				b: {b1: 1, b2: 1}
			res = subSelect query, data
			expected =
				a:
					a1: 1
					aa: {aa1: 1}
					ab: [{ab1: 1}, {ab1: 2}]
				b: {b1: 1}

			deepEq [[], expected], res

		it 'no fields for array and object', ->
			query =
				a: null
				b: null
			data =
				a: [{a1: 1, a2: 1}, {a1: 2, a2: 2}]
				b: {a1: 1, a2: 1}
			res = subSelect query, data
			expected =
				a: [{}, {}]
				b: {}

			deepEq [[], expected], res


	# describe.only 'subSelectMissing', ->
	# 	it 'data is nil', ->
	# 		res = subSelectMissing {a: {a1: null}}, null
	# 		deepEq {a: null}, res

	describe 'queryToString', ->
		it 'empty', ->
			query = {}

			feq queryToString(query), "{}"

		it '1', ->
			query =
				Test: _ {a: undefined, ːb, c: 's'},
					child: _ {a: {gt: 2}, ːb},
						grandChild: _ {a: {gt: 2}, ːb}
					child2: _ {ːa, ːb}
					child3: null

			feq queryToString(query), """Test: _ {a: undefined, ːb, c: 's'},\n  \
child: _ {a: {gt: 2}, ːb},\n    \
grandChild: _ {a: {gt: 2}, ːb}\n  \
child2: _ {ːa, ːb}\n  \
child3: null"""

	describe 'ensureQuery ', ->
		it '0', -> throws /nil/, -> ensureQuery null
		it '0.1', -> eq undefined, ensureQuery {}
		it '0.2', -> throws /must be object/, -> ensureQuery [1]
		it '1', -> eq undefined, ensureQuery Customer: _ {}, {address: _ {ːid}}
		it '2', -> eq undefined, ensureQuery Customer: _ {}, {}
		it '3', -> throws /body is not array/, -> ensureQuery Customer: {}, {address: _ {ːid}}
		it '4', -> throws /length 1 or 2/, -> ensureQuery Customer: _ {}, {address: _ {ːid}}, {city: _ {ːid}}
		it '5', -> throws /1 and only 1 key/, -> ensureQuery {Customer: _({ːid}), Task: _({ːid})}

	describe 'ensureQueryMap ', ->
		it '0', -> throws /nil/, -> ensureQueryMap null
		it '0.1', -> eq undefined, ensureQueryMap {}
		it '0.2', -> throws /must be object/, -> ensureQueryMap [1]
		it '1', -> eq undefined, ensureQueryMap customer: Customer: _ {}, {address: _ {ːid}}
		it '2', -> eq undefined, ensureQueryMap customer: {Customer: _ {}, {}}, task: Task: _ {}, {}

	# describe 'isQueryNilOrEmpty', ->
	# 	describe 'query', ->
	# 		it '1', -> eq false, isQueryNilOrEmpty Customer: _ {ːid}
	# 		it '2', -> eq false, isQueryNilOrEmpty Customer: _ {}, {address: _ {ːid}}
	# 		it '3', -> eq true, isQueryNilOrEmpty Customer: _ {}, {address: _ {}}
	# 		it '4', -> eq false, isQueryNilOrEmpty Customer: _ {}



