any = require('ramda/src/any'); clone = require('ramda/src/clone'); contains = require('ramda/src/contains'); filter = require('ramda/src/filter'); fromPairs = require('ramda/src/fromPairs'); has = require('ramda/src/has'); head = require('ramda/src/head'); intersection = require('ramda/src/intersection'); isEmpty = require('ramda/src/isEmpty'); isNil = require('ramda/src/isNil'); join = require('ramda/src/join'); keys = require('ramda/src/keys'); length = require('ramda/src/length'); map = require('ramda/src/map'); match = require('ramda/src/match'); merge = require('ramda/src/merge'); prepend = require('ramda/src/prepend'); reject = require('ramda/src/reject'); repeat = require('ramda/src/repeat'); replace = require('ramda/src/replace'); split = require('ramda/src/split'); test = require('ramda/src/test'); trim = require('ramda/src/trim'); type = require('ramda/src/type'); union = require('ramda/src/union'); values = require('ramda/src/values'); #auto_require: srcramda
{$, $$, isNilOrEmpty, sf0, customError} = RE = require 'ramda-extras' #auto_require: ramda-extras
[ːObject, ːid, ːname, ːArray, ːaa1, ːa1] = ['Object', 'id', 'name', 'Array', 'aa1', 'a1'] #auto_sugar
qq = (f) -> console.log match(/return (.*);/, f.toString())[1], f()
qqq = (...args) -> console.log ...args
_ = (...xs) -> xs

customError = (name, staticMsg) ->
	class CustomError extends Error
		constructor: (msg) ->
			if staticMsg then super staticMsg else super msg
			@name = name
			Error.captureStackTrace this, CustomError

class PopsiqlValidationError extends Error
	constructor: (query, msg) ->
		if type(query) == 'String' then super(query)
		else super(msg + ". Your query:\n#{queryToString query}")
		@name = 'PopsiqlValidationError'
		Error.captureStackTrace this, PopsiqlValidationError

PVE = PopsiqlValidationError

class DataQueryError extends Error
	constructor: (query, msg) ->
		if type(query) == 'String' then super(query)
		else super(msg + ". Your data-query:\n#{queryToString query}\n")
		@name = 'DataQueryError'
		Error.captureStackTrace this, DataQueryError

DQE = DataQueryError

NYIE = NotYetImplementedError = customError 'NotYetImplementedError', 'Not yet implemented!'

# Array shorthand
_ = (...xs) -> xs

# ({a: {gt: 2}}, {a: {lt: 5}} -> {a: {gt: 2, lt: 5}}
# Combines a left and right where object and simplifies possible ANDs
# Note: only pure where objects, no fieldsClauses
AND = (_left, _right) ->
	if $(_left, keys, any(test(/〳/))) or $ _right, keys, any(test(/〳/))
		throw new PVE "aggregations not yet supported"
	if isNilOrEmpty(_left) && isNilOrEmpty(_right) then return {}
	else if isNilOrEmpty(_left) then return _right
	else if isNilOrEmpty(_right) then return _left
	else if _left.OR || _right.OR then return {AND: [_left, _right]}
	# We're assuming AND was used to create _left and _right so if either contains AND: we're assuming it
	# cannot be more simplified and bailing out and not trying to simplify any further
	else if _left.AND || _right.AND then return {AND: [_left, _right]}

	left = clone _left
	right = clone _right
	res = {}
	bothKeys = union keys(left), keys(right)
	for k in bothKeys
		if has(k, left) && has k, right
			if type(left[k]) != ːObject then left[k] = {eq: left[k]} # implicit eq
			if type(right[k]) != ːObject then right[k] = {eq: right[k]} # implicit eq

			if isEmpty intersection keys(left[k]), keys(right[k])
				res[k] = merge left[k], right[k]
			else return {AND: [left, right]}
		else if has k, left then res[k] = left[k]
		else res[k] = right[k]

	return res


# It's hard with regexp to split on comma (,) because they can be nested in curlys,
# so this is a simple loop that keeps track and splits.
_splitArgs = (s) ->
	res = ''
	curlCount = 0
	for c in s
		if c == '{' then curlCount++
		else if c == '}' then curlCount--

		if c == ',' && curlCount == 0 then res += '~'
		else res += c
	return split '~', res

# The idea here is to convert a destructuring string to valid json like a data-query
_toJson = (s) ->
	# if one argument is just a variable, we'll force it into an object
	if ! test(/\{/g, s) then return "{\"#{s}\": null}"

	# https://stackoverflow.com/a/1661249/416797
	VAR = '[a-zA-Z_$][0-9a-zA-Z_$]*'
	RE = (s) -> new RegExp(replace(/VAR/g, VAR, s), 'g')
	
	return $ s,
		replace RE('(VAR),'), '"$1": null,'
		replace RE('(VAR)}'), '"$1": null}'
		replace RE('(VAR):'), '"$1":'


# Returns a dataQuery given a function.toString() result
parseArguments = (fnStr) ->
	if isNil fnStr then return [{}]
	fnStrʹ = replace(/\n\s*/g, '', fnStr)
	[___, s] = match new RegExp(/function\s?\((.*?)\) {/), fnStrʹ
	if isNilOrEmpty s then return [{}]

	json = $ s, replace(/\s/g, ''), _splitArgs, map(_toJson), join(','), (x) -> "[#{x}]"

	return JSON.parse json



# Returns a dataQuery given a function.toString() result
parseArgumentsOLD = (fnStr) ->
	if isNil fnStr then return {}
	fnStrʹ = replace(/\n\s*/g, '', fnStr)
	[___, s] = match new RegExp(/function\s?\((.*?)\) {/), fnStrʹ
	if isNil s then return {}
	curlys = match new RegExp(/\{(.*?)\}/g), s
	qq 2, curlys

	# temporary replace  curlys
	sʹ = s
	i = 0
	for c in curlys
		sʹ = $ sʹ, replace(c, "__CURLY__#{i++}")

	qq 1, sʹ

	ss = split ',', sʹ
	# simples = arg without destructuring
	simples = $ ss, map(trim), reject(test(/__CURLY__/)), map((x) -> [x, null]), fromPairs
	_complex = $ ss, map(trim), filter(test(/__CURLY__/))

	qq 3, _complex
	complex = {}
	i = 0
	for c in _complex
		[___, k] = match /^(.*?):/, c
		ts = $ curlys[i++], replace(/^\{/, ''), replace(/\}$/, ''), split(','), map(trim)
		complex[k] = $$ ts, fromPairs, map (x) -> [x, null]

	return merge simples, complex


# query						Client: _ {ːid},
#										address: _ {ːid}
# query key				Client:
# query body			_ {ːid},
#										address: _ {ːid}
# propQuery				{ːid, ːname}
# childQuery			address: _ {ːid}
# queryMap				clients: Client: _ {ːid}
# dataQuery				Client: {id: null, address: {id: null}}
# dataQueryMap		clients: Client: {id: null, address: {id: null}}
	
isQuery = (q) -> _validateQuery(q) == null
ensureQuery = (q) -> if _validateQuery(q) != null then throw new Error _validateQuery q
isQueryMap = (qm) -> _validateQueryMap(qm) == null
ensureQueryMap = (qm) -> if _validateQueryMap(qm) != null then throw new Error _validateQueryMap qm
isDataQuery = (dq) -> throw new Error 'NYI'
ensureDataQuery = (dq) -> throw new Error 'NYI'
isDataQueryMap = (dqm) -> throw new Error 'NYI'
ensureDataQueryMap = (dqm) -> throw new Error 'NYI'

_validateQuery = (q) ->
	if isNil q then "Query cannot be nil: #{sf0 q}"
	else if type(q) != ːObject then "Query must be object: #{sf0 q}"
	else if isEmpty q then return null
	else if $(q, keys, length) != 1 then "Query must have 1 and only 1 key: #{sf0 q}"
	else _validateBody q[$(q, keys, head)], q

_validateBody = (b, q) ->
	if type(b) != ːArray then return "Query body is not array: #{sf0 q}"
	else if $(b, length) < 1 || $(b, length) > 2 then return "Query body must be length 1 or 2: #{sf0 q}"

	propRes = _validatePropQuery b[0], q
	if propRes != null then return propRes
	if b[1]
		childRes = _validateChildQuery b[1], q
		if childRes != null then return childRes

	return null

_validatePropQuery = (p, q) ->
	if type(p) != ːObject then return "propQuery (first part of body) must be an object: #{sf0 p}, query: #{sf0 q}"
	return null

_validateChildQuery = (c, q) ->
	if type(c) != ːObject then return "childQuery (second part of body) must be an object: #{sf0 c}, query: #{sf0 q}"
	for k, body of c
		res = _validateBody body, q
		if res != null then return res
	return null

_validateQueryMap = (qm) ->
	if isNil qm then return "QueryMap cannot be nil: #{sf0 qm}"
	else if type(qm) != ːObject then return "Query must be object: #{sf0 qm}"
	else if isEmpty qm then return null
	for k, q of qm
		res = _validateQuery q
		if res then return res
	return null


isQueryNilOrEmpty = (query) ->
	throw new Error 'Maybe this function is not needed'
	if isNilOrEmpty query then return true
	else if type(query) == 'Array'
		if query.length == 1 then return isEmpty query[0]
		else if query.length == 2 then return isEmpty(query[0]) && isEmpty query[1]
		else throw new Error 'Invalid popsiql query'
	else if type(query) == 'Object'
		for k,q of query
			if isQueryNilOrEmpty q then return true
		return false
	else throw new Error "NYI #{JSON.stringify query}"



# {a: _ {ːa1}, aa: _ {ːaa1}} -> {a: {a1: null, aa: {aa1: null}}}
# Converts a dataQuery in multi line form and returns a raw dataQuery
toDataQuery = (multiLineDataQuery) ->
	$ multiLineDataQuery || {}, map (v, k) ->
		if isNil v then throw new DQE multiLineDataQuery, "key #{k} of dataQuery is nil"
		if type(v) != 'Array' then throw new DQE multiLineDataQuery, "body is not Array"
		[attrs, children] = v
		{...toDataQuery(children), ...$(attrs, values, map((a) -> [a, null]), fromPairs)}


# {a: {a1: null}} -> [['a', 'a1']]
# Returns the paths of an argQuery
dataQueryToPaths = (dataQuery) ->
	paths = []
	ks = keys dataQuery
	for k in ks
		v = dataQuery[k]
		if 'Object' == type v
			subPaths = $ v, dataQueryToPaths, map(prepend(k))
			paths.push ...subPaths
		else
			paths.push [k]
	return paths


_safeToString = (x) ->
	if x == undefined then 'undefined'
	else if x == null then 'null'
	# https://stackoverflow.com/a/11233515/416797
	else $ x, JSON.stringify, replace(/\"([^(\")"]+)\":/g, "$1: "), replace(/"/g, "'")

# Returns an easy-to read new-lined string of a popsiql query for debugging
queryToString = (query, level = 0) ->
	if isEmpty query then return '{}'
	indentation = if level then $ level * 2, repeat(' '), join '' else ''
	ss = []
	for key, body of query
		s = "#{indentation}#{key}: "
		if !body
			s += _safeToString body
			ss.push s
			continue

		if 'Object' == type body 
			s += '{}'
			continue

		[fieldClause, children] = body
		s += "_ {"

		fields = []
		for k, v of fieldClause
			if k == 'ː'+v then fields.push k
			else fields.push "#{k}: #{_safeToString v}"

		s += $ fields, join(', ')
		s += '}'

		if children
			s += ',\n' + queryToString children, ++level
		
		ss.push s

	return $ ss, join '\n'

# Returns the subset specified by dataQuery from data plus a hasNils flag
subSelect = (dataQuery, data) -> _subSelect dataQuery, data, dataQuery

_subSelect = (dataQuery, data, initialQuery) ->
	if !dataQuery
		throw new DQE initialQuery, "dataQuery argument is mandatory, cannot be: #{dataQuery}"
	if isNil data then return [$(dataQuery, keys, map((k)->[k])), null]
	res = {}
	missing = []
	for _k, v of dataQuery
		k = replace /〳$/, '', _k
		isOptional = test /〳$/, _k
		if !has(k, data) || data[k] == undefined
			res[k] = null
			if !isOptional then missing.push [k]
		else if v == null
			if 'Array' == type data[k]
				if contains type(data[k][0]), ['Number', 'String', 'Boolean']
					res[k] = data[k]
				else res[k] = $ data[k], map () -> {}
			else if 'Object' == type data[k]
				res[k] = {}
			else
				res[k] = data[k]
		else
			if 'Array' == type data[k]
				res[k] = []
				for d in data[k]
					[itemMissing, itemRes] = _subSelect v, d, initialQuery
					if !isEmpty itemMissing
						if isOptional
							if itemRes != null then missing.push ...map(prepend(k), itemMissing)
						else missing.push ...map(prepend(k), itemMissing)
					res[k].push itemRes
			else if 'Object' == type data[k]
				[childMissing, childRes] = _subSelect v, data[k], initialQuery
				if !isEmpty childMissing
					missing.push ...map(prepend(k), childMissing)
				res[k] = childRes
			else if data[k] == null
				res[k] = null # null is not a miss as opposed to missing key or undefined
			else
				throw new Error "not supported #{data[k]} for key '#{k}' in dataQuery (should be null or obj)
				\ndataQuery: #{sf0 dataQuery}\ndata: #{sf0 data}"

	return [missing, res]

# subSelectMissing = (dataQuery, data) ->
# 	if !dataQuery then throw new DQE "dataQuery argument is mandatory, cannot be: #{dataQuery}"
# 	if isNil data then return fmapO dataQuery, -> null
# 	res = {}
# 	for _k, v of dataQuery
# 		k = replace /〳$/, '', _k
# 		isOptional = test /〳$/, _k
# 		if !has(k, data) || data[k] == undefined
# 			if !isOptional then res[k] = null
# 		else if v == null # no op
# 		else
# 			if 'Array' == type data[k]
# 				arrRes = {}
# 				for d in data[k]
# 					itemRes = subSelectMissing v, d
# 					if itemRes
# 						arrRes = merge arrRes, itemRes
# 						if isOptional
# 							if itemRes != null then isFull = false
# 						else isFull = false
# 					res[k].push itemRes
# 			else if 'Object' == type data[k]
# 				[childIsFull, childRes] = subSelect v, data[k]
# 				if !childIsFull then isFull = false
# 				res[k] = childRes
# 			else if data[k] == null
# 				res[k] = null # null is not a miss as opposed to missing key or undefined
# 			else throw new NYIE

# 	return [isFull, res]




module.exports = {customError, PVE, DQE, NYIE, parseArguments, queryToString,
AND, _, dataQueryToPaths, subSelect, toDataQuery, isQueryNilOrEmpty,
isQuery, isQueryMap, isDataQuery, isDataQueryMap,
ensureQuery, ensureQueryMap, ensureDataQuery, ensureDataQueryMap}
