// Generated by CoffeeScript 2.4.1
(function() {
  var RE, _, add, createModel, deepEq, eq, fdeepEq, ffit, has, match, mode, parseArguments, qq, qqq, throws, type, ːBigInt, ːBool, ːDate, ːDateTime, ːFloat, ːID_Int_Seq, ːInt, ːStr, ːUser, ːid〳COUNT, ːnumEmployees, ːsex〳GROUP1, ːturnover;

  add = require('ramda/src/add');

  has = require('ramda/src/has');

  match = require('ramda/src/match');

  type = require('ramda/src/type');

  ({} = RE = require('ramda-extras')); //auto_require: ramda-extras

  [ːid〳COUNT, ːUser, ːStr, ːDate, ːturnover, ːBool, ːID_Int_Seq, ːnumEmployees, ːsex〳GROUP1, ːFloat, ːBigInt, ːDateTime, ːInt] = [
    'id〳COUNT',
    'User',
    'Str',
    'Date',
    'turnover',
    'Bool',
    'ID_Int_Seq',
    'numEmployees',
    'sex〳GROUP1',
    'Float',
    'BigInt',
    'DateTime',
    'Int' //auto_sugar
  ];

  qq = function(f) {
    return console.log(match(/return (.*);/, f.toString())[1], f());
  };

  qqq = function(...args) {
    return console.log(...args);
  };

  _ = function(...xs) {
    return xs;
  };

  ({eq, deepEq, fdeepEq, throws, ffit} = RE = require('testhelp')); // auto_require: testhelp

  ({createModel, parseArguments} = mode = require('./model'));

  // model = require './testModel'
  _ = function(...xs) {
    return xs;
  };

  // TODO: Gör om full till att använda testModel ist?
  describe('model', function() {
    console.log(111111111222222222222223333333333333);
    // NOTE: if testModel throws before you can run createModel tests below,
    // add a -> before createModel in testModel and use .only below
    return describe('createModel', function() {
      console.log('NOTE: add a -> before createModel in testModel and use .only below');
      it('unknown field type', function() {
        return throws(/unknown field type/, function() {
          return createModel({
            User: {
              id: 1
            }
          });
        });
      });
      it('field types', function() {
        var res;
        res = createModel({
          User: {
            id: ːID_Int_Seq,
            name: ːStr,
            gpa: ːFloat,
            single: ːBool,
            dob: ːDateTime,
            favouriteHoliday: ːDate
          }
        });
        return deepEq({
          entity: ːUser,
          fields: {
            id: ːID_Int_Seq,
            name: ːStr,
            gpa: ːFloat,
            single: ːBool,
            dob: ːDateTime,
            favouriteHoliday: ːDate
          },
          rels: {},
          subs: {}
        }, res.User);
      });
      it('lower', function() {
        return throws(/must begin with upper/, function() {
          return createModel({
            user: {
              id: ːInt
            }
          });
        });
      });
      it('invalid relation', function() {
        return throws(/invalid rela/, function() {
          return createModel({
            User: {
              id: {
                oneToMany: 1
              }
            }
          });
        });
      });
      it('invalid link 1', function() {
        var model;
        model = {
          User: {
            id: ːStr,
            bff: {
              oneToOne: 'UserX.bff = User.what'
            }
          }
        };
        return throws(/invalid link/, function() {
          return createModel(model);
        });
      });
      it('invalid link 2', function() {
        var model;
        model = {
          User: {
            id: ːStr,
            bff: {
              oneToOne: 'UserX.bff = User.what'
            }
          }
        };
        return throws(/invalid link/, function() {
          return createModel(model);
        });
      });
      it('invalid link 3', function() {
        var model;
        model = {
          User: {
            id: ːStr,
            favoriteCourse: {
              oneToOne: 'Course.id = User.courseId'
            }
          },
          Course: {
            id: ːStr
          }
        };
        return throws(/first entity/, function() {
          return createModel(model);
        });
      });
      it('invalid link 4', function() {
        var model;
        model = {
          User: {
            id: ːStr,
            bff: {
              oneToOne: 'User.bff = User.what'
            }
          }
        };
        return throws(/same name as rela/, function() {
          return createModel(model);
        });
      });
      it('linking fields 1', function() {
        var model, res;
        model = {
          User: {
            id: ːStr,
            bff: {
              oneToOne: 'User.bffId = User.id'
            }
          }
        };
        res = createModel(model);
        eq(res.User.fields.bffId, ːStr);
        return fdeepEq(res.User.rels.bff, {
          multiplicity: 'oneToOne',
          entity: 'User',
          on: ['bffId', 'id'],
          isRel: true,
          notNull: true
        });
      });
      it('linking fields 2', function() {
        var model, res;
        model = {
          User: {
            id: ːStr
          },
          Course: {
            id: ːStr,
            usersFavorite: {
              manyToOne: 'Course.id = User.courseId'
            }
          }
        };
        res = createModel(model);
        return eq(res.User.fields.courseId, ːStr);
      });
      it('linking fields big', function() {
        var model, res;
        model = {
          User: {
            id: ːID_Int_Seq,
            name: ːStr,
            favoriteCourse: {
              oneToOne: 'User.favoriteCourseId = Course.id'
            },
            didFail: {
              oneToMany: 'User.id = FailedCourse.userId'
            },
            bff: {
              oneToOne: 'User.bffId = User.id'
            }
          },
          FailedCourse: {
            id: ːID_Int_Seq,
            userId: ːInt,
            courseId: ːInt,
            attempts: ːInt
          },
          Course: {
            id: ːID_Int_Seq,
            name: ːStr,
            teacher: {
              oneToOne: 'Course.teacherId = User.id'
            }
          }
        };
        res = createModel(model);
        return ffit(res.User, {
          rels: {
            favoriteCourse: {
              entity: 'Course'
            },
            didFail: {
              entity: 'FailedCourse'
            },
            bff: {
              entity: 'User'
            }
          },
          fields: {
            bffId: ːInt
          }
        });
      });
      it('linking fields 3', function() {
        var model, res;
        model = {
          User: {
            id: ːID_Int_Seq,
            bff: {
              oneToOne: 'User.bffId = User.id'
            }
          }
        };
        res = createModel(model);
        return eq(res.User.fields.bffId, ːInt);
      });
      it('config', function() {
        var model, res;
        model = {
          User: {
            id: ːID_Int_Seq
          },
          Auth: {
            id: ːID_Int_Seq
          },
          $config: {
            entityToTable: 'pascalToSnake',
            propToCol: 'camelToSnake',
            forAll: function(k) {
              if (k === 'User') {
                return {
                  createdAt: ːDate,
                  updatedAt: ːDate
                };
              } else {
                return {};
              }
            }
          }
        };
        res = createModel(model);
        eq(type(res.$config.entityToTable), 'Function');
        eq(type(res.$config.propToCol), 'Function');
        eq(res.$config.forAll, model.$config.forAll);
        eq(res.User.fields.createdAt, ːDate);
        return eq(false, has('createdAt', res.Auth.fields));
      });
      describe('case conversions', function() {
        it('_snakeToCamel', function() {
          return eq('helloWorldHowAreYou', mode._snakeToCamel('hello_world_how_are_you'));
        });
        it('_camelToSnake', function() {
          return eq('hello_world_how_are_you', mode._camelToSnake('helloWorldHowAreYou'));
        });
        it('_snakeToPascal', function() {
          return eq('HelloWorldHowAreYou', mode._snakeToPascal('hello_world_how_are_you'));
        });
        return it('_pascalToSnake', function() {
          return eq('hello_world_how_are_you', mode._pascalToSnake('HelloWorldHowAreYou'));
        });
      });
      return describe('subqueries', function() {
        // it 'invalid subquery', ->
        // 	model =
        // 		Company:
        // 			id: ːID_Int_Seq
        // 			employees: {oneToMany〳: 'Company.id = Employment.companyId'}
        // 			femaleEmployees: {employees: _ {positXion: 'F'}}

        // 		Employment:
        // 			id: ːID_Int_Seq
        // 			company: {manyToOne: 'Employment.companyId = Company.id'}

        // 	throws /for subquery/, -> createModel model
        return it('full', function() {
          var model, res;
          model = {
            Employment: {
              id: ːID_Int_Seq,
              person: {
                oneToOne: 'Employment.personId = Person.id'
              },
              company: {
                manyToOne: 'Employment.companyId = Company.id'
              },
              position: ːStr,
              salary: ːInt
            },
            Person: {
              id: ːID_Int_Seq,
              name: ːStr,
              sex: ːStr,
              position: ːStr
            },
            Company: {
              id: ːID_Int_Seq,
              name: ːStr,
              turnover: ːBigInt,
              employees: {
                oneToMany〳: 'Company.id = Employment.companyId'
              },
              managers: {
                employees: _({
                  position: 'Manager'
                })
              },
              numEmployees: {
                employees: _({ːid〳COUNT}) // 0
              },
              // femaleEmployees: {employees: _ {position: 'F'}} # 0
              // femaleEmployeesWithHighSalary: {femaleEmployees: _ {salary: {gt: 100000}}} # 0
              // numFemaleEmployees: {femaleEmployees: _ {ːid〳COUNT}} # 0
              importantEmployees: function({turnover, numEmployees}) { // 1
                return {
                  employees: _({
                    salary: {
                      gt: turnover
                    }
                  })
                };
              },
              hoursByManagers: function({
                  managers: {personId}
                }) {
                return {
                  Person: _({
                    ːid〳COUNT: {
                      in: personId
                    },
                    ːsex〳GROUP1
                  })
                };
              }
            }
          };
          // importantFemaleEmployees: {importantEmployees: _ {position: 'F'}} # 0
          // importantFemaleEmployeesWithHighSalary: {importantFemaleEmployees: _ {salary: {gt: 100000}}} # 0

          // importantEmployees:
          // 	returns: 'Employee'
          // 	f: ({turnover, numEmployees}) ->
          // 		avgEmpTurnover = turnover / numEmployees
          // 		{employees: _ {salary: {gt: avgEmpTurnover}}}

          // importantEmployees: _ 'Employee', ({turnover, numEmployees}) ->
          // 	avgEmpTurnover = turnover / numEmployees
          // 	{employees: _ {salary: {gt: avgEmpTurnover}}}

          // turnoverPerEmployee: ({turnover, numEmployees}) -> # 1
          // 	turnover / numEmployees

          // numImportantEmployees: {importantEmployees: _ {ːid〳COUNT}} # 1

          // betterCompanies: ({turnoverPerEmployee}) -> # 2
          // 	{Company: _ {turnoverPerEmployee: {gt: turnoverPerEmployee}}}

          // numBetterCompaniesStupid: ({betterCompanies}) -> # 3
          // 	length betterCompanies

          // numBetterCompanies: {betterCompanies: _ {ːid〳COUNT}} # 2
          res = createModel(model);
          // console.log '#########'
          // qqq 'END RESULT', res
          return eq(1, 1);
        });
      });
    });
  });

  // fdeepEq res.Company.subs.femaleEmployeesWithHighSalary,
// 	isSub: true
// 	isAgg: false
// 	subType: 'object'
// 	# order: 1
// 	rel: 'employees'
// 	compoundWhere: {AND: [{salary: {gt: 100000}}, {position: 'F'}]}
// 	original: {femaleEmployees: _ {salary: {gt: 100000}}}

// fdeepEq res.Company.subs.numFemaleEmployees,
// 	isSub: true
// 	isAgg: true
// 	subType: 'object'
// 	# order: 2
// 	rel: 'employees'
// 	compoundWhere: {position: 'F'}
// 	original: {femaleEmployees: _ {ːid〳COUNT}}

// fdeepEq res.Company.subs.turnoverPerEmployee,
// 	isSub: true
// 	isAgg: false
// 	subType: 'object'
// 	# order: 1
// 	parentDeps: [ːturnover]
// 	siblingDeps: [ːnumEmployees]

// fdeepEq res.Company.subs.numImportantEmployees,
// 	isSub: true
// 	isAgg: true
// 	# order: 2
// 	siblingDeps: ['importantEmployees']
// 	subType: 'object-function'
// 	compoundWhere: {}
// 	original: {importantEmployees: _ {ːid〳COUNT}}

}).call(this);
