// Generated by CoffeeScript 2.4.1
(function() {
  var AND, RE, _, dataQueryToPaths, deepEq, dots, empty, ensureQuery, ensureQueryMap, eq, fdeepEq, feq, i, isQueryNilOrEmpty, length, model, num, parseArguments, path, queryToString, ref, sql, subSelect, test, throws, toDataQuery, values, ːa, ːa1, ːaa1, ːaa2, ːab1, ːactivity, ːb, ːb2, ːdate, ːgroup, ːid, ːname, ːuserId;

  empty = require('ramda/src/empty');

  length = require('ramda/src/length');

  path = require('ramda/src/path');

  test = require('ramda/src/test');

  values = require('ramda/src/values');

  ({} = RE = require('ramda-extras')); // auto_require: ramda-extras

  [ːgroup, ːb, ːname, ːid, ːdate, ːaa1, ːaa2, ːb2, ːab1, ːuserId, ːa1, ːactivity, ːa] = [
    'group',
    'b',
    'name',
    'id',
    'date',
    'aa1',
    'aa2',
    'b2',
    'ab1',
    'userId',
    'a1',
    'activity',
    'a' //auto_sugar
  ];

  ({eq, feq, deepEq, fdeepEq, throws} = RE = require('testhelp')); // auto_require: testhelp

  model = require('./testModel');

  ({AND, parseArguments, toDataQuery, subSelect, queryToString, dataQueryToPaths, isQueryNilOrEmpty, ensureQuery, ensureQueryMap} = require('./utils'));

  sql = require('./sql')(model);

  // todo: move to test help?
  console.clear();

  console.log((new Date).toISOString());

  dots = '';

  for (num = i = 0, ref = Date.now() % 50; (0 <= ref ? i <= ref : i >= ref); num = 0 <= ref ? ++i : --i) {
    dots += '.';
  }

  console.log(dots);

  console.log(dots);

  console.log(dots);

  _ = function(...xs) {
    return xs;
  };

  describe('utils', function() {
    describe('AND', function() {
      it('empty', function() {
        deepEq({
          a: 1
        }, AND({
          a: 1
        }, {}));
        deepEq({
          a: 2
        }, AND({}, {
          a: 2
        }));
        return deepEq({}, AND({}, {}));
      });
      it('undefined', function() {
        deepEq({
          a: 1
        }, AND({
          a: 1
        }, void 0));
        deepEq({
          a: 2
        }, AND(void 0, {
          a: 2
        }));
        return deepEq({}, AND(void 0, void 0));
      });
      it('1', function() {
        var res;
        res = AND({
          a: {
            neq: 1
          }
        }, {
          a: {
            neq: 2
          }
        });
        return fdeepEq(res, {
          AND: [
            {
              a: {
                neq: 1
              }
            },
            {
              a: {
                neq: 2
              }
            }
          ]
        });
      });
      it('2', function() {
        var res;
        res = AND({
          a: 1
        }, {
          b: {
            in: [1, 2]
          }
        });
        return fdeepEq(res, {
          a: 1,
          b: {
            in: [1, 2]
          }
        });
      });
      it('3', function() {
        var res;
        res = AND({
          a: {
            lt: 1
          }
        }, {
          a: {
            gt: 2
          }
        });
        return fdeepEq(res, {
          a: {
            lt: 1,
            gt: 2
          }
        });
      });
      it('4', function() {
        var res;
        res = AND({
          a: 1
        }, {
          a: {
            gt: 2
          }
        });
        return fdeepEq(res, {
          a: {
            eq: 1,
            gt: 2
          }
        });
      });
      it('5', function() {
        var res;
        res = AND({
          OR: [
            {
              a: 1
            },
            {
              b: 2
            }
          ]
        }, {
          a: {
            gt: 2
          }
        });
        return fdeepEq(res, {
          AND: [
            {
              OR: [
                {
                  a: 1
                },
                {
                  b: 2
                }
              ]
            },
            {
              a: {
                gt: 2
              }
            }
          ]
        });
      });
      it('6', function() {
        var res;
        res = AND({
          AND: [
            {
              a: {
                lt: 4
              }
            },
            {
              b: 2
            }
          ]
        }, {
          a: {
            gt: 2
          }
        });
        return fdeepEq(res, {
          AND: [
            {
              AND: [
                {
                  a: {
                    lt: 4
                  }
                },
                {
                  b: 2
                }
              ]
            },
            {
              a: {
                gt: 2
              }
            }
          ]
        });
      });
      return it('aggs', function() {
        return throws(/not yet supported/, function() {
          return AND({
            a: 1
          }, {
            b〳COUNT: 1
          });
        });
      });
    });
    describe('parseArguments', function() {
      it('null', function() {
        var res;
        res = parseArguments(null);
        return deepEq([{}], res);
      });
      it('empty', function() {
        var res;
        res = parseArguments('');
        return deepEq([{}], res);
      });
      it('empty no', function() {
        var res;
        res = parseArguments('function () { ...');
        return deepEq([{}], res);
      });
      it('1', function() {
        var res;
        res = parseArguments('function ({a, b}) { ...');
        return deepEq([
          {
            a: null,
            b: null
          }
        ], res);
      });
      it('2', function() {
        var res;
        res = parseArguments('function ({a, b: {b1, b2}, c, d: {d1}}) { ...');
        return deepEq([
          {
            a: null,
            b: {
              b1: null,
              b2: null
            },
            c: null,
            d: {
              d1: null
            }
          }
        ], res);
      });
      it('3', function() {
        var res;
        res = parseArguments("function({\n	a: {a1},\n	b\n}) { ...");
        return deepEq([
          {
            a: {
              a1: null
            },
            b: null
          }
        ], res);
      });
      it('4', function() {
        var res;
        res = parseArguments('function ({a, b: {b1}}, d, {a: {a1}, c}) { ...');
        return deepEq([
          {
            a: null,
            b: {
              b1: null
            }
          },
          {
            d: null
          },
          {
            a: {
              a1: null
            },
            c: null
          }
        ], res);
      });
      return it('5', function() {
        var res;
        res = parseArguments("function({\n    a: {a1}\n  }) {\n  (function() {\n    switch (path0) {\n  ");
        return deepEq([
          {
            a: {
              a1: null
            }
          }
        ], res);
      });
    });
    describe('toDataQuery', function() {
      it('undefined', function() {
        var query;
        query = {
          a: _({ːa1}, {
            aa: void 0
          })
        };
        return throws(/is nil/, function() {
          return toDataQuery(query);
        });
      });
      it('not array', function() {
        var query;
        query = {
          a: _({}, {
            aa: {ːaa1}
          })
        };
        return throws(/body is not Array/, function() {
          return toDataQuery(query);
        });
      });
      it('no fields', function() {
        var query;
        query = {
          a: _({}, {
            aa: _({ːaa1})
          })
        };
        return deepEq({
          a: {
            aa: {
              aa1: null
            }
          }
        }, toDataQuery(query));
      });
      it('1', function() {
        var expected, query, res;
        query = {
          a: _({ːa1}, {
            aa: _({ːaa1, ːaa2}),
            ab: _({ːab1})
          }),
          b: _({ːb2})
        };
        expected = {
          a: {
            a1: null,
            aa: {
              aa1: null,
              aa2: null
            },
            ab: {
              ab1: null
            }
          },
          b: {
            b2: null
          }
        };
        res = toDataQuery(query);
        return deepEq(expected, res);
      });
      return it('test', function() {
        var query;
        query = {
          Data: _({}, {
            me: _({ːid}),
            group: _({}, {
              workouts: _({ːdate, ːuserId, ːactivity})
            }),
            activities: _({ːid, ːname}),
            url: _({ːgroup, ːdate})
          })
        };
        toDataQuery(query);
        return eq(1, 1);
      });
    });
    describe('dataQueryToPaths', function() {
      return it('1', function() {
        var res;
        res = dataQueryToPaths({
          a: {
            a1: {
              a11: null,
              a12: null
            },
            a2: null
          },
          b: null
        });
        return fdeepEq(res, [['a', 'a1', 'a11'], ['a', 'a1', 'a12'], ['a', 'a2'], ['b']]);
      });
    });
    describe('subSelect', function() {
      it('data is nil', function() {
        var res;
        res = subSelect({
          a: {
            a1: null
          }
        }, null);
        return deepEq([[['a']], null], res);
      });
      it('missing key', function() {
        var res;
        res = subSelect({
          a: {
            a1: null
          }
        }, {});
        return deepEq([
          [['a']],
          {
            a: null
          }
        ], res);
      });
      it('missing key in object', function() {
        var res;
        res = subSelect({
          a: {
            a1: null,
            a2: null
          }
        }, {
          a: {
            a2: 1
          }
        });
        return deepEq([
          [['a',
          'a1']],
          {
            a: {
              a1: null,
              a2: 1
            }
          }
        ], res);
      });
      it('missing key in array', function() {
        var res;
        res = subSelect({
          a: {
            a1: null,
            a2: null
          }
        }, {
          a: [
            {
              a2: 1
            }
          ]
        });
        return deepEq([
          [['a',
          'a1']],
          {
            a: [
              {
                a1: null,
                a2: 1
              }
            ]
          }
        ], res);
      });
      // it 'missing key in array 2', ->
      // 	res = subSelect {a: {a1: null}, {a: [{a1: 1, a2: 1}]}
      // 	deepEq [[['a', 'a1']], {a: [{a1: null, a2: 1}]}], res
      it('undefined in data', function() {
        var res;
        res = subSelect({
          a: {
            a1: null,
            a2: null
          }
        }, {
          a: [
            {
              a1: void 0,
              a2: 1
            }
          ]
        });
        return deepEq([
          [['a',
          'a1']],
          {
            a: [
              {
                a1: null,
                a2: 1
              }
            ]
          }
        ], res);
      });
      it('null in array', function() {
        var res;
        res = subSelect({
          a: {
            a1: null,
            a2: null
          }
        }, {
          a: [
            {
              a1: null,
              a2: 1
            }
          ]
        });
        return deepEq([
          [],
          {
            a: [
              {
                a1: null,
                a2: 1
              }
            ]
          }
        ], res);
      });
      it('missing optional key in object', function() {
        var res;
        res = subSelect({
          a: {
            a1〳: null
          }
        }, {
          a: {
            a2: 1
          }
        });
        return deepEq([
          [],
          {
            a: {
              a1: null
            }
          }
        ], res);
      });
      it('missing optional key in array', function() {
        var res;
        res = subSelect({
          a: {
            a1〳: null
          }
        }, {
          a: [
            {
              a2: 1
            },
            {
              a1: 1
            }
          ]
        });
        return deepEq([
          [],
          {
            a: [
              {
                a1: null
              },
              {
                a1: 1
              }
            ]
          }
        ], res);
      });
      it('missing optional item in array', function() {
        var res;
        res = subSelect({
          a〳: {
            a1: null
          }
        }, {
          a: [
            {
              a1: 1
            },
            null
          ]
        });
        return deepEq([
          [],
          {
            a: [
              {
                a1: 1
              },
              null
            ]
          }
        ], res);
      });
      it('missing key in optional item in array', function() {
        var res;
        res = subSelect({
          a〳: {
            a1: null
          }
        }, {
          a: [
            {
              a1: 1
            },
            {
              a2: 2
            }
          ]
        });
        return deepEq([
          [['a',
          'a1']],
          {
            a: [
              {
                a1: 1
              },
              {
                a1: null
              }
            ]
          }
        ], res);
      });
      it('missing optional key in optional item in array', function() {
        var res;
        res = subSelect({
          a〳: {
            a1〳: null
          }
        }, {
          a: [
            {
              a1: 1
            },
            {
              a2: 2
            }
          ]
        });
        return deepEq([
          [],
          {
            a: [
              {
                a1: 1
              },
              {
                a1: null
              }
            ]
          }
        ], res);
      });
      it('missing optional array', function() {
        var res;
        res = subSelect({
          a〳: {
            a1: null
          }
        }, {
          a: null
        });
        return deepEq([
          [],
          {
            a: null
          }
        ], res);
      });
      it('array with values', function() {
        var res;
        res = subSelect({
          a: {
            a1: null
          }
        }, {
          a: {
            a1: [1, 2, 3]
          }
        });
        return deepEq([
          [],
          {
            a: {
              a1: [1,
          2,
          3]
            }
          }
        ], res);
      });
      it('1', function() {
        var data, expected, query, res;
        query = {
          a: {
            a1: null,
            aa: {
              aa1: null
            },
            ab: {
              ab1: null
            }
          },
          b: {
            b1: null
          }
        };
        data = {
          a: {
            a1: 1,
            aa: {
              aa1: 1
            },
            ab: [
              {
                ab1: 1
              },
              {
                ab1: 2
              }
            ]
          },
          b: {
            b1: 1,
            b2: 1
          }
        };
        res = subSelect(query, data);
        expected = {
          a: {
            a1: 1,
            aa: {
              aa1: 1
            },
            ab: [
              {
                ab1: 1
              },
              {
                ab1: 2
              }
            ]
          },
          b: {
            b1: 1
          }
        };
        return deepEq([[], expected], res);
      });
      return it('no fields for array and object', function() {
        var data, expected, query, res;
        query = {
          a: null,
          b: null
        };
        data = {
          a: [
            {
              a1: 1,
              a2: 1
            },
            {
              a1: 2,
              a2: 2
            }
          ],
          b: {
            a1: 1,
            a2: 1
          }
        };
        res = subSelect(query, data);
        expected = {
          a: [{}, {}],
          b: {}
        };
        return deepEq([[], expected], res);
      });
    });
    // describe.only 'subSelectMissing', ->
    // 	it 'data is nil', ->
    // 		res = subSelectMissing {a: {a1: null}}, null
    // 		deepEq {a: null}, res
    describe('queryToString', function() {
      it('empty', function() {
        var query;
        query = {};
        return feq(queryToString(query), "{}");
      });
      return it('1', function() {
        var query;
        query = {
          Test: _({
            a: void 0,
            ːb,
            c: 's'
          }, {
            child: _({
              a: {
                gt: 2
              },
              ːb
            }, {
              grandChild: _({
                a: {
                  gt: 2
                },
                ːb
              })
            }),
            child2: _({ːa, ːb}),
            child3: null
          })
        };
        return feq(queryToString(query), "Test: _ {a: undefined, ːb, c: 's'},\n  child: _ {a: {gt: 2}, ːb},\n    grandChild: _ {a: {gt: 2}, ːb}\n  child2: _ {ːa, ːb}\n  child3: null");
      });
    });
    describe('ensureQuery ', function() {
      it('0', function() {
        return throws(/nil/, function() {
          return ensureQuery(null);
        });
      });
      it('0.1', function() {
        return eq(void 0, ensureQuery({}));
      });
      it('0.2', function() {
        return throws(/must be object/, function() {
          return ensureQuery([1]);
        });
      });
      it('1', function() {
        return eq(void 0, ensureQuery({
          Customer: _({}, {
            address: _({ːid})
          })
        }));
      });
      it('2', function() {
        return eq(void 0, ensureQuery({
          Customer: _({}, {})
        }));
      });
      it('3', function() {
        return throws(/body is not array/, function() {
          return ensureQuery({
            Customer: {}
          }, {
            address: _({ːid})
          });
        });
      });
      it('4', function() {
        return throws(/length 1 or 2/, function() {
          return ensureQuery({
            Customer: _({}, {
              address: _({ːid})
            }, {
              city: _({ːid})
            })
          });
        });
      });
      return it('5', function() {
        return throws(/1 and only 1 key/, function() {
          return ensureQuery({
            Customer: _({ːid}),
            Task: _({ːid})
          });
        });
      });
    });
    return describe('ensureQueryMap ', function() {
      it('0', function() {
        return throws(/nil/, function() {
          return ensureQueryMap(null);
        });
      });
      it('0.1', function() {
        return eq(void 0, ensureQueryMap({}));
      });
      it('0.2', function() {
        return throws(/must be object/, function() {
          return ensureQueryMap([1]);
        });
      });
      it('1', function() {
        return eq(void 0, ensureQueryMap({
          customer: {
            Customer: _({}, {
              address: _({ːid})
            })
          }
        }));
      });
      return it('2', function() {
        return eq(void 0, ensureQueryMap({
          customer: {
            Customer: _({}, {})
          },
          task: {
            Task: _({}, {})
          }
        }));
      });
    });
  });

  // describe 'isQueryNilOrEmpty', ->
// 	describe 'query', ->
// 		it '1', -> eq false, isQueryNilOrEmpty Customer: _ {ːid}
// 		it '2', -> eq false, isQueryNilOrEmpty Customer: _ {}, {address: _ {ːid}}
// 		it '3', -> eq true, isQueryNilOrEmpty Customer: _ {}, {address: _ {}}
// 		it '4', -> eq false, isQueryNilOrEmpty Customer: _ {}

}).call(this);
