// Generated by CoffeeScript 2.4.1
(function() {
  var $, $$, AND, DQE, DataQueryError, NYIE, NotYetImplementedError, PVE, PopsiqlValidationError, RE, _, _safeToString, _splitArgs, _subSelect, _toJson, _validateBody, _validateChildQuery, _validatePropQuery, _validateQuery, _validateQueryMap, any, clone, contains, customError, dataQueryToPaths, ensureDataQuery, ensureDataQueryMap, ensureQuery, ensureQueryMap, filter, fromPairs, has, head, intersection, isDataQuery, isDataQueryMap, isEmpty, isNil, isNilOrEmpty, isQuery, isQueryMap, isQueryNilOrEmpty, join, keys, length, map, match, merge, parseArguments, parseArgumentsOLD, prepend, qq, qqq, queryToString, reject, repeat, replace, sf0, split, subSelect, test, toDataQuery, trim, type, union, values, ːArray, ːObject, ːa1, ːaa1, ːid, ːname;

  any = require('ramda/src/any');

  clone = require('ramda/src/clone');

  contains = require('ramda/src/contains');

  filter = require('ramda/src/filter');

  fromPairs = require('ramda/src/fromPairs');

  has = require('ramda/src/has');

  head = require('ramda/src/head');

  intersection = require('ramda/src/intersection');

  isEmpty = require('ramda/src/isEmpty');

  isNil = require('ramda/src/isNil');

  join = require('ramda/src/join');

  keys = require('ramda/src/keys');

  length = require('ramda/src/length');

  map = require('ramda/src/map');

  match = require('ramda/src/match');

  merge = require('ramda/src/merge');

  prepend = require('ramda/src/prepend');

  reject = require('ramda/src/reject');

  repeat = require('ramda/src/repeat');

  replace = require('ramda/src/replace');

  split = require('ramda/src/split');

  test = require('ramda/src/test');

  trim = require('ramda/src/trim');

  type = require('ramda/src/type');

  union = require('ramda/src/union');

  values = require('ramda/src/values');

  ({$, $$, isNilOrEmpty, sf0, customError} = RE = require('ramda-extras')); //auto_require: ramda-extras

  [ːObject, ːid, ːname, ːArray, ːaa1, ːa1] = [
    'Object',
    'id',
    'name',
    'Array',
    'aa1',
    'a1' //auto_sugar
  ];

  qq = function(f) {
    return console.log(match(/return (.*);/, f.toString())[1], f());
  };

  qqq = function(...args) {
    return console.log(...args);
  };

  _ = function(...xs) {
    return xs;
  };

  customError = function(name, staticMsg) {
    var CustomError;
    return CustomError = class CustomError extends Error {
      constructor(msg) {
        if (staticMsg) {
          super(staticMsg);
        } else {
          super(msg);
        }
        this.name = name;
        Error.captureStackTrace(this, CustomError);
      }

    };
  };

  PopsiqlValidationError = class PopsiqlValidationError extends Error {
    constructor(query, msg) {
      if (type(query) === 'String') {
        super(query);
      } else {
        super(msg + `. Your query:\n${queryToString(query)}`);
      }
      this.name = 'PopsiqlValidationError';
      Error.captureStackTrace(this, PopsiqlValidationError);
    }

  };

  PVE = PopsiqlValidationError;

  DataQueryError = class DataQueryError extends Error {
    constructor(query, msg) {
      if (type(query) === 'String') {
        super(query);
      } else {
        super(msg + `. Your data-query:\n${queryToString(query)}\n`);
      }
      this.name = 'DataQueryError';
      Error.captureStackTrace(this, DataQueryError);
    }

  };

  DQE = DataQueryError;

  NYIE = NotYetImplementedError = customError('NotYetImplementedError', 'Not yet implemented!');

  // Array shorthand
  _ = function(...xs) {
    return xs;
  };

  // ({a: {gt: 2}}, {a: {lt: 5}} -> {a: {gt: 2, lt: 5}}
  // Combines a left and right where object and simplifies possible ANDs
  // Note: only pure where objects, no fieldsClauses
  AND = function(_left, _right) {
    var bothKeys, j, k, left, len, res, right;
    if ($(_left, keys, any(test(/〳/))) || $(_right, keys, any(test(/〳/)))) {
      throw new PVE("aggregations not yet supported");
    }
    if (isNilOrEmpty(_left) && isNilOrEmpty(_right)) {
      return {};
    } else if (isNilOrEmpty(_left)) {
      return _right;
    } else if (isNilOrEmpty(_right)) {
      return _left;
    } else if (_left.OR || _right.OR) {
      return {
        AND: [_left, _right]
      };
    // We're assuming AND was used to create _left and _right so if either contains AND: we're assuming it
    // cannot be more simplified and bailing out and not trying to simplify any further
    } else if (_left.AND || _right.AND) {
      return {
        AND: [_left, _right]
      };
    }
    left = clone(_left);
    right = clone(_right);
    res = {};
    bothKeys = union(keys(left), keys(right));
    for (j = 0, len = bothKeys.length; j < len; j++) {
      k = bothKeys[j];
      if (has(k, left) && has(k, right)) {
        if (type(left[k]) !== ːObject) {
          left[k] = {
            eq: left[k]
          };
        }
        if (type(right[k]) !== ːObject) {
          right[k] = {
            eq: right[k]
          };
        }
        if (isEmpty(intersection(keys(left[k]), keys(right[k])))) {
          res[k] = merge(left[k], right[k]);
        } else {
          return {
            AND: [left, right]
          };
        }
      } else if (has(k, left)) {
        res[k] = left[k];
      } else {
        res[k] = right[k];
      }
    }
    return res;
  };

  // It's hard with regexp to split on comma (,) because they can be nested in curlys,
  // so this is a simple loop that keeps track and splits.
  _splitArgs = function(s) {
    var c, curlCount, j, len, res;
    res = '';
    curlCount = 0;
    for (j = 0, len = s.length; j < len; j++) {
      c = s[j];
      if (c === '{') {
        curlCount++;
      } else if (c === '}') {
        curlCount--;
      }
      if (c === ',' && curlCount === 0) {
        res += '~';
      } else {
        res += c;
      }
    }
    return split('~', res);
  };

  // The idea here is to convert a destructuring string to valid json like a data-query
  _toJson = function(s) {
    var VAR;
    if (!test(/\{/g, s)) {
      return `{"${s}": null}`;
    }
    // https://stackoverflow.com/a/1661249/416797
    VAR = '[a-zA-Z_$][0-9a-zA-Z_$]*';
    RE = function(s) {
      return new RegExp(replace(/VAR/g, VAR, s), 'g');
    };
    return $(s, replace(RE('(VAR),'), '"$1": null,'), replace(RE('(VAR)}'), '"$1": null}'), replace(RE('(VAR):'), '"$1":'));
  };

  // Returns a dataQuery given a function.toString() result
  parseArguments = function(fnStr) {
    var ___, fnStrʹ, json, s;
    if (isNil(fnStr)) {
      return [{}];
    }
    fnStrʹ = replace(/\n\s*/g, '', fnStr);
    [___, s] = match(new RegExp(/function\s?\((.*?)\) {/), fnStrʹ);
    if (isNilOrEmpty(s)) {
      return [{}];
    }
    json = $(s, replace(/\s/g, ''), _splitArgs, map(_toJson), join(','), function(x) {
      return `[${x}]`;
    });
    return JSON.parse(json);
  };

  // Returns a dataQuery given a function.toString() result
  parseArgumentsOLD = function(fnStr) {
    var ___, _complex, c, complex, curlys, fnStrʹ, i, j, k, l, len, len1, s, simples, ss, sʹ, ts;
    if (isNil(fnStr)) {
      return {};
    }
    fnStrʹ = replace(/\n\s*/g, '', fnStr);
    [___, s] = match(new RegExp(/function\s?\((.*?)\) {/), fnStrʹ);
    if (isNil(s)) {
      return {};
    }
    curlys = match(new RegExp(/\{(.*?)\}/g), s);
    qq(2, curlys);
    // temporary replace  curlys
    sʹ = s;
    i = 0;
    for (j = 0, len = curlys.length; j < len; j++) {
      c = curlys[j];
      sʹ = $(sʹ, replace(c, `__CURLY__${i++}`));
    }
    qq(1, sʹ);
    ss = split(',', sʹ);
    // simples = arg without destructuring
    simples = $(ss, map(trim), reject(test(/__CURLY__/)), map(function(x) {
      return [x, null];
    }), fromPairs);
    _complex = $(ss, map(trim), filter(test(/__CURLY__/)));
    qq(3, _complex);
    complex = {};
    i = 0;
    for (l = 0, len1 = _complex.length; l < len1; l++) {
      c = _complex[l];
      [___, k] = match(/^(.*?):/, c);
      ts = $(curlys[i++], replace(/^\{/, ''), replace(/\}$/, ''), split(','), map(trim));
      complex[k] = $$(ts, fromPairs, map(function(x) {
        return [x, null];
      }));
    }
    return merge(simples, complex);
  };

  // query						Client: _ {ːid},
  //										address: _ {ːid}
  // query key				Client:
  // query body			_ {ːid},
  //										address: _ {ːid}
  // propQuery				{ːid, ːname}
  // childQuery			address: _ {ːid}
  // queryMap				clients: Client: _ {ːid}
  // dataQuery				Client: {id: null, address: {id: null}}
  // dataQueryMap		clients: Client: {id: null, address: {id: null}}
  isQuery = function(q) {
    return _validateQuery(q) === null;
  };

  ensureQuery = function(q) {
    if (_validateQuery(q) !== null) {
      throw new Error(_validateQuery(q));
    }
  };

  isQueryMap = function(qm) {
    return _validateQueryMap(qm) === null;
  };

  ensureQueryMap = function(qm) {
    if (_validateQueryMap(qm) !== null) {
      throw new Error(_validateQueryMap(qm));
    }
  };

  isDataQuery = function(dq) {
    throw new Error('NYI');
  };

  ensureDataQuery = function(dq) {
    throw new Error('NYI');
  };

  isDataQueryMap = function(dqm) {
    throw new Error('NYI');
  };

  ensureDataQueryMap = function(dqm) {
    throw new Error('NYI');
  };

  _validateQuery = function(q) {
    if (isNil(q)) {
      return `Query cannot be nil: ${sf0(q)}`;
    } else if (type(q) !== ːObject) {
      return `Query must be object: ${sf0(q)}`;
    } else if (isEmpty(q)) {
      return null;
    } else if ($(q, keys, length) !== 1) {
      return `Query must have 1 and only 1 key: ${sf0(q)}`;
    } else {
      return _validateBody(q[$(q, keys, head)], q);
    }
  };

  _validateBody = function(b, q) {
    var childRes, propRes;
    if (type(b) !== ːArray) {
      return `Query body is not array: ${sf0(q)}`;
    } else if ($(b, length) < 1 || $(b, length) > 2) {
      return `Query body must be length 1 or 2: ${sf0(q)}`;
    }
    propRes = _validatePropQuery(b[0], q);
    if (propRes !== null) {
      return propRes;
    }
    if (b[1]) {
      childRes = _validateChildQuery(b[1], q);
      if (childRes !== null) {
        return childRes;
      }
    }
    return null;
  };

  _validatePropQuery = function(p, q) {
    if (type(p) !== ːObject) {
      return `propQuery (first part of body) must be an object: ${sf0(p)}, query: ${sf0(q)}`;
    }
    return null;
  };

  _validateChildQuery = function(c, q) {
    var body, k, res;
    if (type(c) !== ːObject) {
      return `childQuery (second part of body) must be an object: ${sf0(c)}, query: ${sf0(q)}`;
    }
    for (k in c) {
      body = c[k];
      res = _validateBody(body, q);
      if (res !== null) {
        return res;
      }
    }
    return null;
  };

  _validateQueryMap = function(qm) {
    var k, q, res;
    if (isNil(qm)) {
      return `QueryMap cannot be nil: ${sf0(qm)}`;
    } else if (type(qm) !== ːObject) {
      return `Query must be object: ${sf0(qm)}`;
    } else if (isEmpty(qm)) {
      return null;
    }
    for (k in qm) {
      q = qm[k];
      res = _validateQuery(q);
      if (res) {
        return res;
      }
    }
    return null;
  };

  isQueryNilOrEmpty = function(query) {
    var k, q;
    throw new Error('Maybe this function is not needed');
    if (isNilOrEmpty(query)) {
      return true;
    } else if (type(query) === 'Array') {
      if (query.length === 1) {
        return isEmpty(query[0]);
      } else if (query.length === 2) {
        return isEmpty(query[0]) && isEmpty(query[1]);
      } else {
        throw new Error('Invalid popsiql query');
      }
    } else if (type(query) === 'Object') {
      for (k in query) {
        q = query[k];
        if (isQueryNilOrEmpty(q)) {
          return true;
        }
      }
      return false;
    } else {
      throw new Error(`NYI ${JSON.stringify(query)}`);
    }
  };

  // {a: _ {ːa1}, aa: _ {ːaa1}} -> {a: {a1: null, aa: {aa1: null}}}
  // Converts a dataQuery in multi line form and returns a raw dataQuery
  toDataQuery = function(multiLineDataQuery) {
    return $(multiLineDataQuery || {}, map(function(v, k) {
      var attrs, children;
      if (isNil(v)) {
        throw new DQE(multiLineDataQuery, `key ${k} of dataQuery is nil`);
      }
      if (type(v) !== 'Array') {
        throw new DQE(multiLineDataQuery, "body is not Array");
      }
      [attrs, children] = v;
      return {...toDataQuery(children), ...$(attrs, values, map(function(a) {
          return [a, null];
        }), fromPairs)};
    }));
  };

  // {a: {a1: null}} -> [['a', 'a1']]
  // Returns the paths of an argQuery
  dataQueryToPaths = function(dataQuery) {
    var j, k, ks, len, paths, subPaths, v;
    paths = [];
    ks = keys(dataQuery);
    for (j = 0, len = ks.length; j < len; j++) {
      k = ks[j];
      v = dataQuery[k];
      if ('Object' === type(v)) {
        subPaths = $(v, dataQueryToPaths, map(prepend(k)));
        paths.push(...subPaths);
      } else {
        paths.push([k]);
      }
    }
    return paths;
  };

  _safeToString = function(x) {
    if (x === void 0) {
      return 'undefined';
    } else if (x === null) {
      return 'null';
    } else {
      // https://stackoverflow.com/a/11233515/416797
      return $(x, JSON.stringify, replace(/\"([^(\")"]+)\":/g, "$1: "), replace(/"/g, "'"));
    }
  };

  // Returns an easy-to read new-lined string of a popsiql query for debugging
  queryToString = function(query, level = 0) {
    var body, children, fieldClause, fields, indentation, k, key, s, ss, v;
    if (isEmpty(query)) {
      return '{}';
    }
    indentation = level ? $(level * 2, repeat(' '), join('')) : '';
    ss = [];
    for (key in query) {
      body = query[key];
      s = `${indentation}${key}: `;
      if (!body) {
        s += _safeToString(body);
        ss.push(s);
        continue;
      }
      if ('Object' === type(body)) {
        s += '{}';
        continue;
      }
      [fieldClause, children] = body;
      s += "_ {";
      fields = [];
      for (k in fieldClause) {
        v = fieldClause[k];
        if (k === 'ː' + v) {
          fields.push(k);
        } else {
          fields.push(`${k}: ${_safeToString(v)}`);
        }
      }
      s += $(fields, join(', '));
      s += '}';
      if (children) {
        s += ',\n' + queryToString(children, ++level);
      }
      ss.push(s);
    }
    return $(ss, join('\n'));
  };

  // Returns the subset specified by dataQuery from data plus a hasNils flag
  subSelect = function(dataQuery, data) {
    return _subSelect(dataQuery, data, dataQuery);
  };

  _subSelect = function(dataQuery, data, initialQuery) {
    var _k, childMissing, childRes, d, isOptional, itemMissing, itemRes, j, k, len, missing, ref, res, v;
    if (!dataQuery) {
      throw new DQE(initialQuery, `dataQuery argument is mandatory, cannot be: ${dataQuery}`);
    }
    if (isNil(data)) {
      return [
        $(dataQuery,
        keys,
        map(function(k) {
          return [k];
        })),
        null
      ];
    }
    res = {};
    missing = [];
    for (_k in dataQuery) {
      v = dataQuery[_k];
      k = replace(/〳$/, '', _k);
      isOptional = test(/〳$/, _k);
      if (!has(k, data) || data[k] === void 0) {
        res[k] = null;
        if (!isOptional) {
          missing.push([k]);
        }
      } else if (v === null) {
        if ('Array' === type(data[k])) {
          if (contains(type(data[k][0]), ['Number', 'String', 'Boolean'])) {
            res[k] = data[k];
          } else {
            res[k] = $(data[k], map(function() {
              return {};
            }));
          }
        } else if ('Object' === type(data[k])) {
          res[k] = {};
        } else {
          res[k] = data[k];
        }
      } else {
        if ('Array' === type(data[k])) {
          res[k] = [];
          ref = data[k];
          for (j = 0, len = ref.length; j < len; j++) {
            d = ref[j];
            [itemMissing, itemRes] = _subSelect(v, d, initialQuery);
            if (!isEmpty(itemMissing)) {
              if (isOptional) {
                if (itemRes !== null) {
                  missing.push(...map(prepend(k), itemMissing));
                }
              } else {
                missing.push(...map(prepend(k), itemMissing));
              }
            }
            res[k].push(itemRes);
          }
        } else if ('Object' === type(data[k])) {
          [childMissing, childRes] = _subSelect(v, data[k], initialQuery);
          if (!isEmpty(childMissing)) {
            missing.push(...map(prepend(k), childMissing));
          }
          res[k] = childRes;
        } else if (data[k] === null) {
          res[k] = null; // null is not a miss as opposed to missing key or undefined
        } else {
          throw new Error(`not supported ${data[k]} for key '${k}' in dataQuery (should be null or obj) \ndataQuery: ${sf0(dataQuery)}\ndata: ${sf0(data)}`);
        }
      }
    }
    return [missing, res];
  };

  // subSelectMissing = (dataQuery, data) ->
  // 	if !dataQuery then throw new DQE "dataQuery argument is mandatory, cannot be: #{dataQuery}"
  // 	if isNil data then return fmapO dataQuery, -> null
  // 	res = {}
  // 	for _k, v of dataQuery
  // 		k = replace /〳$/, '', _k
  // 		isOptional = test /〳$/, _k
  // 		if !has(k, data) || data[k] == undefined
  // 			if !isOptional then res[k] = null
  // 		else if v == null # no op
  // 		else
  // 			if 'Array' == type data[k]
  // 				arrRes = {}
  // 				for d in data[k]
  // 					itemRes = subSelectMissing v, d
  // 					if itemRes
  // 						arrRes = merge arrRes, itemRes
  // 						if isOptional
  // 							if itemRes != null then isFull = false
  // 						else isFull = false
  // 					res[k].push itemRes
  // 			else if 'Object' == type data[k]
  // 				[childIsFull, childRes] = subSelect v, data[k]
  // 				if !childIsFull then isFull = false
  // 				res[k] = childRes
  // 			else if data[k] == null
  // 				res[k] = null # null is not a miss as opposed to missing key or undefined
  // 			else throw new NYIE

  // 	return [isFull, res]
  module.exports = {customError, PVE, DQE, NYIE, parseArguments, queryToString, AND, _, dataQueryToPaths, subSelect, toDataQuery, isQueryNilOrEmpty, isQuery, isQueryMap, isDataQuery, isDataQueryMap, ensureQuery, ensureQueryMap, ensureDataQuery, ensureDataQueryMap};

}).call(this);
